/*---------------------------------------------------------------------------*/
/*                                                                           */
/* DSHEng4   Equipment GEM Communication Enggine                             */
/*                                                                           */
/*     < dshsyslib.h   >                                                     */
/*                                                                           */
/*  Copyright (c)2009 by Data Map Corp.                                      */
/*---------------------------------------------------------------------------*/
typedef struct{
   ushort wYear;
   ushort wMonth;
   ushort wDayOfWeek;
   ushort wDay;
   ushort wHour;
   ushort wMinute;
   ushort wSecond;
   ushort wMilliseconds;
}SYSTEMTIME;

char    *FormatDateTime( char *buff, char *fmt );
char    *FormatDateTimeExt( char *buff, char *fmt );
char    *FormatDateTimeX( char *buff, char *fmt );
char    *DshFormatDateTimeZ( char *buff, char *fmt, SYSTEMTIME *t );
int     DshSetDateTime( char *tinfo );
void    DshMakeSystemTime( SYSTEMTIME *t );

void    EVT_init( int top_port, int max_evt );
void    EVT_term( void );
int     EVT_create( void );
void    EVT_close( int evtid );
int     EVT_wait( int evtid, int tms );
int     EVT_send( int evtid );
void    EVT_kill( int evtid );

#define  mutex_t pthread_mutex_t

//#ifndef SOLARIS_FLAG
  #define USYNC_PROCESS_ROBUST    NULL
  #define mutex_init( a, b, c )   pthread_mutex_init( a, b )
  #define mutex_destroy( a )  pthread_mutex_destroy( a )
  #define mutex_lock( a ) pthread_mutex_lock( a )
  #define mutex_unlock( a )   pthread_mutex_unlock( a )
//#endif

typedef int T_MUTEX;

int     dsh_create_mutex_tab( int max_mutex );
void    dsh_destroy_mutex_tab( void );
int     dsh_create_mutex( void );
int     dsh_destroy_mutex( int mt );
int     dsh_lock_mutex( int mt );
int     dsh_unlock_mutex( int mt );

int     MUTEX_init( mutex_t *mp );      // dshdr2r or dshdr2u
int     MUTEX_destroy( mutex_t *mp );

#define MSGQ_WAIT_TIME  3000
/*-----------------------------------------------------------*/
typedef struct{
        int     message;            // message
        int     wParam;             // w-para
        int     lParam;             // l-para
        } TMSG;

/*-----------------------------------------------------------*/
void    TMSGQ_init( int max_size );
void    TMSGQ_term( void );
int     TMSGQ_create( int evt_id, int max_slot );
void    TMSGQ_close( int qid );
int     TMSGQ_put( int qid, int cmd, int wParam, int lParam );
int     TMSGQ_get( int qid, TMSG *msg, int wtime );

typedef struct{
    int     t;
    int     evtid;
} TSLEEP_INFO;

/*---------------------------------------------------------------------*/
void    DshInitTSLEEP( int max_sleep );
void    DshTermTSLEEP( void );
void    DshStartTSLEEP( int t );
void    DshReleaseTSLEEP( int tx, int f );
void    DshCountDownTSLEEP( void );
void    DshThreadTSLEEP( void *arg );
void    dsh_msleep( int t );

#define m_sleep( a ) dsh_msleep( a )

int THR_create( void *(*start_routine)(void *), void *arg, pthread_t *tid );

int dsh_create_thread( void *(*start_routine)(void *), // start routine
                      void *arg,        // pass arg
                      int  *evtid,      // EventID(out)
                      int  *msgqid,     // MSGQID(out)
                      pthread_t *tid );  // threadID(out)


int  dsh_join_thread( pthread_t tid );
void dsh_exit_thread( void );


