/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEng4   - GEM, GEM300 Equipment Communication Control Package         */
/*                                                                          */
/*    eng_api.h - ENG  function                                          */
/*                                                                          */
/*  Copyright (c)2009 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#ifndef eng_api_h
    #define eng_api_h

#ifdef __cplusplus
  extern "C"{
#endif

//=============================================================================

 int  EngStart( char *comm_file, char *sysconf, int restore_bkup, char *err_str );

 int  EngStop( void );

 void  EngInitSecsMsgReq( int count, HANDLE event );
 int   EngRegSecsMsg(int stream, int function, int queue_flag, int(*func)() );
 int   EngGetSecsMsgReq( TMSG_QUEUE_INFO *msg );

 int  EngSetEcVal( TECID ecid, void *val, int arraysize );

 int  EngGetEcVal( TECID ecid, void *val, int *arraysize );

 int  EngGetEcName( TECID ecid, char *val, int *arraysize );

 int  EngGetEcUnits( TECID ecid, char *val, int *arraysize );

 int  EngGetEcFormat( TECID ecid, int *fmt );

 int  EngGetEcArraySize( TECID ecid, int *val );

 int  EngGetEcSizeMinMax( TECID ecid, int *min, int *max );

 int  EngGetEcMin( TECID ecid, void *val, int *arraysize );

 int  EngGetEcMax( TECID ecid, void *val, int *arraysize );

 int  EngGetEcNominal( TECID ecid, void *val, int *arraysize );

 int  EngCheckEcVal( TECID ecid, void *val, int arraysize );

 int  EngGetEcList( TBIN_DLIST **list );

 int  EngSetReservedEcid( int index, TECID ecid );

 int  EngGetReservedEcid( int index, TECID *ecid );

 int  EngGetEcInfo( TECID ecid, TV_INFO *info );

 int  EngSetEcInfo( TEC_INFO *info );

// int  EngGetEcTimeStamp( TECID ecid, SYSTEMTIME *t );

 int  EngSetSvVal( TSVID svid, void *val, int arraysize );

 int  EngGetSvVal( TSVID svid, void *val, int *arraysize );

 int  EngGetSvName( TSVID svid, char *val, int *arraysize );

 int  EngGetSvUnits( TSVID svid, char *val, int *arraysize );

 int  EngGetSvFormat( TSVID svid, int *fmt );

 int  EngGetSvArraySize( TSVID svid, int *val );

 int  EngGetSvSizeMinMax( TSVID svid, int *min, int *max );

 int  EngGetSvMin( TSVID svid, void *val, int *arraysize );

 int  EngGetSvMax( TSVID svid, void *val, int *arraysize );

 int  EngGetSvNominal( TSVID svid, void *val, int *arraysize );

 int  EngCheckSvVal( TSVID svid, void *val, int arraysize );

 int  EngGetSvList( TBIN_DLIST **list );

 int  EngSetReservedSvid( int index, TSVID svid );

 int  EngGetReservedSvid( int index, TSVID *svid );

 int  EngGetSvInfo( TSVID svid, TV_INFO *info );

 int  EngSetSvInfo( TSV_INFO *info );

// int  EngGetSvTimeStamp( TSVID svid, SYSTEMTIME *t );

 int  EngSetDvVal( TVID vid, void *val, int arraysize );

 int  EngGetDvVal( TVID vid, void *val, int *arraysize );

 int  EngGetDvName( TVID vid, char *val, int *arraysize );

 int  EngGetDvUnits( TVID vid, char *val, int *arraysize );

 int  EngGetDvFormat( TVID vid, int *fmt );

 int  EngGetDvArraySize( TVID vid, int *val );

 int  EngGetDvSizeMinMax( TVID vid, int *min, int *max );

 int  EngGetDvMin( TVID vid, void *val, int *arraysize );

 int  EngGetDvMax( TVID vid, void *val, int *arraysize );

 int  EngGetDvNominal( TVID vid, void *val, int *arraysize );

 int  EngCheckDvVal( TVID vid, void *val, int arraysize );

 int  EngGetDvList( TBIN_DLIST **list );

 int  EngSetReservedDvid( int index, TVID vid );

 int  EngGetReservedDvid( int index, TVID *vid );

 int  EngGetDvInfo( TDVID dvid, TV_INFO *info );

 int  EngSetDvInfo( TV_INFO *info );

// int  EngGetDvTimeStamp( TDVID dvid, SYSTEMTIME *t );

 int  EngAllocTrInfo( char *trid, int *index );

 int  EngSetTrInfo( TTRACE_INFO *trinfo );

 int  EngSetTrInfoX( int index, TTRACE_INFO *trinfo );

 int  EngGetTrInfo( char *trid, TTRACE_INFO *trinfo );

 int  EngGetTrInfoX( int index, TTRACE_INFO *trinfo );

 int  EngDelTrInfo( char *trid );

 int  EngDelTrInfoX( int index );

 int  EngDelAllTrInfo( void );

 int  EngEnableTrace( char *trid );

 int  EngEnableTraceX( int index );

 int  EngGetTrId( int index, char *trid );

 int  EngGetTrIdIndex( char *trid, int *index );

 int  EngGetTrList( TTEXT_DLIST **list );

 int  EngAllocTrInfo( char *trid, int *index );

 int  EngSetTrInfo( TTRACE_INFO *trinfo );

 int  EngSetTrInfoX( int index, TTRACE_INFO *trinfo );

 int  EngGetTrInfo( char *trid, TTRACE_INFO *trinfo );

 int  EngGetTrInfoX( int index, TTRACE_INFO *trinfo );

 int  EngDelTrInfo( char *trid );

 int  EngDelTrInfoX( int index );

 int  EngDelAllTrInfo( );

 int  EngEnableTrace( char *trid );

 int  EngEnableTraceX( int index );

 int  EngGetTrId( int index, char *trid );

 int  EngGetTrIdIndex( char *trid, int *index );

 int  EngGetTrList( TTEXT_DLIST **list );

 int  EngSetMultiVLimit( TLIMIT_LIST *lmtlist );

 int  EngSetVLimit( TDVID vid, TLIMIT_INFO *lminfo );

 int  EngGetVLimit( TDVID vid, TLIMIT_INFO *lminfo );

 int  EngDelVLimit( TDVID vid );

 int  EngCheckVLimit( TDVID vid, TLIMITID limitid, void *value );

 int  EngGetVLimitFormat( TDVID vid, int *fmt );

 int  EngGetVLimitArraySize( TDVID vid, int *asize );

 int  EngSetupVLimitEventList( HANDLE event );

 void  EngTerminateVLimitEventList( void );

 int  EngPutVLimitEventList( TVLIMIT_EVENT_INFO *info );

 int  EngGetVLimitEventList( TVLIMIT_EVENT_INFO *info );

 int  EngGetRpName( TRPID rpid, char *name );

 int  EngGetRpVCount( TRPID rpid );

 int  EngGetRpVid( TRPID rpid, int order, TDVID *vid );

 int  EngGetRpAllVid( TRPID rpid, TDVID *vid );

 int  EngGetRpVName( TRPID rpid, int order, char *vname );

 int  EngGetRpList( TBIN_DLIST **list );

 int  EngSetRpVLink( TRP_LIST *list );

 int  EngGetRpInfo( TRPID rpid, TRP_INFO *info );

 int  EngSetRpInfo( TRP_INFO *info );

 int  EngGetCeName( TCEID ceid, char *name );

 int  EngGetCeEnabled( TCEID ceid );

 int  EngSetCeEnabled( TCEID ceid, int on_off );

 int  EngGetCeRpCount( TCEID ceid );

 int  EngGetCeRpid( TCEID ceid, int order, TRPID *rpid );

 int  EngGetCeAllRpid( TCEID ceid, TRPID *rpid );

 int  EngGetCeRpName( TCEID ceid, int order, char *rpname );

 int  EngSetCeRpLink( TCE_LIST *list );

 int  EngSetReservedCeid( int index, TCEID ceid );

 int  EngGetReservedCeid( int index, TCEID *ceid );

 int  EngGetCeList( TBIN_DLIST **list );

 int  EngGetCeInfo( TCEID ceid, TCE_INFO *info );

 int  EngSetCeInfo( TCE_INFO *info );

 int  EngGetAlName( TALID alid, char *name );

 int  EngGetAlEnabled( TALID alid );

 int  EngSetAlEnabled( TALID alid, int on_off );

 TALCD  EngGetAlcd( TALID alid );

 int  EngGetAltx( TALID alid, char *altx );

 TCEID  EngGetAlCeOn( TALID alid );

 TCEID  EngGetAlCeOff( TALID alid );

 int  EngGetAlList( TBIN_DLIST **list );

 int  EngSetAlInfo( TAL_INFO *info );

 int  EngGetAlInfo( TALID alid, TAL_INFO *info );

 int  EngEnable( int(*callback)(), ULONG upara);

 int  EngCancelEnable( void );

 int  EngDisable( TCEID ceid, int ( *callback )(), ULONG upara );

 int  EngSetSpoolInfo( int stream, int f_count, int *func_list );

 int  EngGetSpoolInfo( int stream, int *func_list );

 int  EngSetAllSpoolInfo( TSPOOL_INFO *ppinfo );

 int  EngGetAllSpoolInfo( TSPOOL_INFO *ppinfo );

 int  EngResetSpoolInfo( int stream );

 int  EngResetAllSpoolInfo( void );

 int  EngAllocPpInfo( char *rcpid, int *index );

 int  EngSetPpInfo( TPP_INFO *pinfo );

 int  EngSetPpInfoX( int index, TPP_INFO *pinfo );

 int  EngGetPpInfo( char *rcpid, TPP_INFO *pinfo );

 int  EngGetPpInfoX( int index, TPP_INFO *pinfo );

 int  EngDelPpInfo( char *rcpid );

 int  EngDelPpInfoX( int index );

 int  EngGetPpId( int index, char *rcpid );

 int  EngGetPpIdIndex( char *rcpid, int *index );

 int  EngSetPpState( char *rcpid, int state );

 int  EngSetPpStateX( int index, int state );

 int  EngGetPpState( char *rcpid, int *state );

 int  EngGetPpStateX( int index, int *state );

 int  EngGetPpList( TTEXT_DLIST **list );

 int  EngAllocFppInfo( char *rcpid, int *index );

 int  EngSetFppInfo( TFPP_INFO *pinfo );

 int  EngSetFppInfoX( int index, TFPP_INFO *pinfo );

 int  EngGetFppInfo( char *rcpid, TFPP_INFO *pinfo );

 int  EngGetFppInfoX( int index, TFPP_INFO *pinfo );

 int  EngDelFppInfo( char *rcpid );

 int  EngDelFppInfoX( int index );

 int  EngGetFppId( int index, char *rcpid );

 int  EngGetFppIdIndex( char *rcpid, int *index );

 int  EngSetFppState( char *rcpid, int state );

 int  EngSetFppStateX( int index, int state );

 int  EngGetFppState( char *rcpid, int *state );

 int  EngGetFppStateX( int index, int *state );

 int  EngGetFppList( TTEXT_DLIST **list );

 int  EngAllocRcpInfo( char *rcpid, int *index );

 int  EngSetRcpInfo( TRCP_INFO *pinfo );

 int  EngSetRcpInfoX( int index, TRCP_INFO *pinfo );

 int  EngGetRcpInfo( char *rcpid, TRCP_INFO *pinfo );

 int  EngGetRcpInfoX( int index, TRCP_INFO *pinfo );

 int  EngDelRcpInfo( char *rcpid );

 int  EngDelRcpInfoX( int index );

 int  EngGetRcpId( int index, char *rcpid );

 int  EngGetRcpIdIndex( char *rcpid, int *index );

 int  EngSetRcpState( char *rcpid, int state );

 int  EngSetRcpStateX( int index, int state );

 int  EngGetRcpState( char *rcpid, int *state );

 int  EngGetRcpStateX( int index, int *state );

 int  EngRenameRcpId( char *rcpid, char *new_rcpid );

 int  EngGetRcpList( TTEXT_DLIST **list );

 int  EngAllocCarInfo( char *carid, int *index );

 int  EngSetCarInfo( TCAR_INFO *cinfo );

 int  EngSetCarInfoX( int index, TCAR_INFO *cinfo );

 int  EngGetCarInfo( char *carid, TCAR_INFO *cinfo );

 int  EngGetCarInfoX( int index, TCAR_INFO *cinfo );

 int  EngDelCarInfo( char *carid );

 int  EngDelCarInfoX( int index );

 int  EngGetCarId( int index, char *carid );

 int  EngGetCarIdIndex( char *carid, int *index );

 int  EngSetCarState( char *carid, int state );

 int  EngSetCarStateX( int index, int state );

 int  EngGetCarState( char *carid, int *state );

 int  EngGetCarStateX( int index, int *state );

 int  EngSetCarIdStatus( char *carid, int state );

 int  EngSetCarIdStatusX( int index, int state );

 int  EngGetCarIdStatus( char *carid, int *state );

 int  EngGetCarIdStatusX( int index, int *state );

 int  EngSetCarMapStatus( char *carid, int map_status );

 int  EngSetCarMapStatusX( int index, int map_status );

 int  EngGetCarMapStatus( char *carid, int *map_status );

 int  EngGetCarMapStatusX( int index, int *map_status );

 int  EngSetCarLocation( char *carid, char *location );

 int  EngSetCarLocationX( int index, char *location );

 int  EngGetCarLocation( char *carid, char *location );

 int  EngGetCarLocationX( int index, char *location );

 int  EngSetCarAccessStatus( char *carid, int acc_status );

 int  EngSetCarAccessStatusX( int index, int acc_status );

 int  EngGetCarAccessStatus( char *carid, int *acc_status );

 int  EngGetCarAccessStatusX( int index, int *acc_status );

 int  EngGetCarList( TTEXT_DLIST **list );

 int  EngSetCarContent( char *carid, TCACT_CONTENT *pinfo );

 int  EngSetCarContentX( int index, TCACT_CONTENT *pinfo );

 int  EngGetCarContent( char *carid, TCACT_CONTENT *pinfo );

 int  EngGetCarContentX( int index, TCACT_CONTENT *pinfo );

 int  EngSetCarUsage( char *carid, char *usage );

 int  EngSetCarUsageX( int index, char *usage );

 int  EngGetCarUsage( char *carid, char *usage );

 int  EngGetCarUsageX( int index, char *usage );

 int  EngSetCarLotid( char *carid, int order, char *lotid );

 int  EngSetCarLotidX( int index, int order, char *lotid );

 int  EngGetCarLotid( char *carid, int order, char *lotid );

 int  EngGetCarLotidX( int index, int order, char *lotid );

 int  EngSetCarSubstid( char *carid, int order, char *substid );

 int  EngSetCarSubstidX( int index, int order, char *substid );

 int  EngGetCarSubstid( char *carid, int order, char *substid );

 int  EngGetCarSubstidX( int index, int order, char *substid );

 int  EngSetCarSlotmap( char *carid, int order, int slotmap );

 int  EngSetCarSlotmapX( int index, int order, int slotmap );

 int  EngGetCarSlotmap( char *carid, int order, int *slotmap );

 int  EngGetCarSlotmapX( int index, int order, int *slotmap );

 int  EngSetCarSlotCount( char *carid, int count );

 int  EngSetCarSlotCountX( int index, int count );

 int  EngGetCarSlotCount( char *carid, int *count );

 int  EngGetCarSlotCountX( int index, int *count );

 int  EngAllocSubstInfo( char *substid, int *index );

 int  EngSetSubstInfo( TSUBST_INFO *pinfo );

 int  EngSetSubstInfoX( int index, TSUBST_INFO *pinfo );

 int  EngGetSubstInfo( char *substid, TSUBST_INFO *pinfo );

 int  EngGetSubstInfoX( int index, TSUBST_INFO *pinfo );

 int  EngDelSubstInfo( char *substid );

 int  EngDelSubstInfoX( int index );

 int  EngGetSubstId( int index, char *substid );

 int  EngGetSubstIdIndex( char *substid, int *index );

 int  EngSetSubstInfoState( char *substid, int state );

 int  EngSetSubstInfoStateX( int index, int state );

 int  EngGetSubstInfoState( char *substid, int *state );

 int  EngGetSubstInfoStateX( int index, int *state );

 int  EngSetSubstAcquiredId( char *substid, char *acqid );

 int  EngSetSubstAcquiredIdX( int index, char *acqid );

 int  EngGetSubstAcquiredId( char *substid, char *acqid );

 int  EngGetSubstAcquiredIdX( int index, char *acqid );

 int  EngSetSubstLotId( char *substid, char *lotid );

 int  EngSetSubstLotIdX( int index, char *lotid );

 int  EngGetSubstLotId( char *substid, char *lotid );

 int  EngGetSubstLotIdX( int index, char *lotid );

 int  EngSetSubstLocId( char *substid, char *location );

 int  EngSetSubstLocIdX( int index, char *location );

 int  EngGetSubstLocId( char *substid, char *location );

 int  EngGetSubstLocIdX( int index, char *location );

 int  EngSetSubstSource( char *substid, char *source );

 int  EngSetSubstSourceX( int index, char *source );

 int  EngGetSubstSource( char *substid, char *source );

 int  EngGetSubstSourceX( int index, char *source );

 int  EngSetSubstDestination( char *substid, char *dest );

 int  EngSetSubstDestinationX( int index, char *dest );

 int  EngGetSubstDestination( char *substid, char *dest );

 int  EngGetSubstDestinationX( int index, char *dest );

 int  EngSetSubstBatchLocId( char *substid, char *blocid );

 int  EngSetSubstBatchLocIdX( int index, char *blocid );

 int  EngGetSubstBatchLocId( char *substid, char *blocid );

 int  EngGetSubstBatchLocIdX( int index, char *blocid );

 int  EngSetSubstPosInBatch( char *substid, char *posid );

 int  EngSetSubstPosInBatchX( int index, char *posid );

 int  EngGetSubstPosInBatch( char *substid, char *posid );

 int  EngGetSubstPosInBatchX( int index, char *posid );

 int  EngSetSubstState( char *substid, int state );

 int  EngSetSubstStateX( int index, int state );

 int  EngGetSubstState( char *substid, int *state );

 int  EngGetSubstStateX( int index, int *state );

 int  EngSetSubstMaterialStatus( char *substid, int state );

 int  EngSetSubstMaterialStatusX( int index, int state );

 int  EngGetSubstMaterialStatus( char *substid, int *state );

 int  EngGetSubstMaterialStatusX( int index, int *state );

 int  EngSetSubstProcState( char *substid, int state );

 int  EngSetSubstProcStateX( int index, int state );

 int  EngGetSubstProcState( char *substid, int *state );

 int  EngGetSubstProcStateX( int index, int *state );

 int  EngSetSubstLocState( char *substid, int state );

 int  EngSetSubstLocStateX( int index, int state );

 int  EngGetSubstLocState( char *substid, int *state );

 int  EngGetSubstLocStateX( int index, int *state );

 int  EngSetSubstIdStatus( char *substid, int status );

 int  EngSetSubstIdStatusX( int index, int status );

 int  EngGetSubstIdStatus( char *substid, int *status );

 int  EngGetSubstIdStatusX( int index, int *status );

 int  EngSetSubstUsage( char *substid, int usage );

 int  EngSetSubstUsageX( int index, int usage );

 int  EngGetSubstUsage( char *substid, int *usage );

 int  EngGetSubstUsageX( int index, int *usage );

 int  EngSetSubstType( char *substid, int stype );

 int  EngSetSubstTypeX( int index, int stype );

 int  EngGetSubstType( char *substid, int *stype );

 int  EngGetSubstTypeX( int index, int *stype );

 int  EngSetSubstLocHistory( char *substid, TSUBST_LOC_HIST *hinfo );

 int  EngSetSubstLocHistoryX( int index, TSUBST_LOC_HIST *hinfo );

 int  EngGetSubstLocHistory( char *substid, TSUBST_LOC_HIST *hinfo );

 int  EngGetSubstLocHistoryX( int index, TSUBST_LOC_HIST *hinfo );

 int  EngAddSubstLocHistory( char *substid, char *loc, char *time_in, char *time_out );

 int  EngAddSubstLocHistoryX( int index, char *loc, char *time_in, char *time_out );

 int  EngGetSubstHistCount( char *substid, int *count );

 int  EngGetSubstHistCountX( int index, int *count );

 int  EngGetSubstList( TTEXT_DLIST **list );

 int  EngAllocCjInfo( char *cjid, int *index );

 int  EngSetCjInfo( TOBJ_INFO *pinfo );

 int  EngSetCjInfoX( int index, TOBJ_INFO *pinfo );

 int  EngGetCjInfo( char *cjid, TOBJ_INFO *pinfo );

 int  EngGetCjInfoX( int index, TOBJ_INFO *pinfo );

 int  EngDelCjInfo( char *cjid );

 int  EngDelCjInfoX( int index );

 int  EngGetCjId( int index, char *cjid );

 int  EngGetCjIdIndex( char *cjid, int *index );

 int  EngSetCjState( char *cjid, int state );

 int  EngSetCjStateX( int index, int state );

 int  EngGetCjState( char *cjid, int *state );

 int  EngGetCjStateX( int index, int *state );

 int  EngGetCjList( TTEXT_DLIST **list );

 int  EngAllocPrjInfo( char *prjid, int *index );

 int  EngSetPrjInfo( TPRJ_INFO *pinfo );

 int  EngSetPrjInfoX( int index, TPRJ_INFO *pinfo );

 int  EngGetPrjInfo( char *prjid, TPRJ_INFO *pinfo );

 int  EngGetPrjInfoX( int index, TPRJ_INFO *pinfo );

 int  EngDelPrjInfo( char *prjid );

 int  EngDelPrjInfoX( int index );

 int  EngGetPrjId( int index, char *prjid );

 int  EngGetPrjIdIndex( char *prjid, int *index );

 int  EngSetPrjState( char *prjid, int state );

 int  EngSetPrjStateX( int index, int state );

 int  EngGetPrjState( char *prjid, int *state );

 int  EngGetPrjStateX( int index, int *state );

 int  EngGetPrjList( TTEXT_DLIST **list );

 int  EngNotifyAlarm( TALID alid, int on_off, int(*callback)(), ULONG upara);

 int  EngNotifyEvent( TCEID ceid, int(*callback)(), ULONG upara);

 int  EngNotifyAnEvent( TCEID ceid, int(*callback)(), ULONG upara);

 int  EngSendS10F1( int tid, char *text, int *ackc10, int ( *callback )(), ULONG upara );

 int  EngTerminalText( int tid, char *text, int ( *callback )(), ULONG upara );

 int  EngSendS15F3( char *rmnsspec, int rmnscmd, TRCP_ERR_INFO *erinfo, int ( *callback )(), ULONG upara );

 int  EngSendS15F5( char *rmnsspec, char *rmnewns, TRCP_ERR_INFO *erinfo, int ( *callback )(), ULONG upara );

 int  EngSendS15F7( char *objspec, TRCP_S15F8_INFO *erinfo, int ( *callback )(), ULONG upara );

 int  EngSendS15F9( char *rcpspec, TRCP_S15F10_INFO *erinfo, int ( *callback )(), ULONG upara );

 int  EngSendS15F13( TRCP_INFO *info, int updt_flag, TRCP_ERR_INFO *erinfo, int ( *callback )(), ULONG upara );

 int  EngSendS15F17( char *rcpspec, int rcpseccode, TRCP_S15F18_INFO *erinfo, int ( *callback )(), ULONG upara );

 int  EngSendS7F3( char *ppid, int *ackc7, int ( *callback )(), ULONG upara );

 int  EngSendS7F5( char *ppid, TPP_INFO *info, int ( *callback )(), ULONG upara );

 int  EngSendS7F23( char *fppid, int *ackc7, int (*callback)(), ULONG upara );

 int  EngSendS7F25( char *fppid, TFPP_INFO *info, int (*callback)(), ULONG upara );

 int   EngSetDataFormat( int x, int format );
 int   EngGetDataFormat( int x );

#ifdef __cplusplus
  }
#endif

#endif
