/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEng4   - GEM, GEM300 Equipment Communication Control Package         */
/*                                                                          */
/*    eng_lib.h - ENG KLibrary function                                     */
/*                                                                          */
/*  Copyright (c)2009 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#ifndef eng_lib_h
    #define eng_lib_h

#ifdef __cplusplus
  extern "C"{
#endif

#ifdef WINDOWS
    #define m_sleep(t) Sleep(t);
    #define dsh_create_mutex() CreateMutex(0,0,0)
    #define dsh_destroy_mutex( m ) CloseHandle(m)
    #define dsh_lock_mutex( m ) WaitForSingleObject(m,1000)
    #define dsh_unlock_mutex( m ) ReleaseMutex(m)
    #define dsh_create_thread( thread, para, a,b, thid ) \
      DshCreateThread( (LPTHREAD_START_ROUTINE)thread, (int)para, (LPDWORD)thid )

#else
//    int     dsh_create_mutex_tab( int max_mutex );
//    void    dsh_destroy_mutex_tab( void );
    int     dsh_create_mutex( void );
    int     dsh_destroy_mutex( int mt );
    int     dsh_lock_mutex( int mt );
    int     dsh_unlock_mutex( int mt );
#endif

/*--------------------------------------------------------------------------*/
/* S2F23 - Trace Information                                                */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS2F23( DSHMSG *smsg, TTRACE_INFO *info );
 int   DshMakeS2F23Response( int tiaack, DSHMSG *smsg, BYTE *buff, int buff_size );
// int   DshEncodeS2F23( DSHMSG *smsg, BYTE *buff, int bufflen, TTRACE_INFO *info );
 void  DshFreeTTRACE_INFO( TTRACE_INFO *info );
 void  DshFreeTTRACE_INFO_ALL( TTRACE_INFO *info );
 int   DshCopyTTRACE_INFO( TTRACE_INFO *pinfo, TTRACE_INFO *sinfo );
 void  DshSetupDsper( TTRACE_INFO *info );
 int   DshCheckTraceSV( TTRACE_INFO *info );
 int   DshInitTTRACE_INFO( TTRACE_INFO *info,  char *trid, char *dsper, int totsmp, int repgsz, int svid_count );
 int   DshPutTTRACE_INFO( TTRACE_INFO *info, int order, TSVID svid );
/*--------------------------------------------------------------------------*/
/* S6F1  - Trace Information                                                */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS6F1( DSHMSG *smsg, TTRACE_DATA *info );
 void  DshFreeTTRACE_DATA( TTRACE_DATA *info );
 int   DshMakeS6F1Response( BYTE ackc6, DSHMSG *smsg, BYTE *buff, int buff_size );
/*--------------------------------------------------------------------------*/
/* S2F43 - Spooling                                                         */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS2F43( DSHMSG *smsg, TSPOOL_INFO *info );
 void  DshFreeTSPOOL_INFO( TSPOOL_INFO *info );
 void  DshFreeTSPOOL_INFO_ALL( TSPOOL_INFO *info );
 int   DshCopyTSPOOL_INFO( TSPOOL_INFO **pinfo, TSPOOL_INFO *sinfo );
 int   DshMakeS2F43Response( TSPOOL_INFO *info, TSPOOL_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
// int   DshEncodeS2F43( DSHMSG *smsg, BYTE *buff, int bufflen, TSPOOL_INFO *info );
// int   EncodeSpoolMsg( DSHMSG *smsg, TSPOOL_INFO *info );
 void  DshFreeTSPOOL_ERR_INFO( TSPOOL_ERR_INFO *info );
 void  DshInitTSPOOL_ERR_INFO( TSPOOL_ERR_INFO *info, int rsack, int err_count );
 int   DshPutTSPOOL_ERR_INFO( TSPOOL_ERR_INFO *info, TSTRE_ERR_INFO *errinfo);
 void  DshInitTSTRE_ERR_INFO( TSTRE_ERR_INFO **pinfo, int strack, int stream, int f_count );
 int   DshPutTSTRE_ERR_INFO( TSTRE_ERR_INFO *info, int f_code, int func_err );
 void  DshInitTSPOOL_INFO( TSPOOL_INFO *info, int s_count );
 int   DshPutTSPOOL_INFO( TSPOOL_INFO *info, TSTRE_INFO *sinfo);
 void  DshInitTSTRE_INFO( TSTRE_INFO **pinfo, int stream, int f_count );
 int   DshPutTSTRE_INFO( TSTRE_INFO *info, int f_code );
/*---------------------------------------------------------------------*/
/* LIMIT S2F45                                                         */
/*---------------------------------------------------------------------*/
// int   DshDecodeLimit( DSHMSG *smsg, TLIMIT_INFO *info );
 int   DshCopyTLIMIT_INFO( TLIMIT_INFO **pinfo, TLIMIT_INFO *sinfo );
// int   DshEncodeLimit( DSHMSG *smsg, BYTE *buff, int bufflen, TLIMIT_INFO *info );
 void  DshFreeTLIMIT_INFO( TLIMIT_INFO *info );
 void  DshFreeTLIMIT_INFO_ALL( TLIMIT_INFO *info );

 int   DshDecodeS2F45( DSHMSG *smsg, TLIMIT_LIST *info );
// int   DshEncodeS2F45( DSHMSG *smsg, BYTE *buff, int bufflen, TLIMIT_LIST *info );
 void  DshFreeTLIMIT_LIST( TLIMIT_LIST *info );
 int   DshCopyTLIMIT_LIST( TLIMIT_LIST **pinfo, TLIMIT_LIST *sinfo );

 int   DshMakeS2F45Response( TLIMIT_LIST *info, TLIMIT_ERR_LIST *erlist, DSHMSG *smsg, BYTE *buff, int buff_size );
 void  DshFreeTLIMIT_ERR_LIST( TLIMIT_ERR_LIST *info );
 void  DshInitTLIMIT_ERR_LIST( TLIMIT_ERR_LIST *list, int vlaack, int err_count );
 int   DshPutTLIMIT_ERR_LIST( TLIMIT_ERR_LIST *list, TLIMIT_ERR_INFO *errinfo);
 void  DshInitTLIMIT_ERR_INFO( TLIMIT_ERR_INFO **pinfo, TVID vid, int lvack, int lmt_count );

 int   DshPutTLIMIT_ERR_ID( TLIMIT_ERR_INFO *pinfo, int limit_id, int limitack );

 void  DshInitTLIMIT_INFO( TLIMIT_INFO *info, TVID vid, int fmt, int asize, int count );
 int   DshPutTLIMIT_INFO( TLIMIT_INFO *info, int limit_id, void *upperdb, void *lowerdb );
 void  DshInitTLIMIT_LIST( TLIMIT_LIST *list, int count );
 int   DshAddTLIMIT_LIST( TLIMIT_LIST *list, TLIMIT_INFO *info );

 int   DshDecodeS2F48( DSHMSG *smsg, TLIMIT_RSP_LIST *list );
 void  DshFreeTLIMIT_RSP_LIST( TLIMIT_RSP_LIST *list );

 void  DshFreeTVLIMIT_EVENT_INFO( TVLIMIT_EVENT_INFO *info );
 void  DshCopyTVLIMIT_EVENT_INFO( TVLIMIT_EVENT_INFO *dinfo, TVLIMIT_EVENT_INFO *sinfo );
/*--------------------------------------------------------------------------*/
/* S2F41 - Host Command                                                     */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS2F41( DSHMSG *smsg, TRCMD_INFO *info );
 void  DshFreeTRCMD_INFO( TRCMD_INFO *info );
 void  DshFreeTRCMD_INFO_ALL( TRCMD_INFO *info );
 void  DshFreeTRCMD_ERR_INFO( TRCMD_ERR_INFO *info );
 int   DshMakeS2F41Response( TRCMD_INFO *info, TRCMD_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTRCMD_INFO( TRCMD_INFO **dinfo, TRCMD_INFO *sinfo );
 int   DshInitTRCMD_ERR_INFO( TRCMD_INFO *info, TRCMD_ERR_INFO *erinfo, int hcack, int err_count );
 int   DshPutTRCMD_ERR_PARA( TRCMD_INFO *info, TRCMD_ERR_INFO *erinfo, int order, int cpack );
 int   DshDecodeS2F42( DSHMSG *smsg, TRCMD_HERR_INFO *info );
 void  DshFreeTRCMD_HERR_INFO( TRCMD_HERR_INFO *info );
 void  DshInitTRCMD_INFO( TRCMD_INFO *info, char *rcmd, int cp_count );
 int   DshAddTRCMD_INFO( TRCMD_INFO *info, char *cp_name, int fmt, int asize, void *cp_val );
 int   DshAddTRCMD_PARA( TRCMD_INFO *info, int order, int fmt, int asize, void *cp_val );
/*--------------------------------------------------------------------------*/
/* S2F49 - gzXgR}h                                               */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS2F49( DSHMSG *smsg, TERCMD_INFO *info );
 void  DshFreeTERCMD_INFO( TERCMD_INFO *info );
 void  DshFreeTERCMD_INFO_ALL( TERCMD_INFO *info );
 void  DshFreeEnRCmdPara( TERCMD_PARA *pinfo );
 void  DshFreeTERCMD_ERR_INFO( TERCMD_ERR_INFO *info );
 int   DshMakeS2F49Response( TERCMD_INFO *info, TERCMD_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTERCMD_INFO( TERCMD_INFO **dinfo, TERCMD_INFO *sinfo );

 int   DshInitTERCMD_ERR_INFO( TERCMD_INFO *info, TERCMD_ERR_INFO *erinfo, int hcack, int err_count );
 int   DshPutTERCMD_ERR_PARA( TERCMD_INFO *info, TERCMD_ERR_INFO *erinfo, int order, int cepack );
/*--------------------------------------------------------------------------*/
/* S3F17 - Carrier Action                                                   */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS3F17( DSHMSG *smsg, TCACT_INFO *info );
 int   DshGetContentMap( DSHMSG *smsg, TCACT_PARA *info, int count, char *buff );
 int   DshGetSlotMap( DSHMSG *smsg, TCACT_PARA *info, int count, char *buff );
 void  DshFreeTCACT_INFO( TCACT_INFO *info );
 void  DshFreeTCACT_INFO_ALL( TCACT_INFO *info );
 int   DshMakeS3F17Response( TCACT_INFO *info, TCACT_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTCACT_INFO( TCACT_INFO **dinfo, TCACT_INFO *sinfo );
 void  DshFreeTCACT_ERR_INFO( TCACT_ERR_INFO *info );

 void  DshFreeTCACT_CONTENT( TCACT_CONTENT *cinfo );
 void  DshInitTCACT_ERR_INFO( TCACT_ERR_INFO *errinfo, int caack, int errcount );
 void  DshInitTCACT_INFO( TCACT_INFO *info, int action_x, char *carid, int ptn, int attr_count );
 int   DshAddTCACT_INFO( TCACT_INFO *info, TCACT_PARA *attrdata );
 void  DshMakeTCACT_PARA( TCACT_PARA **info, int attr_x, void *attrdata );
 int   DshPutTCACT_CONTENT( TCACT_PARA *info, int order, char *lotid, char *substid );
 int   DshPutTCACT_SLOT_INFO( TCACT_PARA *info, int order, int mapdata);

 int   DshSetCaActionName( int index, char *name );
 int   DshGetCaActionIndex( char *ca_action );
 char * DshGetCaActionName( int index );

 int   DshSetCaAttrName( int index, char *name );
 char * DshGetCaActionName( int index );
 char * DshGetCaAttrName( int index );

/*--------------------------------------------------------------------------*/
/* S3F25 - Port Action                                                      */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS3F25( DSHMSG *smsg, TPORT_INFO *info );
 void  DshFreeTPORT_INFO( TPORT_INFO *info );
 void  DshFreeTPORT_INFO_ALL( TPORT_INFO *info );
 int   DshMakeS3F25Response( TPORT_INFO *info, TCACT_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTPORT_INFO( TPORT_INFO **dinfo, TPORT_INFO *sinfo );
// int   DshEncodeS3F25( DSHMSG *smsg, BYTE *buff, int bufflen, TPORT_INFO *info );
 int   DshDecodeS3F26( DSHMSG *smsg, TCACT_ERR_INFO *erinfo );
 void  DshInitTPORT_INFO( TPORT_INFO *info, char *paction, int ptn, int para_count );
 int   DshAddTPORT_INFO( TPORT_INFO *info, char *pname, int fmt, int asize, void *pval );

/*--------------------------------------------------------------------------*/
/* S3F23 - Port Group Action                                                */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS3F23( DSHMSG *smsg, TPORTG_INFO *info );
 void  DshFreeTPORTG_INFO( TPORTG_INFO *info );
 void  DshFreeTPORTG_INFO_ALL( TPORTG_INFO *info );
 int   DshMakeS3F23Response( TPORTG_INFO *info, TCACT_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTPORTG_INFO( TPORTG_INFO **dinfo, TPORTG_INFO *sinfo );
/*--------------------------------------------------------------------------*/
/* Port Access Change                                                       */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS3F27( DSHMSG *smsg, TACCESS_INFO *info );
 void  DshFreeTACCESS_INFO( TACCESS_INFO *info );
 void  DshFreeTACCESS_INFO_ALL( TACCESS_INFO *info );
 int   DshMakeS3F27Response( TACCESS_INFO *info, TACCESS_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTACCESS_INFO( TACCESS_INFO **dinfo, TACCESS_INFO *sinfo );
 void  DshFreeTACCESS_ERR_INFO( TACCESS_ERR_INFO *info );
 int   DshInitTACCESS_ERR_INFO( TACCESS_ERR_INFO *errinfo, TACCESS_INFO *info, int caack, int errcount );
 int   DshPutTACCESS_ERR_INFO( TACCESS_ERR_INFO *errinfo, TACCESS_INFO *info, int order, int errcode, char *errtext );
// int  DshEncodeS3F27( DSHMSG *smsg, BYTE *buff, int bufflen, TACCESS_INFO *info );
 int   DshDecodeS3F28( DSHMSG *smsg, TACCESS_ERR_INFO *erinfo );
 void  DshInitTACCESS_INFO( TACCESS_INFO *info, int accessmode, int port_count );
 int   DshAddTACCESS_INFO( TACCESS_INFO *info, int ptn );
/*--------------------------------------------------------------------------*/
/* S7F3 - Process Program                                                   */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS7F3( DSHMSG *smsg, TPP_INFO *info );
 int   DshDecodePp( DSHMSG *smsg, TPP_INFO *info );
 void  DshFreeTPP_INFO_ALL( TPP_INFO *info );
 void  DshFreeTPP_INFO( TPP_INFO *info );

 int   DshEncodeS7F3( DSHMSG *smsg, BYTE *buff, int bufflen, TPP_INFO *info );
 int   DshEncodePp( DSHMSG *smsg, TPP_INFO *info );
 int   DshMakeS7F3Response( BYTE ackc7, DSHMSG *smsg, BYTE *buff, int buff_size );

 int   DshDecodeS7F1( DSHMSG *smsg, TPPINQ_INFO *pinfo );
 void  DshFreePpInqInfo( TPPINQ_INFO *info );
 int   DshMakeS7F1Response( BYTE ppgnt, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTPP_INFO( TPP_INFO *pinfo, TPP_INFO *sinfo );
 int   DshCopyTPPINQ_INFO( TPPINQ_INFO **pinfo, TPPINQ_INFO *sinfo );

// int   DshDecodeS7F3XX( DSHMSG *smsg, TPP_INFO *info );
// int   DshEncodeS7F3XX( DSHMSG *smsg, TPP_INFO *info );
 void  DshInitPpInfo( TPP_INFO *info, int ppid_fmt, int ppid_size, char *ppid, int ppbody_fmt, int ppbody_size, char *ppbody );
 int   DshDecodeS7F20( DSHMSG *smsg, TPPID_LIST *list );
 void  DshFreeTPPID_LIST( TPPID_LIST *list );
 int   DshDecodeS7F27( DSHMSG *smsg, TPP_PVS_LIST *list );
 void  DshFreeTPP_PVS_LIST( TPP_PVS_LIST *list );

// int  DshEncodeS7F27( DSHMSG *smsg, BYTE *buff, int bufflen, TPP_PVS_LIST *list );
 void  DshInitTPP_PVS_LIST( TPP_PVS_LIST *list, char *ppid, int err_count );
 int   DshAddTPP_PVS_LIST( TPP_PVS_LIST *list, int ackc7a, int seqnum, char *errw7 );
 int   DshDecodeS7F29( DSHMSG *smsg, int *length );
 int   DshDecodeS7F5( DSHMSG *smsg, char *ppid, int buffsize );

/*--------------------------------------------------------------------------*/
/* S7F23 - Formatted Process Program                                        */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS7F23( DSHMSG *smsg, TFPP_INFO *info );
 int   DshDecodeFpp( DSHMSG *smsg, TFPP_INFO *info );
 int   DshCopyTFPP_INFO( TFPP_INFO *info, TFPP_INFO *sinfo );
 void  DshFreeTFPP_INFO_ALL( TFPP_INFO *info );
 void  DshFreeTFPP_INFO( TFPP_INFO *info );
 void  FreeTFPP_CCODE( TFPP_CCODE *info );
 int   DshMakeS7F23Response( int ackc7, TFPP_INFO *info, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshEncodeS7F23( DSHMSG *smsg, BYTE *buff, int bufflen, TFPP_INFO *info );
 int   DshEncodeFpp( DSHMSG *smsg, TFPP_INFO *info );
// int   DshDecodeS7F231( DSHMSG *smsg, TFPP_INFO *info );
// int   DshEncodeS7F231( DSHMSG *smsg, TFPP_INFO *info );
 void  DshInitFppInfo( TFPP_INFO *info, char *ppid, char *mdln, char *softrev, int ccode_count );
 int   DshPutFppCCode( TFPP_INFO *info, int ccode_fmt, int ccode_size, int max_ccode_size, void *ccode, int ppara_count );
 int   DshPutFppPPara( TFPP_CCODE *info, int ppara_fmt, int ppara_size, int max_ppara_size, void *ppara );
 int   DshDecodeS7F25( DSHMSG *smsg, char *ppid, int buffsize );

/*--------------------------------------------------------------------------*/
/* S15FXX - Recipe Information                                              */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS15F3( DSHMSG *smsg, TRCP_ACT_INFO *info );
 void  DshFreeTRCP_ACT_INFO( TRCP_ACT_INFO *info );
 int   DshMakeS15F3Response( TRCP_ACT_INFO *pinfo, TRCP_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );

 int   DshDecodeS15F5( DSHMSG *smsg, TRCP_RENAME_INFO *info );
 void  DshFreeTRCP_RENAME_INFO( TRCP_RENAME_INFO *info );
 int   DshMakeS15F5Response( TRCP_RENAME_INFO *pinfo, TRCP_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );

 int   DshDecodeS15F8( DSHMSG *smsg, TRCP_S15F8_INFO *erinfo );
 void  DshFreeTRCP_S15F8_INFO( TRCP_S15F8_INFO *info );

 int   DshDecodeS15F13( DSHMSG *smsg, TRCP_INFO *info, int *updt_flag );
 int   DshEncodeS15F13( DSHMSG *smsg, BYTE *buff, int bufflen, TRCP_INFO *rinfo, int updt_flag );
 int   DshMakeS15F13Response( TRCP_INFO *pinfo, TRCP_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 void  DshFreeTRCP_ERR_INFO( TRCP_ERR_INFO *info );
 void  DshFreeTRCP_INFO( TRCP_INFO * info );
 void  DshFreeTRCP_INFO_ALL( TRCP_INFO * info );
 void  DshFreeTRCP_PARA( TRCP_PARA * info );
 int   DshCopyTRCP_INFO( TRCP_INFO *info, TRCP_INFO *sinfo );
 void  DshCopyTRCP_PARA( TRCP_PARA *info, TRCP_PARA *sinfo );
 int   DshMakeS15F17Response( TRCP_INFO *pinfo, TRCP_ERR_INFO *erinfo, int sect, DSHMSG *smsg, BYTE *buff, int buff_size );

 void  DshInitRcpInfo( TRCP_INFO *info, char *rcpspec, char *rcpbody, int para_count );
 int   DshPutRcpPara( TRCP_INFO   *info, char *rcpparnm, int para_fmt, int para_size, void *rcpparval );

 int   DshDecodeS15FRsp( DSHMSG *smsg, TRCP_ERR_INFO *erinfo );
 int   DshDecodeS15F18( DSHMSG *smsg, TRCP_S15F18_INFO *info );
 int   DshDecodeTRCP_SECNM( DSHMSG *smsg, char *buff, TRCP_SECNM *info);
 void  DshFreeTRCP_S15F18_INFO( TRCP_S15F18_INFO *info );
 void  DshFreeTRCP_SECNM( TRCP_SECNM *info );
 void  DshFreeTRCP_ATTR( TRCP_ATTR *info );
 int   DshDecodeS15F10( DSHMSG *smsg, TRCP_S15F10_INFO *info );
 void  DshFreeTRCP_S15F10_INFO( TRCP_S15F10_INFO *info );
 int   DshDecodeTERR_INFO_LIST( DSHMSG *smsg, char *buff, TERR_INFO **list, int count );
/*--------------------------------------------------------------------------*/
/* S10F1,F3,F5 - Terminal Messahe                                           */
/*--------------------------------------------------------------------------*/
 int  DshDecodeS10F1( DSHMSG *smsg, int *tid, char *text );
 int  DshDecodeS10F3( DSHMSG *smsg, int *tid, char *text );
 int  DshDecodeS10F5( DSHMSG *smsg, TTERMTEXT_INFO *pinfo );
 void  DshFreeTTERMTEXT_INFO( TTERMTEXT_INFO *info );
 void  DshCopyTTERMTEXT_INFO( TTERMTEXT_INFO **pinfo, TTERMTEXT_INFO *info );
 void  DshInitTTERMTEXT_INFO( TTERMTEXT_INFO *info, int tid, int count);
 int   DshAddTTERMTEXT_INFO( TTERMTEXT_INFO *info, char *text );
/*--------------------------------------------------------------------------*/
/* Carrier Information Access                                               */
/*--------------------------------------------------------------------------*/
 int   DshCopyTCAR_INFO( TCAR_INFO *info, TCAR_INFO *sinfo );
 int   DshCopyTSLOT_INFO( TSLOT_INFO *dinfo, TSLOT_INFO *sinfo );
 void  DshFreeTCAR_INFO( TCAR_INFO *info );
 void  DshFreeTCAR_INFO_ALL( TCAR_INFO *info );
 void  DshFreeTSLOT_INFO( TSLOT_INFO *info );
 void  DshInitCarInfo( TCAR_INFO *info, char *carid, char *usage, int map_status, int id_status, int acc_status, char *location, int slot_count );
 int   DshPutCarSlotInfo( TCAR_INFO *info, TSLOT_INFO *sinfo );
 void  DshInitCarSlotInfo( TSLOT_INFO **sinfo, int slotid, char *mid, char *substid, char *substloc );
/*--------------------------------------------------------------------------*/
/* Substrate Information                                                    */
/*--------------------------------------------------------------------------*/
 int   DshCopyTSUBST_INFO( TSUBST_INFO *info, TSUBST_INFO *sinfo );
 void  DshFreeTSUBST_INFO_ALL( TSUBST_INFO *info );
 void  DshFreeTSUBST_INFO( TSUBST_INFO *info );
 void  DshFreeTSUBST_LOC_HIST_ALL( TSUBST_LOC_HIST* sinfo );
 void  DshFreeTSUBST_LOC_HIST( TSUBST_LOC_HIST* sinfo );
 int   DshObjToSubstInfo( TOBJ_INFO *info, TSUBST_INFO *sinfo );
 int   DshDecodeLocHistory( DSHMSG *smsg, TSUBST_LOC_HIST *info );
 int   DshEncodeLocHistory( DSHMSG *smsg, TSUBST_LOC_HIST *info, BYTE *buff, int length );
 int   DshCopyTSUBST_LOC_HIST( TSUBST_LOC_HIST **dinfo, TSUBST_LOC_HIST *sinfo );
 void  DshInitSubstInfo(
        TSUBST_INFO *info,
        char        *substid,
        char        *acquiredID,
        char        *lotID,
        char        *subst_locID,
        char        *subst_source,
        char        *subst_destination,
        char        *batch_locID,
        char        *subst_pos_in_batch,
        int         substIDstatus,
        int         material_status,
        int         subst_proc_state,
        int         subst_state,
        int         subst_loc_state,
        int         subst_usage,
        int         subst_type );

 int   DshPutSubstLocHist( TSUBST_INFO *info, char *loc, char *time_in, char *time_out );
/*--------------------------------------------------------------------------*/
/* PRJ - Process Job S16F15                                                 */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS16F11( DSHMSG *smsg, TPRJ_INFO *info );
 int   DshDecodeS16F15( DSHMSG *smsg, TPRJ_LIST *tlist );

 int   DshCopyTPRJ_LIST( TPRJ_LIST *list, TPRJ_LIST *slist );
 int   DshCopyTPRJ_INFO( TPRJ_INFO *info, TPRJ_INFO *sinfo );
 void  DshFreeTPRJ_LIST( TPRJ_LIST *list );
 void  DshFreeTPRJ_INFO( TPRJ_INFO *info );
 void  DshFreeTPRJ_INFO_ALL( TPRJ_INFO *info );
 int   DshMakeS16F11Response( TPRJ_INFO *pinfo, TPRJ_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshMakeS16F15Response( TPRJ_LIST *pinfo, TPRJ_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 void  DshCopyPrjObId( TPRJ_ERR_INFO *erinfo, TPRJ_LIST *plist );

 void  DshFreeTPRJ_ERR_INFO( TPRJ_ERR_INFO *info );

 void  DshInitTPRJ_ERR_INFO( TPRJ_ERR_INFO *errinfo, int prj_count, int acka, int errcount );
 int   DshPutTPRJ_ERR_PRJID( TPRJ_ERR_INFO *errinfo, char *prjid );
 int   DshPutTPRJ_ERR_INFO( TPRJ_ERR_INFO *errinfo, int errcode, char *errtext );

 void  DshInitPrjInfo( TPRJ_INFO *info, char *prjobid, int mf, int cj_index, int car_count, int prrecipemethod, int prprocessstart, int ceid_count );
 void  DshPutPrjRcpInfo( TPRJ_INFO *info, TRCP_INFO *rcp_info );
 int   DshPutPrjCarInfo( TPRJ_INFO *info, TCAR_INFO *cinfo );
 int   DshPutPrjPauseCeid( TPRJ_INFO *info, int ceid );

 void  DshInitTPRJ_LIST( TPRJ_LIST *list, int prj_count );
 int   DshAddTPRJ_LIST( TPRJ_LIST *list, TPRJ_INFO *prj_info );

 int   DshDecodeS16FRsp( DSHMSG *smsg, TPRJ_ERR_INFO *erinfo );
 int   DshDecodeS16F20( DSHMSG *smsg, TPRJ_STATE_LIST *list );
 void  DshFreeTPRJ_STATE_LIST( TPRJ_STATE_LIST *list );

/*--------------------------------------------------------------------------*/
/* S16F5 - PRJ Command                                                      */
/*--------------------------------------------------------------------------*/
 int  DshDecodeS16F5( DSHMSG *smsg, TPRJ_CMD_INFO *info );
// int  DshEncodeS16F5( DSHMSG *smsg, BYTE *buff, int bufflen, TPRJ_CMD_INFO *info );
 void  DshFreeTPRJ_CMD_INFO( TPRJ_CMD_INFO *info );
 int   DshMakeS16F5Response( TPRJ_CMD_INFO *info, TPRJ_CMD_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTPRJ_CMD_INFO( TPRJ_CMD_INFO **dinfo, TPRJ_CMD_INFO *sinfo);
 void  DshFreeTPRJ_CMD_ERR_INFO( TPRJ_CMD_ERR_INFO *info );
 void  DshInitTPRJ_CMD_ERR_INFO( TPRJ_CMD_ERR_INFO *errinfo, char *prjobid, int acka, int errcount );
 void  DshInitTPRJ_CMD_INFO( TPRJ_CMD_INFO *info, char *prjobid, char *cmd, int cp_count );
 int   DshAddTPRJ_CMD_INFO( TPRJ_CMD_INFO *info, char *cpname, int cpval_fmt, int cpval_size, void *cpval );
/*--------------------------------------------------------------------------*/
/* S16F17 - PRJ Deque                                                       */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS16F17( DSHMSG *smsg, TPRJ_DEQ_INFO *info );
// int   DshEncodeS16F17( DSHMSG *smsg, BYTE *buff, int bufflen, TPRJ_DEQ_INFO *info );
 void  DshFreeTPRJ_DEQ_INFO( TPRJ_DEQ_INFO *info );
 int   DshMakeS16F17Response( TPRJ_DEQ_INFO *info, TPRJ_DEQ_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTPRJ_DEQ_INFO( TPRJ_DEQ_INFO **dinfo, TPRJ_DEQ_INFO *sinfo );
 void  DshFreeTPRJ_DEQ_ERR_INFO( TPRJ_DEQ_ERR_INFO *info );
 int   DshDeqPrjId( TPRJ_DEQ_INFO *info, TPRJ_DEQ_ERR_INFO *erinfo );
 void  DshInitTPRJ_DEQ_ERR_INFO( TPRJ_DEQ_ERR_INFO *errinfo, TPRJ_DEQ_INFO *info, int acka, int errcount );
 void  DshInitTPRJ_DEQ_INFO( TPRJ_DEQ_INFO *info, int prj_count );
 int   DshAddTPRJ_DEQ_INFO( TPRJ_DEQ_INFO *info, char *prjid );
/*--------------------------------------------------------------------------*/
/* OBJECT S14F9,11                                                          */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS14F9( DSHMSG *smsg, TOBJ_INFO *info );

 int   DshDecodeObject( DSHMSG *smsg, TOBJ_INFO *info );
 int   DshDecodeMOStat( DSHMSG *smsg, TOBJ_ATTR_INFO *ainfo, int count, char *buff);
 int   DshDecodeMOSpec( DSHMSG *smsg, TOBJ_ATTR_INFO *info, int count, char *buff);
 int   DshDecodePrCtrlSpec( DSHMSG *smsg, TOBJ_ATTR_INFO *info, int count, char *buff);
// int   DshEncodeS14F9( DSHMSG *smsg, BYTE *buff, int bufflen, void *pinfo );
// int   DshEncodeObjAttr( DSHMSG *smsg, TOBJ_INFO *pinfo );
 int   DshCopyTOBJ_INFO( TOBJ_INFO *info, TOBJ_INFO *sinfo );
 void  DshFreeTOBJ_INFO( TOBJ_INFO *info );
 void  DshFreeTOBJ_INFO_ALL( TOBJ_INFO *info );
 int   DshMakeS14F9Response( TOBJ_INFO *pinfo, TOBJ_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 void  DshFreeTOBJ_ERR_INFO( TOBJ_ERR_INFO *info );
 int   DshDecodeS14F11( DSHMSG *smsg, TOBJ_INFO *info );
// int   DshEncodeS14F11( DSHMSG *smsg, BYTE *buff, int bufflen, void *pinfo );
 int   DshMakeS14F11Response( TOBJ_INFO *pinfo, TOBJ_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );

 void  DshInitCjInfo( TOBJ_INFO *info, char *objid, char *objspec, char *objtype, int attr_count );
 int   DshPutCjAttrInfo( TOBJ_INFO *info, int attr_index, void *attr_info );
 void  DshInitCjVoidList( TVOID_LIST **info, int void_count );
 int   DshPutCjVoidList( TVOID_LIST *info, void *void_info );

 void  DshInitCjTextInfo( TCJ_TEXT_INFO **info, int text_count );
 int   DshPutCjTextInfo( TCJ_TEXT_INFO *info, char *text );
 void  DshInitCjMtrlOutByStatus( TMTRL_OUT_STAT **info, int mtrl_status, char *carid, int slot_count );
 int   DshPutCjMtrlOutByStatus( TMTRL_OUT_STAT *info, int slotid );
 void  DshInitCjMtrlOutSpec( TMTRL_OUT_SPEC **info, char *src_carid, int src_slot_count, char *dst_carid, int dst_slot_count );
 int   DshPutCjMtrlOutSpec( TMTRL_OUT_SPEC *info, int src_slotid, int dst_slotid );
 void  DshInitCjProcessCtrlSpec( TCTRL_SPEC **info, char *prjobid, int ctrl_rule_count, int out_rule_count );
 int   DshPutCjCtrlRuleInfo( TCTRL_SPEC *info, char *name, int fmt, int asize, void *value );
 int   DshPutCjOutRuleInfo( TCTRL_SPEC *info, int status, int fmt, int asize, void *value );
 void  DshInitCjPRJobStatusList( TPRJ_STATE_LIST **info, int prj_count );
 int   DshPutCjPRJobStatus( TPRJ_STATE_LIST *info, char *prjid, int state );
 void  DshInitCjPauseEvent( TPAUSE_EVENT **info, int ce_count );
 int   DshPutCjPauseEvent( TPAUSE_EVENT *info, int ceid );
 int   DshDecodeS14F10( DSHMSG *smsg, TOBJ_S14_ERR_INFO *erinfo );
 void  DshFreeTOBJ_S14_ERR_INFO( TOBJ_S14_ERR_INFO *info );
 void  DshFreeTOBJ_ATTR_INFO( TOBJ_ATTR_INFO *ainfo );
// int   DshEncodeTOBJ_ATTR( DSHMSG *smsg, TOBJ_ATTR_INFO *info );

 int   DshDecodeTOBJ_ATTR_INFO( DSHMSG *smsg, TOBJ_ATTR_INFO *ainfo );
 int   DshDecodeS14F12( DSHMSG *smsg, TOBJ_S14_ERR_INFO *erinfo );
 int   DshDecodeTERR_INFO( DSHMSG *smsg, TERR_INFO *erinfo );

 int   DshSetObjTypeName( int index, char *name );
 int   DshGetObjTypeIndex( char *objtype );
 char*  DshGetObjTypeByIndex( int index );
 int   DshGetObjAttrIdIndex( char *attrid );

 int   DshSetCjObjAttrIdName( int index, char *name );
 char*  DshGetCjAttrIdByIndex( int index );

 int   DshSetCjCmdName( int index, char *name );
 int   DshGetCjCmdIndex( char *cmd );
 char*  DshGetCjCmdByIndex( int index );

 int   DshSetSubstObjAttrIdName( int index, char *name );
 char*  DshGetSubstAttrIdByIndex( int index );

 int   DshSetSubstCmdName( int index, char *name );
 int   DshGetSubstCmdIndex( char *cmd );
 char*  DshGetSubstCmdByIndex( int index );

/*--------------------------------------------------------------------------*/
/* S14F19, 21 - Reticle Control                                             */
/*--------------------------------------------------------------------------*/

#if 0
 int   DshDecodeS14F19( DSHMSG *smsg, TS14F19_INFO *info );
 void  DshFreeTS14F19_INFO_ALL( TS14F19_INFO *info );
 void  DshFreeTS14F19_INFO( TS14F19_INFO *info );
 void  DshFreeTGSV_PARA( TGSV_PARA *pinfo );
 int   DshMakeS14F19Response( TS14F20_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTS14F20_ERR_INFO( TS14F20_ERR_INFO **dinfo, TS14F20_ERR_INFO *sinfo );
 void  DshInitTS14F19_INFO( TS14F19_INFO *info, ULONG opid, char *objspec, char *svcname, int spcount );
 int   DshPutTS14F19_SP_INFO( TS14F19_INFO *info,  char *spname, int fmt, int size, void *spval );
 void  DshInitTS14F20_ERR_INFO( TS14F20_ERR_INFO *erinfo, int svcack, ULONG linkid, int sp_count, int err_count );
 int   DshPutTS14F20_SP_INFO( TS14F20_ERR_INFO *erinfo,  char *spname, int fmt, int size, void *spval );
 int   DshPutTS14F20_ERR_INFO( TS14F20_ERR_INFO *erinfo,  int errcode, char *errtext );
// int   DshEncodeS14F19( DSHMSG *smsg, BYTE *buff, int bufflen, TS14F19_INFO *info );
 int   DshDecodeS14F20( DSHMSG *smsg, TS14F20_ERR_INFO *erinfo );
 void  DshFreeTS14F20_ERR_INFO( TS14F20_ERR_INFO *info );


//----- S14F21 - Completion
 int   DshDecodeS14F21( DSHMSG *smsg, TS14F21_INFO *info );
 void  DshFreeTS14F21_INFO_ALL( TS14F21_INFO *info );
 void  DshFreeTS14F21_INFO( TS14F21_INFO *info );
 int   DshCopyTS14F21_INFO( TS14F21_INFO **dinfo, TS14F21_INFO *sinfo );
 int   DshEncodeS14F21( DSHMSG *smsg, BYTE *buff, int bufflen,TS14F21_INFO *info );
 int   DshMakeS14F21Response( int dataack, DSHMSG *smsg, BYTE *buff, int buff_size );
 void  DshInitTS14F21_INFO( TS14F21_INFO *info, ULONG opid, ULONG linkid, int spcount, int svcack, int errcount );
 int   DshPutTS14F21_SP_INFO( TS14F21_INFO *info,  char *spname, int fmt, int size, void *spval );
 int   DshPutTS14F21_ERR_INFO( TS14F21_INFO *info,  int errcode, char *errtext );
#endif

/*--------------------------------------------------------------------------*/
/* S16F27 - CJ Command                                                      */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS16F27( DSHMSG *smsg, TCJ_CMD_INFO *info );
// int   DshEncodeS16F27( DSHMSG *smsg, BYTE *buff, int bufflen, TCJ_CMD_INFO *info );
 void  DshFreeTCJ_CMD_INFO( TCJ_CMD_INFO *info );
 int   DshMakeS16F27Response( TCJ_CMD_INFO *info, TCJ_CMD_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshCopyTCJ_CMD_INFO( TCJ_CMD_INFO **dinfo, TCJ_CMD_INFO *sinfo );
 void  DshFreeTCJ_CMD_ERR_INFO( TCJ_CMD_ERR_INFO *info );
 void  DshInitTCJ_CMD_ERR_INFO( TCJ_CMD_ERR_INFO *errinfo, int acka, int err_flag, int errcode, char *errtext );
 void  DshInitTCJ_CMD_INFO( TCJ_CMD_INFO *info, char *ctljobid, BYTE cmd );
 int   DshAddTCJ_CMD_INFO( TCJ_CMD_INFO *info, char *cpname, int cpval_fmt, int cpval_size, void *cpval );

/*--------------------------------------------------------------------------*/
/* S14F1 - Get Attr Request                                                 */
/*--------------------------------------------------------------------------*/
 int   DshDecodeS14F1( DSHMSG *smsg, TATTR_INFO  *info );
 void  DshFreeTATTR_INFO( TATTR_INFO *info );
/*--------------------------------------------------------------------------*/
/* OBJECT Error ݒ                                                    */
/*--------------------------------------------------------------------------*/
 void  DshInitTOBJ_ERR_INFO( void *obj_errinfo, int objack, int errcount );
 int   DshPutTOBJ_ERR_INFO( TOBJ_ERR_INFO *errinfo, int errcode, char *errtext );
 int   DshPutTERR_INFO_LIST( TERR_INFO **erlist, int list_size, int errcode, char *errtext );
 void  DshPutTERR_INFO( TERR_INFO *erinfo, int errcode, char *errtext );
 void  DshFreeTERR_INFO_LIST( TERR_INFO **erlist, int list_size );
 void  DshFreeTERR_INFO( TERR_INFO *erinfo );
/*--------------------------------------------------------------------------*/
/* Ǘ񃊃Xg擾pLIST                                                 */
/*--------------------------------------------------------------------------*/
 TBIN_DLIST*  DshCreateBinDlist( int count );
 void    DshFreeTBIN_DLIST( TBIN_DLIST  *list );
 int     DshAddBinDlist( TBIN_DLIST *list, int i, ULONG id, char *name ); int     DshDecodeBinDlist( DSHMSG *smsg, TBIN_DLIST **list );
 int     DshEncodeBinDlist( DSHMSG *smsg, TBIN_DLIST *list, BYTE *buff, int bufflen );

/*---------------------------------------------------------------------*/
 TTEXT_DLIST*  DshCreateTextDlist( int count );
 void     DshFreeTTEXT_DLIST( TTEXT_DLIST  *list );
 int      DshAddTextDlist( TTEXT_DLIST *list, int i, char* id, char *name );
 int      DshDecodeTextDlist( DSHMSG *smsg, TTEXT_DLIST **list );
 int      DshEncodeTextDlist( DSHMSG *smsg, TTEXT_DLIST *list, BYTE *buff, int bufflen );

/*---------------------------------------------------------------------*/
/* SECS DSHMSGݒ                                                 */
/*---------------------------------------------------------------------*/
 void    DshSetupMsgForSend( DSHMSG *smsg, int s, int f, int wbit, BYTE *buff, int len );
 void    DshFreeMsg( DSHMSG *smsg );

/*---------------------------------------------------------------------*/
/* SECS Message SxFy - Processed by user                               */
/*---------------------------------------------------------------------*/
 int   DshRegDefaultSxFyFunc( TPRI_PRO_INFO
                                                        *pri_pro_info_tab );
 void  U_FreeMsg( DSHMSG *smsg );
 void * DshGetPtrOfPtr( void **p );
 int   DshResponseSxFy( ID_TR trid, DSHMSG *prmsg, int (*callback)( DSHMSG *prmsg) );
 void  DshGetSerialNo( char *bb );

/*---------------------------------------------------------------------*/
 void  DshBeepAccept();
 void  Kprintf( const char * pfmt, ... );
 void  DshHexDump( void *p, int len );
 void  Dsh_log_secs_msg( DSHMSG *smsg );
 char*  DshFormatDateTime( char *tbuf, char *fmt );
 void*  DshAllocBuff( int fmt, int asize, int mark );
 HANDLE   DshCreateThread( LPTHREAD_START_ROUTINE th_func, int para, LPDWORD thid );

/*---------------------------------------------------------------------*/
 void  DshPutLogText( char *text );  // text̕
 int   DshGetLogText( char *buff );      // texti[pbuff >= 128 bytes
 void  DshLogFormat( const char * pfmt, ... );

/*----- Backup File Check ---------------------------------------------*/
 int   DshCkBkupEcInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupSvInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupDvInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupPpInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupFppInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupRcpInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupCarInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupSubstInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupCjInfo( char *dir, int up_flag, TBACKUP_INFO *info );
 int   DshCkBkupPrjInfo( char *dir, int up_flag, TBACKUP_INFO *info );

 int  DshDecodeS6F11( DSHMSG *smsg, TCE_CONTENT *info );
 int  DshDecodeS6F13( DSHMSG *smsg, TCE_CONTENT *info );
 void  DshFreeTCE_CONTENT( TCE_CONTENT *info );
 void  DshFreeTRP_CONTENT( TRP_CONTENT *info );
 void  DshFreeTV_CONTENT( TV_CONTENT *info );
 int   DshMakeS6F11Response( BYTE ackc6, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshMakeS6F13Response( BYTE ackc6, DSHMSG *smsg, BYTE *buff, int buff_size );
 void  DshInitGetTCE_CONTENT( TCE_CONTENT *info );
 TV_CONTENT*  DshGetNextPtrV_CONTENT( TCE_CONTENT *info );

// int   DshEncodeS2F33( DSHMSG *smsg, BYTE *buff, int bufflen, TRP_LIST  *list );
 int   DshDecodeS2F33( DSHMSG *smsg, TRP_LIST  *list );
 void  DshFreeTRP_LIST( TRP_LIST *list );
// int   DshEncodeS2F35( DSHMSG *smsg, BYTE *buff, int bufflen, TCE_LIST  *list );
 int   DshDecodeS2F35( DSHMSG *smsg, TCE_LIST  *list );
 void  DshFreeTCE_LIST( TCE_LIST *list );
 void  DshInitTCE_LIST( TCE_LIST *list, int count );
 int   DshInitTCE_LINK( TCE_LIST *list, int ce_order, TCEID ceid, int rp_count );
 int   DshAddTCE_LINK( TCE_LIST *list, int ce_order, TRPID rpid );

 void  DshInitTRP_LIST( TRP_LIST *list, int count );
 int   DshInitTRP_LINK( TRP_LIST *list, int rp_order, TRPID rpid, int rp_count );
 int   DshAddTRP_LINK( TRP_LIST *list, int rp_order, TVID vid );

// int   DshEncodeS2F37( DSHMSG *smsg, BYTE *buff, int bufflen, TCEID  *list, int count, int ceed );
 int   DshDecodeS2F37( DSHMSG *smsg, TCEID  *list, int *count, int *ceed );
// int   DshDecodeS6F20( DSHMSG *smsg, TRPID rpid, TRP_CONTENT *info );
/*---------------------------------------------------------------------*/
 int   DshDecodeS5F1( DSHMSG *smsg, TAL_S5F1_INFO *info );
 void  DshFreeTAL_S5F1_INFO( TAL_S5F1_INFO *info );
 int   DshMakeS5F1Response( BYTE ackc5, DSHMSG *smsg, BYTE *buff, int buff_size );
 int   DshDecodeS5F6( DSHMSG *smsg, TAL_S5F6_LIST *list );
 void  DshFreeTAL_S5F6_LIST( TAL_S5F6_LIST *list );

/*---------------------------------------------------------------------*/
 int   DshEncodeVidList( DSHMSG *smsg, int s, int f, BYTE *buff, int bufflen, TVID *list, int count );
 int   DshDecodeVarValMsg( DSHMSG *smsg, TV_VALUE_LIST *list );
 int   DshEncodeVarValMsg( DSHMSG *smsg, int s, int f, BYTE *buff, int bufflen, TV_VALUE_LIST *list );
 void  DshFreeTV_VALUE_LIST( TV_VALUE_LIST *list );
 void  DshInitTV_VALUE_LIST( TV_VALUE_LIST *list, int count );
 int   DshAddTV_VALUE_LIST( TV_VALUE_LIST *list, TVID vid, int fmt, int asize, void *value );

 int   DshDecodeEcNameMsg( DSHMSG *smsg, TEC_NAME_LIST *list );
 int   DshEncodeEcNameMsg( DSHMSG *smsg, int s, int f, BYTE *buff, int bufflen, TEC_NAME_LIST *list );
 void  DshFreeTEC_NAME_LIST( TEC_NAME_LIST *list );
 int   DshDecodeSvNameMsg( DSHMSG *smsg, TSV_NAME_LIST *list );
 int   DshEncodeSvNameMsg( DSHMSG *smsg, int s, int f, BYTE *buff, int bufflen, TSV_NAME_LIST *list );
 void  DshFreeTSV_NAME_LIST( TSV_NAME_LIST *list );

#if 0
//-----------------------------------------------------------------------------
 int   DshDecodeS3F35( DSHMSG *smsg, TS3F35_INFO *info );

 void  DshFreeS3F35_INFO_ALL( TS3F35_INFO *info );

 void  DshFreeTS3F35_INFO( TS3F35_INFO *info );

 int   DshEncodeS3F35( DSHMSG *smsg, BYTE *buff, int bufflen, TS3F35_INFO *info );

 int   DshDecodeS3F36( DSHMSG *smsg, TS3F36_ERR_INFO *erinfo );

 void  DshFreeTS3F36_ERR_INFO( TS3F36_ERR_INFO *info );

 int   DshCopyTS3F36_ERR_INFO( TS3F36_ERR_INFO *dinfo, TS3F36_ERR_INFO *sinfo );

 int   DshMakeS3F35Response( TS3F36_ERR_INFO *erinfo, DSHMSG *smsg, BYTE *buff, int buff_size );

 void  DshInitTS3F35_INFO(
        TS3F35_INFO   *info,
        char        *jobaction,
        char        *podid,
        int         in_ptn,
        int         out_ptn,
        int         attr_count,
        int         remove_inst_count,
        int         place_inst_count );

 int   DshAddTS3F35_INFO_ATTR_INFO( TS3F35_INFO  *info,  TRET_ATTR_INFO  *ainfo );
 void  DshSetTRET_ATTR_INFO( TRET_ATTR_INFO *info, char *attrid, int fmt, int size, BYTE *attrdatat );
 void  DshFreeTRET_ATTR_INFO( TRET_ATTR_INFO *info );
 void  DshCopyTRET_ATTR_INFO( TRET_ATTR_INFO *dst, TRET_ATTR_INFO *src );

 void  DshInitTRET_REMOVE_INST_INFO( TRET_REMOVE_INST_INFO *info, char *ret_id, char *inst, int count );
 int   DshAddTRET_REMOVE_INST_ATTR( TRET_REMOVE_INST_INFO *info, TRET_ATTR_INFO *ainfo );
 int   DshAddTRET_REMOVE_INST_INFO( TS3F35_INFO *info, TRET_REMOVE_INST_INFO *ainfo );
 void  DshFreeTRET_REMOVE_INST_INFO( TRET_REMOVE_INST_INFO *info );
 int   DshCopyTRET_REMOVE_INST_INFO( TRET_REMOVE_INST_INFO *dst, TRET_REMOVE_INST_INFO *src );

 void  DshInitTRET_PLACE_INST_INFO( TRET_PLACE_INST_INFO *info, char *ret_id, char *inst );
 int   DshAddTRET_PLACE_INST_INFO( TS3F35_INFO *info, char *ret_id, char *inst );
 void  DshFreeTRET_PLACE_INST_INFO( TRET_PLACE_INST_INFO *info );
 int   DshCopyTRET_PLACE_INST_INFO( TRET_PLACE_INST_INFO *dst, TRET_PLACE_INST_INFO *src );

 void  DshInitTS3F36_ERR_INFO( TS3F36_ERR_INFO *info, int ack, int err_count );
 int   DshAddTS3F36_ERR_INFO( TS3F36_ERR_INFO *info, int err_code, char *err_text );
 int   DshCopyTS3F35_INFO( TS3F35_INFO *dst, TS3F35_INFO *src );
#endif
//-----------------------------------------------------------------------------

 void     DshStartPerformanceTimer( int x );
 float    DshStopPerformanceTimer( int x );

 void     DshStartProcessTimer( int x );
 UINT     DshStopProcessTimer( int x );
//-------------------------------------------------------------
 int   dsh_lower_to_upper( int c );
 int   dsh_upper_to_lower( int c );
 void  dsh_lower_to_upper_str( char *s );
 void  dsh_upper_to_lower_str( char *s );

 void   dsh_to_upper( char *d, char *s );
 void   dsh_to_lower( char *d, char *s );
 char*  dsh_trim( char *buff );
 char*  dsh_dsh_trim_trail( char *buff );
 char*  dsh_dsh_trim_leader( char *buff );
 void   dsh_change_byte_order( char *d, char *s, int n );
 int    dsh_atoi( char * buf );
 int    dsh_atox( char *buff );
 int    dsh_atobool( char *buf );
 void   dsh_a8toi( BYTE *dst, char *src );
 void   dsh_shift_r_4( BYTE *dst, int n );
 int    dsh_set_vdval( void *val, void *sval, int fmt, int size, int max_size );
 void   dsh_sprint_vdval( char *buff, int fmt, void *sval );
 int    dsh_compare_vdval( void *val1, void *val2, int fmt );
 void   dsh_adjust_str_length( char *val, int fmt, int size );
 char*  dsh_get_item_name( int icode );
 int    dsh_get_item_code( char *name );
 int    dsh_get_item_unit_size( int icode );
 int    dsh_get_item_format_count( DSHMSG *smsg, int max_count, int *dcount);
 char*  dsh_edit_data_format( char *buff, int icode, int size, int max_size );
 char*  dsh_edit_vdval( char *buff, int fmt, void *sval, int hex );
 int    DshCreateProcess( char *exe_file, char *argv, char *title, char *error );
 void   DshBeep( int n, int interval );
 void   dsh_make_v_val( char *sbuf, int len, int icode, void **val );
// char  *  DshFormatDateTimeZ( char *buff, char *fmt, SYSTEMTIME *t );

//----- List --------------------------------------------------
 void  DshInitList( TDshList *list, int max_list, int wtime );
 void  DshTermList( TDshList *list );
 int   DshPutList( TDshList *list, void *tab );
 int   DshGetList( TDshList *list, void **tab );
 int   DshListCount( TDshList *list );
 int   DshPutBackList( TDshList *list, void *tab );
 void  DshSetMemLeakCkFlag( int flag );             // memory leak check
 void  PrintMalloc( void );


#ifdef __cplusplus
  }
#endif

#endif
/*----- Enf of File --------------------------------------------------------*/
