/****************************************************************/
/*                                                              */
/*    << DSHEng4   Test Program >>                              */
/*                                                              */
/*              file name : g_info.h h                          */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/
#define MAX_NAME_LEN    81

/*-----------------------------------------------------------*/
#define K_MAX_SLOT  25
#define K_MAX_PARA  10

//----- recipe - process program message mode -----------------
#define rcp_msg_mode_PP     0           // S7F3
#define rcp_msg_mode_FPP    1           // S7F23
#define rcp_msg_mode_RCP    2           // S15F13

//----- process job message moce ------------------------------
#define prj_msg_mode_PRJ    0           // S16F11
#define prj_msg_mode_MPRJ   1           // S16F15

/*----- Job Schejule Information --------------------------------------------*/
typedef struct{
        int     slotid;
        char    *mid;
        char    *substid;
        char    *location;
}TTSLOT_INFO;

/*-----------------------------------------------------------*/
typedef struct{
        char    *name;
        char    *value;
}TTRCP_PARA;

/*-----------------------------------------------------------*/
typedef struct{                                             // for S7F23
        char    *ccode;
        int     para_count;
        char    *para[K_MAX_SLOT];
} TTFPP_CCODE;

/*-----------------------------------------------------------*/
/* Job Information Block                                     */
/*-----------------------------------------------------------*/
typedef struct{
        char    *carid;             // carrier id
        int     port;               // port 1,2
        char    *usage;             // usage
        char    *location;          // location
        TTSLOT_INFO *slot_info[K_MAX_SLOT]; // slot information
        char    *cjid;              // control job id
        char    *prjid;             // prjid
        char    *rcpid;             // rcpid( = ppid )              S7F3, S7F23, S15F13 common
        char    *rcpbody;           // rcp body( = ppbody)          S7F3, S15F13
        int     para_count;         // # of parameter               S15F13
        int     para_index;         // next to put                  S15F13
        TTRCP_PARA *rcp_para[K_MAX_PARA];   // parameter            S15F13
        int     ccode_count;        // fpp cmd code counter         S7F23
        TTFPP_CCODE *fpp_ccode[K_MAX_PARA]; // fpp ccode list       S7F23
}TTJOB_INFO;

typedef struct{
        int     job_count;          // # of job ot process
        int     job_index;
        TTJOB_INFO **job_list;      // job list
} TTSIM_JOB_LIST;
/*-----------------------------------------------------------*/
/* Sim Operation Control Block                               */
/*-----------------------------------------------------------*/
typedef struct{
        int         eqid;                           // eqid ( not used )
        int         sim_busy;                       // in simulation
#ifndef WINDOWS
        pthread_t   sim_thid;                       // thread id
#else
        ULONG       sim_thid;
#endif
        FILE        *sim_fp;                        // job schedule file FILE*
        int         s_print_flag;                   // load staus information print flag
        int         proc_count;                     // # of processing time finished
        int         ope_mode;                       // step/auto
        int         stop_flag;                      // operation stop flag
        int         cycle_stop_flag;                // cycle stop flag
        int         state;                          // sim processing state
        int         sub_state;                      //    "           sub_state
        int         job_index;                      // job schedule info index
        TCEID       ceid_callback;                  // CEID waiting for callback
        int         ce_end_status;                  // end status
        int         callback_s;                     // Sx - waiting secondary msg
        int         callback_f;                     // Fy
        int         option;                         // option data to wait primary message
        int         callback_ack;                   // ack
        TTJOB_INFO  *job_info;                      // Job Information block pointer
        int         operation_mode;                 // ONLINE / OFFLINE
        int         acess_mode;                     // port access mode
        int         load_port;                      // SV_LoadPortId
        int         carid_index;                    // (carid reg index)
        int         load_transfer_status;           // SV_LoadPortTransferStatus
        int         load_carid_status;              // SV_LoadCarIdStatus
        int         load_slotmap_status;            // SV_LoadSlotMapStatus
        int         load_car_access_status;         // SV_LoadPortAssociationStatus
        int         load_port_association_status;   // SV_LoadPortAssociationStatus
        char        carid[MAX_NAME_LEN];            // carrier ID
        char        ppid[MAX_NAME_LEN];             // process program/recipe ID
        char        prjid[MAX_NAME_LEN];            // prrocess job ID
        char        prj_state[MAX_NAME_LEN];        // process job status(char string)
        char        cjid[MAX_NAME_LEN];             // control job ID
        int         cj_state;                       // control job state
        char        usage[MAX_NAME_LEN];            // carrier usage
        char        location[MAX_NAME_LEN];         // carrier location
} TTSIM_OPERATION;

/*-----------------------------------------------------------*/
    #define  SOPE_IDLE               0
    #define  SOPE_LOAD_START         1
    #define  SOPE_LOAD_END           2
    #define  SOPE_READ_CARID         3
    #define  SOPE_PORT_ASSOCIATED    4
    #define  SOPE_ID_VERIFY_END      5
    #define  SOPE_OPEN_FOUP          6
    #define  SOPE_READ_SLOTMAP       7
    #define  SOPE_SLOTMAP_VERIFY_END  8
    #define  SOPE_PPID_READY         9
    #define  SOPE_PRJ_READY          10
    #define  SOPE_CJ_READY           11
    #define  SOPE_PROC_START         12
    #define  SOPE_PROC_END           13
    #define  SOPE_PRJ_COMPLETE       14
    #define  SOPE_CJ_COMPLETE        15
    #define  SOPE_CJ_DELETE          16
    #define  SOPE_CLOSE_FOUP         17
    #define  SOPE_UNLOAD_START       18
    #define  SOPE_UNLOAD_END         19

