/*--------------------------------------------------------------------------*/
/*  DSHEng4   - Equipment Communication Control Engine                      */
/*                                                                          */
/*    user_def.h :  User Defined Information                                */
/*                                                                          */
/*                   (C) Copyright 2007 Data Map Corporation                */
/*--------------------------------------------------------------------------*/
#define MAX_SECS_MSG_LEN    0x10000     // Maximum SECS-2 Msg Byte Size
#define MAX_PP_MGR_TAB  256             // Formatted Procee Program
#define MAX_TR_MGR_TAB  256             // Trace info tab volume

typedef ULONG   TVID;                   // VID data type
typedef ULONG   TDVID;                  // DVVALID data type
typedef ULONG   TCEID;                  // CEID
typedef ULONG   TRPID;                  // Report ID
typedef ULONG   TECID;                  // ECID
typedef ULONG   TSVID;                  // SVID
typedef BYTE    TALCD;                  // ALCD
typedef ULONG   TALID;                  // ALID
typedef ULONG   TDATAID;                // DATAID
typedef ULONG   TDATALENGTH;            // DATALENGTH(mulit-block)
typedef ULONG   TLENGTH;                // LENGTH(mulit-block S7F29)
typedef int     TALED;                  // Alarm Enable
typedef int     TPTN;                   // Loader Port number
typedef int     TLIMITID;               // VID limit od

typedef BYTE    *TPPID;                 // Process Program ID
typedef BYTE    *TTRID;                 // Trace ID

/*---------------------------------------------------------------------*/
#define SZ_TVID         1               // VID data type
#define SZ_TDVID        1               // DVID data type
#define SZ_TCEID        1               // CEID
#define SZ_TRPID        1               // Report ID
#define SZ_TECID        1               // ECID
#define SZ_TSVID        1               // SVID
#define SZ_TALCD        1               // ALCD
#define SZ_TALID        1               // ALID
#define SZ_TDATAID      1               // DATAID
#define SZ_TDATALENGTH  1               // DATALENGTH(mulit-block)
#define SZ_TLENGTH      1               // LENGTH(mulit-block S7F29)
#define SZ_TALED        1               // Alarm Enable
#define SZ_TPTN         1               // Loader Port number
#define SZ_TLIMITID     1               // VID limit od

#define SZ_TPPID        8               // PPID
#define SZ_TTRID        8               // TRID

/*---------------------------------------------------------------------*/
/* Œ`ꂽ^CvSECS data item formatŕ\                   */
/*---------------------------------------------------------------------*/
#define FMT_VID     ICODE_U4            // VID item format
#define FMT_DVID    ICODE_U4            // DVID item format
#define FMT_CEID    ICODE_U4            // CEID
#define FMT_SVID    ICODE_U4            // SVID
#define FMT_ECID    ICODE_U4            // ECID
#define FMT_RPID    ICODE_U4            // REPORT ID
#define FMT_ALID    ICODE_U4            // AlarmID
#define FMT_ALCD    ICODE_B             // Alarm Code
#define FMT_DATAID  ICODE_U4            // DATAID
#define FMT_PTN     ICODE_U1            // Loader Port Number
#define FMT_TALED   ICODE_B             // alarm enable
#define FMT_DATALENGTH ICODE_U4         // DATALENGTH(mulit-block)
#define FMT_LENGTH  ICODE_U4            // LENGTH(mulit-block  S7F29)
#define FMT_LIMITID ICODE_B             // LIMIT ID(VID)

#define FMT_PPID    ICODE_A             // PPID
#define FMT_PPBODY  ICODE_A             // PPBODY
#define FMT_TRID    ICODE_A             // TRID

#define FMT_SMPLN   ICODE_U2            // Trace sample number
#define FMT_CARID   ICODE_A             // Carrier ID
#define FMT_PRJID   ICODE_A             // Process Job ID
#define FMT_OBJID   ICODE_A             // Control Job ID
#define FMT_SUBSTID ICODE_A             // Substrate ID
/*---------------------------------------------------------------------*/
/* ALTX̒                                                          */
/*---------------------------------------------------------------------*/
#define LEN_ALTX    40                  // altx ޲Ē
#define DATAID_INC_VALUE 1              // dataid XVݒl

/*---------------------------------------------------------------------*/
/* SV Communication State Definition                                   */
/*---------------------------------------------------------------------*/
#define ST_COMM_DISABLED           0
#define ST_COMM_ENABLED            1
#define ST_NOT_COMMUNICATING       2
#define ST_WAIT_CRA                3
#define ST_WAIT_DELAY              4
#define ST_COMMUNICATING           5

/*---------------------------------------------------------------------*/
/* PortStatus                                                          */
/*---------------------------------------------------------------------*/
// Port Transfer status
#define ST_PortTrOutOfService           0
#define ST_PortTrTransferBlocked        1
#define ST_PortTrReadyToLoad            2
#define ST_PortTrReadyToUnload          3

// Association State
#define ST_PortNotAssociated            0
#define ST_PortAssociated               1

/*---------------------------------------------------------------------*/
/* Carrier ֘A status                                                 */
/*---------------------------------------------------------------------*/
// Carrier ID status
#define ST_CarIdNotRead                 0
#define ST_CarIdWaitingForHost          1
#define ST_CarIdVerificationOK          2
#define ST_CarIdVerificationFail        3
#define ST_CarIdNotExist                4

/*---------------------------------------------------------------------*/
// Carrier Processing Status
#define ST_CarProcNotAccess             0
#define ST_CarProcInAccess              1
#define ST_CarProcComplete              2
#define ST_CarProcStopped               3
#define ST_CarProcNotExist              4

/*---------------------------------------------------------------------*/
// LotMap Status
#define ST_SlotMapNotRead               0
#define ST_SlotMapWaitingForHost        1
#define ST_SlotMapVerificationOK        2
#define ST_SlotMapVerificationFail      3
#define ST_SlotNotExist                 4

/*---------------------------------------------------------------------*/
// Carrier Usage
#define USAGE_Product                   "PRODUCT"
#define USAGE_NPW                       "NPW"

/*---------------------------------------------------------------------*/
// Location                                                            */
#define LOC_PT1_UNDOCK                  "L11"
#define LOC_PT1_DOCK                    "L12"
#define LOC_PT2_UNDOCK                  "L21"
#define LOC_PT2_DOCK                    "L22"
#define LOC_PT3_UNDOCK                  "L31"
#define LOC_PT3_DOCK                    "L32"

/*---------------------------------------------------------------------*/
// Substate Status
#define ST_AtSource                     0
#define ST_AtWork                       1
#define ST_AtDestinatin                 2

// Substate ProcState
#define ST_SUBST_NeedsProcessing        0
#define ST_SUBST_InProcess              1
#define ST_SUBST_Processed              2
#define ST_SUBST_Aborted                3
#define ST_SUBST_Stopped                4
#define ST_SUBST_Rejected               5
#define ST_SUBST_Lost                   6

// Substate LocState
#define ST_SUBST_Unoccupied             0
#define ST_SUBST_Occupied               1

// Substate Type
#define SUBST_TYPE_Wafer                0
#define SUBST_TYPE_FlatPanel            1
#define SUBST_TYPE_CD                   2
#define SUBST_TYPE_Mask                 3

// Substate Usage
#define SUBST_USAGE_Product             0
#define SUBST_USAGE_Test                1
#define SUBST_USAGE_Filler              2

// Substate IdStatus
#define ST_SUBST_NotConfirmed           0
#define ST_SUBST_WaitingForHost         1
#define ST_SUBST_Confirmed              2
#define ST_SUBST_ConfirmationFailed     3
/*---------------------------------------------------------------------*/
// Control Job State
#define ST_CJ_Queued                    0
#define ST_CJ_Selected                  1
#define ST_CJ_WaitingForHost            2
#define ST_CJ_Executing                 3
#define ST_CJ_Paused                    4
#define ST_CJ_Completed                 5
/*---------------------------------------------------------------------*/
// Process Job State
#define ST_PRJ_Pooled                   0
#define ST_PRJ_Settingup                1
#define ST_PRJ_WaitingForHos            2
#define ST_PRJ_Processing               3
#define ST_PRJ_ProcessComplete          4
#define ST_PRJ_Reserved                 5
#define ST_PRJ_Pausing                  6
#define ST_PRJ_Paused                   7
#define ST_PRJ_Stopping                 8
#define ST_PRJ_Aborting                 9
/*---------------------------------------------------------------------*/
// Process Job State
#define ST_PRJ_Pooled                   0
#define ST_PRJ_Settingup                1
#define ST_PRJ_WaitingForHos            2
#define ST_PRJ_Processing               3
#define ST_PRJ_ProcessComplete          4
#define ST_PRJ_Reserved                 5
#define ST_PRJ_Pausing                  6
#define ST_PRJ_Paused                   7
#define ST_PRJ_Stopping                 8
#define ST_PRJ_Aborting                 9
/*---------------------------------------------------------------------*/
// Process Job Command
#define CM_ABORT                        0
#define CM_STOP                         1
#define CM_CANCEL                       2
#define CM_PAUSE                        3
#define CM_RESUME                       4


/*---------------------------------------------------------------------*/
/* SV ControlState Definition                                          */
/*---------------------------------------------------------------------*/
#define ST_CONTROL_OFFLINE         0
#define ST_CONTROL_LOCAL           1      // ONLINE & LOCAL
#define ST_CONTROL_REMOTE          2      // ONLINE & REMOTE

/*---------------------------------------------------------------------*/
/* EC_PortAccessMode Definition                                        */
/*---------------------------------------------------------------------*/
#define ST_ACCESS_MANUAL_MODE      0
#define ST_ACCESS_AUTO_MODE        1
/*---------------------------------------------------------------------*/
/* \CEIDCfbNX                                                */
/*---------------------------------------------------------------------*/
#define CEX_RSV_COMMUNICATING       0           // Communicating
#define CEX_RSV_SPOOL_END           1           // Spool End
#define CEX_RSV_LIMIT               2           // Limit Check 
/*---------------------------------------------------------------------*/
/* \ϐCfbNX  EC,SV,DVVAL                                   */
/*---------------------------------------------------------------------*/
#define ECX_RSV_MDLN                0           // EQ model name
#define ECX_RSV_SOFTREV             1           // EQ soft rev
#define ECX_RSV_SPOOL_MAX           2           // EQ max spool transmit
#define ECX_RSV_SPOOL_OVERWRITE     3           // EQ max spool over write
#define ECX_RSV_INIT_COMMSTATE      4           // EQ InitCommState
#define ECX_RSV_SPOOL_ENABLE        5           // EQ spool enable

#define SVX_RSV_CLOCK               0           // EQ system clock
#define SVX_RSV_COMMUNICATING       1           // EQ Comm State
#define SVX_RSV_SPOOL_STATE         2           // EQ spool state
#define SVX_RSV_SPOOL_TOTAL         3           // EQ spool total count
#define SVX_RSV_SPOOL_ACTUAL        4           // EQ spool actual count
#define SVX_RSV_SPOOL_STIME         5           // EQ spool start time
#define SVX_RSV_SPOOL_FTIME         6           // EQ spool full time
#define SVX_RSV_LIMIT_VID	        7           // EQ limit ck vid
#define SVX_RSV_LIMIT_DVVAL	        8           // EQ limit variable value
#define SVX_RSV_LIMIT_ID	        9           // EQ limit_id
#define SVX_RSV_LIMIT_DIR	        10          // EQ limit change direction

/*---------------------------------------------------------------------*/
/**  SECS-II Message Data Format Set/Get Index                         */
/*   for GemSetDataFormat()                                            */
/*---------------------------------------------------------------------*/
#define     X_FMT_ALID              0           // S5F1 ALID
#define     X_FMT_VID               1           // ECID
#define     X_FMT_ECID              2           // DVID  
#define     X_FMT_DVID              3           // SVID
#define     X_FMT_SVID              4           // LIMITID
#define     X_FMT_LIMITID           5           // Variable Limit ID
#define     X_FMT_TRID              6           // Trace ID
#define     X_FMT_SMPLN             7           // Sampling number
#define     X_FMT_RPID              8           // Report ID
#define     X_FMT_CEID              9           // CE ID
#define     X_FMT_DATAID            10          // DataID
#define     X_FMT_PPID              11          // PPID  (S7F3)
#define     X_FMT_PPBODY            12          // PPBODY(S7F3)
#define     X_FMT_LENGTH            13          // S7F1
#define     X_FMT_PTN               14          // Port No.
#define     X_FMT_DATALENGTH        15          // S6F5

/*---------------------------------------------------------------------*/
#define CAR_CAPACITY                25          // Car Capacity

#define ALTX_LEN                    40          // S5F1 altx length
#define LEN_ALTX                    40          // altx ޲Ē

#define DATAID_INC_VALUE            1           // dataid XVݒl

/*----- Enf of File --------------------------------------------------------*/
