/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEng4 - GEM, GEM300 Library Program Package                           */
/*                                                                          */
/*    os.h       - OS selection    p                                        */
/*                                                                          */
/*  Copyright (c)2009 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#define OS_WINDOWS         0
#define OS_REDHAT_LINUX    1
#define OS_SOLARIS         2

//#define ENG_OS      OS_WINDOWS
#define ENG_OS      OS_REDHAT_LINUX


//===== WINDOWS ===============================================================
#if ENG_OS == OS_WINDOWS

    #define T_MUTEX                     HANDLE

    #define CREATE_MUTEX()              CreateMutex(0,0,0)
    #define CLOSE_MUTEX(a)              CloseHandle(a)
    #define GET_MUTEX(a,b)              WaitForSingleObject(a,b)
    #define RLS_MUTEX(a)                ReleaseMutex(a)

    #define CREATE_EVENT(a,b,c,d)       CreateEvent(a,b,c,d)
    #define CLOSE_EVENT(a)              CloseHandle(a)
    #define WAIT_EVENT(a,b)             WaitForSingleObject(a,b)
    #define SET_EVENT(a)                SetEvent(a)
    #define RESET_EVENT(a)              ResetEvent(a)

    #define CLOSE_MSGQ(a)               NoOperation()

    #define END_THREAD(a)               _endthreadex(a)
//-----------------------------------------------------------------------------
    #define TT_MSG                      MSG
    #define Z_SEPC  '\\'
    #define Z_SEPW  "\\"

#endif

//===== REDHAT LINUX ==========================================================
#if ENG_OS == OS_REDHAT_LINUX
    #define GetCurrentDirectory(a, b)   getcwd(b, a)
    #define SetEvent(a)                 EVT_send(a)
    #define WaitForSingleObject(a, b)   EVT_wait(a, b)
    #define CreateEvent(a, b, c, d)     EVT_create()
    #define DshWaitForEventA(a, b, c)   EVT_wait(a, b)

    //#define CreateMutex(a,b,c)          dsh_create_mutex()
    #define CREATE_MUTEX()              dsh_create_mutex()
    #define GET_MUTEX(a,b)              dsh_lock_mutex(a)
    #define RLS_MUTEX(a)                dsh_unlock_mutex(a)

    #define CLOSE_MUTEX(a)              dsh_destroy_mutex(a)

    #define CREATE_EVENT(a,b,c,d)       EVT_create()
    #define CLOSE_EVENT(a)              EVT_close(a)
    #define WAIT_EVENT(a,b)             EVT_wait(a,b)
    #define SET_EVENT(a)                EVT_send(a)
    #define RESET_EVENT(a)              EVT_kill(a)

    #define CLOSE_MSGQ(a)               TMSGQ_close(a)

    #define END_THREAD(a)               dsh_exit_thread()

    #define DshRmvWakeup(a)             NoOperation()

    #define ReleaseMutex(a)            dsh_unlock_mutex(a)
    #define _stricmp(a,b)              strcasecmp(a,b)
    #define Sleep(a)                   usleep(a*1000)
    #define Beep(a,b)                  beep()
    #define _unlink(a)                 unlink(a)
    #define GetLocalTime(a)            DshMakeSystemTime(a)
    #define _atoi64(a)                 atoi64(a)
    #define DshSetDateTimeX(a)         DshSetDateTime(a)
//-----------------------------------------------------------------------------
    #define TT_MSG                      TMSG
    #define HANDLE                      int
    #define HKEY                        int
    #define Z_SEPC  '/'
    #define Z_SEPW  "/"
#endif



