/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_alope.c                           */
/*                                                              */
/*  Produald by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     al_list( void );
int     al_ginfo( void );
int     al_galed( void );
int     al_saled( void );
/*-----------------------------------------------------------*/
static  char    cbuf[KEY_BUFF_SIZE];

/*-----------------------------------------------------------*/
static  char    *al_menu[] = {                          // menu
        "  q       : quit",
        "  h       : help",
        "  list    : get list",
        "  ginfo   : get infomation",
        "  galed   : get enable state",
        "  saled   : set enable state",
        NULL
        };
/*-----------------------------------------------------------*/
static  TEST_CMD_TAB    al_cmd_tab[] = {                // cmd name & function
        { "Q",        0 },
        { "H",        0 },
        { "LIST",     al_list },
        { "GINFO",    al_ginfo },
        { "GALED",    al_galed },
        { "SALED",    al_saled },
        { NULL,       0 }
        };
/*-----------------------------------------------------------*/
// p_al() - Alarm
/*-----------------------------------------------------------*/
int     p_AL( void )
{
        int     i;
    Gprintf( "*----- AL operation --------*\n" );
    test_menu( al_menu );
    while( 1 ){
        input_line( "AL> : ", cbuf );
        if ( strlen(cbuf) == 0 ) continue;
        i = test_cmd_go( cbuf, al_cmd_tab );
        if ( i == 0 ) break;                    // Quit
        if ( i == 1 ){                          // Help
            Gprintf( "*----- AL operation --------*" );
            test_menu( al_menu );
            continue;
        }
    }
    return 1000;
}

/*-----------------------------------------------------------*/
// al_list() - display all AL id and name list
/*-----------------------------------------------------------*/
int     al_list( void )
{
        int     ei;
        int     i;
        TBIN_DLIST  *lptr;
    ei = EngGetAlList( &lptr );                             // *lptr̓e TBIN_DLIST
    if ( ei == 0 ){
        Gprintf( "  # of id = %d\n", lptr->count );
        if ( lptr->count > 0 ){
            Gprintf( "----- AL id and name list -----------\n" );
            for ( i=0; i < lptr->count; i++ ){
                Gprintf( " %3d. id:%6d  name: %s\n", i+1, lptr->id_list[i], lptr->name_list[i] );
            }
        }
        DshFreeTBIN_DLIST( lptr );                          // release TBIN_DLIST memory
    }else{
        Gprintf( " !! EngGetAllist() error\n ");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// al_ginfo() - get all info and display
/*-----------------------------------------------------------*/
int     al_ginfo( void )
{
        TALID   id;
        int     ei;
        TAL_INFO info;
    while( 1 ){
        input_line( "AL> GINFO - ALID (0=end) : ", cbuf );  // input ALID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   ALID = %d\n", id );
        ei = EngGetAlInfo( id, &info );                     // get information
        if ( ei < 0 ){
            Gprintf( " !! ALID %d inval;id\n" );
            continue;
        }
        Gprintf("        name    = %s\n", info.name );
        Gprintf("        alcd    = %d\n", info.alcd );
        Gprintf("        altx    = %s\n", info.altx );
        Gprintf("        aled    = %d\n", info.aled );
        if ( info.ceid_on != 0 ){
            Gprintf("        ceid_on = %6d  %s \n", info.ceid_on, info.ceon_name );
        }
        if ( info.ceid_off != 0 ){
            Gprintf("        ceid_off= %6d  %s \n", info.ceid_off, info.ceoff_name );
        }
        Gprintf("\n");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// al_galed() - get aled
/*-----------------------------------------------------------*/
int     al_galed( void )
{
        TALID   id;
        int     ei;
    while( 1 ){
        input_line( "AL> GALED ALID (0=end) : ", cbuf );    // input ALID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   ALID = %d\n", id );
        ei = EngGetAlEnabled( id );                         // get ALED
        if ( ei < 0 ){
            Gprintf(" !! ALID invalid\n" );
            continue;
        }
        Gprintf( "      ALED = %d\n", ei );
        Gprintf("\n");
    }
    return 0;
}

/*-----------------------------------------------------------*/
// al_saled() - set ALED
/*-----------------------------------------------------------*/
int     al_saled( void )
{
        TALID   id;
        int     ei;
        int     aled;
    while( 1 ){
        input_line( "AL> SALED ALID (0=end) : ", cbuf );    // input ALID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   ALID = %d\n", id );
        ei = EngGetAlEnabled( id );                         // get ALED
        if ( ei < 0 ){
            Gprintf( " !! ALID %d inval;id\n" );
            continue;
        }
        input_line( "AL> ALED(0/1) = ", cbuf );
        aled = atoi( cbuf );
        if ( aled > 0 ) aled = 1;
        ei = EngSetAlEnabled( id, aled );                   // set aled
        ei = EngGetAlEnabled( id );                         // get ALED for examination
        if ( ei < 0 ){
            continue;
        }
        Gprintf( "        --> ALED after setting = %d\n", ei );
        Gprintf("\n");
    }
    return 0;
}

/*----- End Of File -----------------------------------------*/
