/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_ceope.c                           */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     ce_list( void );
int     ce_ginfo( void );
int     ce_gceed( void );
int     ce_sceed( void );
/*-----------------------------------------------------------*/
static  char    cbuf[KEY_BUFF_SIZE];
/*-----------------------------------------------------------*/
static  char    *ce_menu[] = {                          // menu
        "  q       : quit",
        "  h       : help",
        "  list    : get list",
        "  ginfo   : get infomation",
        "  gceed   : get enable state",
        "  sceed   : set enable state",
        NULL
        };
/*-----------------------------------------------------------*/
static  TEST_CMD_TAB    ce_cmd_tab[] = {                // cmd name & function
        { "Q",        0 },
        { "H",        0 },
        { "LIST",     ce_list },
        { "GINFO",    ce_ginfo },
        { "GCEED",    ce_gceed },
        { "SCEED",    ce_sceed },
        { NULL,       0 }
        };
/*-----------------------------------------------------------*/
// p_ce() - Collection Event
/*-----------------------------------------------------------*/
int     p_CE( void )
{
        int     i;
    Gprintf( "*----- CE operation --------*\n" );
    test_menu( ce_menu );
    while( 1 ){
        input_line( "CE> : ", cbuf );
        if ( strlen(cbuf) == 0 ) continue;
        i = test_cmd_go( cbuf, ce_cmd_tab );
        if ( i == 0 ) break;                    // Quit
        if ( i == 1 ){                          // Help
            Gprintf( "*----- CE operation --------*" );
            test_menu( ce_menu );
            continue;
        }
    }
    return 1000;
}

/*-----------------------------------------------------------*/
// ce_list() - display all CE id and name list
/*-----------------------------------------------------------*/
int     ce_list( void )
{
        int     ei;
        int     i;
        TBIN_DLIST  *lptr;
    ei = EngGetCeList( &lptr );                      // *lptr̓e TBIN_DLIS
    if ( ei == 0 ){
        Gprintf( "  # of id = %d\n", lptr->count );
        if ( lptr->count > 0 ){
            Gprintf( "----- CE id and name list -----------\n" );
            for ( i=0; i < lptr->count; i++ ){
                Gprintf( " %3d. id:%6d  name: %s\n", i+1, lptr->id_list[i], lptr->name_list[i] );
            }
        }
        DshFreeTBIN_DLIST( lptr );                  // release TBIN_DLIST memory
    }else{
        Gprintf( " !! EngGetCelist() error\n ");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// ce_ginfo() - get all info and display
/*-----------------------------------------------------------*/
int     ce_ginfo( void )
{
        TCEID   id;
        int     ei;
        int     i;
        TCE_INFO info;
    while( 1 ){
        input_line( "CE> GINFO CEID (0=end) : ", cbuf );      // input CEID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   CEID = %d\n", id );
        ei = EngGetCeInfo( id, &info );               // get information
        if ( ei < 0 ){
            Gprintf( " !! CEID %d inval;id\n" );
            continue;
        }
        Gprintf("        name    = %s\n", info.name );
        Gprintf("        ceed    = %d\n", info.ceed );
        Gprintf("        # of rp = %d\n", info.rp_count );
        for ( i=0; i < info.rp_count; i++ ){
            Gprintf("          %2d. rpid=%6d  %s\n", i+1, info.rpid[i], info.rpname[i] );
        }
        Gprintf("\n");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// ce_gceed() - get ceed
/*-----------------------------------------------------------*/
int     ce_gceed( void )
{
        TCEID   id;
        int     ei;
    while( 1 ){

        input_line( "CE> GCEED CEID (0=end) : ", cbuf );      // input CEID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   CEID = %d\n", id );
        ei = EngGetCeEnabled( id );                  // get CEED
        if ( ei < 0 ){
            Gprintf(" !! CEID invalid\n" );
            continue;
        }
        Gprintf( "      CEED = %d\n", ei );
        Gprintf("\n");
    }
    return 0;
}

/*-----------------------------------------------------------*/
// ce_sceed() - set CEED
/*-----------------------------------------------------------*/
int     ce_sceed( void )
{
        TCEID   id;
        int     ei;
        int     ceed;
    while( 1 ){
        input_line( "CE> SCEED CEID (0=end) : ", cbuf );    // input CEID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   CEID = %d\n", id );
        ei = EngGetCeEnabled( id );                   // get CEED
        if ( ei < 0 ){
            Gprintf( " !! CEID %d inval;id\n" );
            continue;
        }
        input_line( "CE> CEED(0/1) = ", cbuf );
        ceed = atoi( cbuf );
        if ( ceed > 0 ) ceed = 1;
        ei = EngSetCeEnabled( id, ceed );            // set ceed
        ei = EngGetCeEnabled( id );                  // get CEED for examination
        if ( ei < 0 ){
            continue;
        }
        Gprintf( "        --> CEED after setting = %d\n", ei );
        Gprintf("\n");
    }
    return 0;
}

/*----- End Of File -----------------------------------------*/
