/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_cmdprc.c                          */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     p_quit( void );
int     p_help( void );
int     p_enable( void );
int     p_disable( void );
int     p_s5f1( void );
int     p_s6f11( void );
int     p_s10f1( void );
int     p_EC( void );
int     p_SV( void );
int     p_DV( void );
int     p_CE( void );
int     p_RP( void );
int     p_AL( void );
int     p_SIM( void );
int     p_rcpmsg( void );
int     p_prjmsg( void );

static  HANDLE  input_mutex = 0;

//=============================================================

/* main menu ------------------------------------------------*/

static  char *menu_list[] = {
        "----- main command menu -----",
        "  Q       : Quit operation",
        "  H       : Help",
        "  RCPMSG  : Recipe Message(S7F3/S7F23/S15F13)",
        "  PRJMSG  : Process Job Message(S16F11/S16F15)",
        "  ENABLE  : Enable communication",
        "  DISABLE : Disable communication",
        "  S5F1    : Send Alarm",
        "  S6F11   : Send Event",
        "  S10F1   : Send Terminal Msg",
        "  EC      : EC - Equipment Constant",
        "  SV      : SV - Status Variable",
        "  DV      : DVVAL - Data Varibale",
        "  CE      : Collection Event",
        "  RP      : Report",
        "  AL      : Alarm",
        "  SIM     : Simulation - Wafer Processing",
        NULL
        };

/*-----------------------------------------------------------*/
// TEST_CMD_TAB - command
/*-----------------------------------------------------------*/
static  TEST_CMD_TAB    cmd_tab[] = {
        { "Q",        0 },
        { "H",        0 },
        { "RCPMSG",   p_rcpmsg },
        { "PRJMSG",   p_prjmsg },
        { "ENABLE",   p_enable },
        { "DISABLE",  p_disable },
        { "S6F11",    p_s6f11 },
        { "S5F1",     p_s5f1 },
        { "S10F1",    p_s10f1 },
        { "EC",       p_EC },
        { "SV",       p_SV },
        { "DV",       p_DV },
        { "CE",       p_CE },
        { "RP",       p_RP },
        { "AL",       p_AL },
        { "SIM",      p_SIM },
        { NULL,       0 }
        };

static  char    cbuf[KEY_BUFF_SIZE];
/*-----------------------------------------------------------*/
// test_cmd_proc()
/*-----------------------------------------------------------*/
void    test_cmd_proc( void )
{
        int     i;
    Gprintf( "*----- DSHENG4 Test -----------------------*\n");
    test_menu( menu_list );
    while( 1 ){
        input_line( "MAIN> : ", cbuf );
        dsh_trim( cbuf );
        if ( strlen(cbuf) == 0 ) continue;
        i = test_cmd_go( cbuf, cmd_tab );
        if ( i == 0 ) break;                    // Quit
        if ( i == 1 ){                          // Help
            Gprintf( "\n" );
            test_menu( menu_list );
            continue;
        }
    }
}
/*-----------------------------------------------------------*/
// input_line() -  Key Input
/*-----------------------------------------------------------*/
int     input_line( char *prompt, char *buff )
{
        int     i;
        int     c;
    if ( input_mutex == 0 ){
        input_mutex = CREATE_MUTEX();
    }
    GET_MUTEX( input_mutex, 1000000 );
    printf( prompt );
    for ( i=0, buff[0] = '\0'; i < KEY_BUFF_SIZE; ){
        c = getchar();
        if ( c == '\r' || c == '\n' ){
            break;
        }
        if ( c == '\b' ){
            if ( i > 0 ){ i--; buff[i] = 0; putchar('\b'); putchar('\b'); }
        }else{
            buff[i++] = c;
            buff[i] = '\0';
        }
    }
    if ( i >= KEY_BUFF_SIZE ){
        buff[KEY_BUFF_SIZE-1] = '\0';
    }
    Nprintf( "%s%s\n", prompt, buff );      // log ( file )
    RLS_MUTEX( input_mutex );
    return strlen( buff );
}
/*-----------------------------------------------------------*/
// test_menu() - display menu
/*-----------------------------------------------------------*/
void    test_menu( char *menu[] )
{
        int     i;
    Gprintf( "\n" );
    for ( i=0; menu[i] != NULL; i++ ){
        Gprintf( "%s\n", menu[i] );
    }
}
/*-----------------------------------------------------------*/
// test_cmd_go() - menu command function execution
/*-----------------------------------------------------------*/
int     test_cmd_go( char *cbuf, TEST_CMD_TAB   cmd_tab[] )
{
        int     i;
    dsh_lower_to_upper_str( cbuf );
    for ( i=0; cmd_tab[i].cmd_name != NULL; i++ ){          // scan command
        if ( strcmp( cbuf, cmd_tab[i].cmd_name ) == 0 ){
            if ( cmd_tab[i].func != 0 ){                    // execute
                (cmd_tab[i].func)( );
            }
            return i;
        }
    }
    Gprintf( "??\n" );
    return (-1);
}
/*-----------------------------------------------------------*/
// p_quit(), p_help()
/*-----------------------------------------------------------*/
int     p_quit( void ){ return 0; }
int     p_help( void ){ return 0; }
/*----- End Of File -----------------------------------------*/
