/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_comm.c                            */
/*                                                              */
/*  Produald by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     p_EngEnableCallback( int end_status, ULONG upara );
int     p_EngDisableCallback( int end_status, ULONG upara );

static  int     comm_stat;
/*-----------------------------------------------------------*/
// p_enable() - Enable communication
/*-----------------------------------------------------------*/
int     p_enable( void )
{
        int     ei;
    comm_stat = 1;
    ei = EngEnable( p_EngEnableCallback, 113 );
    Gprintf( "    Enable() ei=%d\n", ei );
    if ( ei != 0 ){
        comm_stat = 0;
    }
    return 0;
}
/*-----------------------------------------------------------*/
// p_disable() - Disable communication
/*-----------------------------------------------------------*/
int     p_disable( void )
{
        int     ei;
    ei = EngDisable( 0, p_EngDisableCallback, 114 );
    Gprintf( "    Disable() ei=%d\n", ei );
    return 0;
}
/*-----------------------------------------------------------*/
// p_EngEnableCallback()
/*-----------------------------------------------------------*/
int     p_EngEnableCallback( int end_status, ULONG upara )
{
    Gprintf( "\n" );
    Gprintf( "    -->EngEnable() Callback(  status=%d upara=%d )\n",
                                        end_status, upara );
    if ( end_status == 0 ) comm_stat = ST_COMMUNICATING;
    else comm_stat = 0;
    return 0;
}
/*-----------------------------------------------------------*/
// p_EngDisableCallback()
/*-----------------------------------------------------------*/
int     p_EngDisableCallback( int end_status, ULONG upara )
{
    Gprintf( "\n" );
    Gprintf( "    -->EngDisable() Callback(  status=%d upara=%d )\n",
                                        end_status, upara );
    if ( end_status == 0 ) comm_stat = 0;
    return 0;
}
/*-----------------------------------------------------------*/
// p_get_comm_stat()
/*-----------------------------------------------------------*/
int     p_get_comm_stat( void )
{
    return comm_stat;
}
