/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                              */
/*                                                              */
/*              file name : g_dspinf.c                          */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/
#include "all.h"
/*-----------------------------------------------------------*/
// disp_car_info()
/*-----------------------------------------------------------*/
void    disp_car_info( TCAR_INFO *info )
{
        int         i;
		TSLOT_INFO  *slot;
//------------1234567890123456789012345678901234567890123456789012345678901234
    Gprintf( "----- Carrier Information --------------------------------------\n" ); 
    Gprintf( "    carid      = %s\n", info->carid );
    Gprintf( "    capacity   = %d\n", info->capacity );
    Gprintf( "    usage      = %s\n", info->usage );
    Gprintf( "    location   = %s\n", info->location );
    Gprintf( "    map status = %d\n", info->map_status );
    Gprintf( "    acc status = %d\n", info->acc_status );
    Gprintf( "    Id  status = %d\n", info->id_status );
    Gprintf( "    slot count = %d\n", info->slot_count );
    if ( info->slot_count > 0 ){
        for ( i=0; i < info->slot_count; i++ ){
			slot = info->slot_list[i];
            Gprintf( "     %d \n", i );
            Gprintf( "       slotid  = %d\n", slot->slotid ); 
            Gprintf( "       mid     = %s\n", slot->mid ); 
            Gprintf( "       substid = %s\n", slot->substid ); 
            Gprintf( "       substloc= %s\n", slot->substloc ); 
        }
    }
}
/*-----------------------------------------------------------*/
// disp_pp_info()
/*-----------------------------------------------------------*/
void    disp_pp_info( TPP_INFO *info )
{
//------------1234567890123456789012345678901234567890123456789012345678901234
    Gprintf( "------ PP Information ------------------------------------------\n" );
    Gprintf( "        ppid    = %s\n", info->ppid );
    Gprintf( "        ppbody  = %s\n", info->ppbody );
}
/*-----------------------------------------------------------*/
// disp_fpp_info()
/*-----------------------------------------------------------*/
void    disp_fpp_info( TFPP_INFO *info )
{
        int         i, j;
        char        buff[256];
        TFPP_CCODE  **p;
//------------1234567890123456789012345678901234567890123456789012345678901234
    Gprintf( "------ FPP Information -----------------------------------------\n" );
    Gprintf( "        ppid    = %s\n", info->ppid );
    Gprintf( "        mdln    = %s\n", info->mdln );
    Gprintf( "        softrev = %s\n", info->softrev );
    Gprintf( "        ccode_count= %d\n", info->ccode_count );
    if ( info->ccode_count > 0 ){
        p = info->ccode_list;
        for ( i=0; i < info->ccode_count; i++ ){
            TFPP_CCODE *info_ccode;
            info_ccode = (TFPP_CCODE*)info->ccode_list[i];
            Gprintf( "        i-%d\n", i );
            Gprintf( "         ccode   = %s\n",(char*)info_ccode->ccode );
            Gprintf( "         ppara_count = %d\n", info_ccode->ppara_count );
            if ( info_ccode->ppara_count > 0 ){
                for ( j=0; j < info_ccode->ppara_count; j++ ){
                    TFPP_PARA *info_para; info_para = info_ccode->ppara_list[j];
                    Gprintf( "          j-%d\n", j );
                    data_to_string( info_para->ppara_fmt, info_para->ppara_size, (BYTE*)info_para->ppara, buff );
                    Gprintf( "            ppara   = %s\n", buff );
                }
            }
        }
    }
}
/*-----------------------------------------------------------*/
// disp_rcp_info()
/*-----------------------------------------------------------*/
void    disp_rcp_info( TRCP_INFO *info )
{
        int     i;
        char    buff[256];
//------------1234567890123456789012345678901234567890123456789012345678901234
    Gprintf( "----- RCP Information ------------------------------------------\n" );
    Gprintf( "    rcpid      = %s\n", info->rcpspec );
    Gprintf( "    rcpbody    = %s\n", info->rcpbody );
    Gprintf( "    para count = %d\n", info->para_count );
    for ( i=0; i < info->para_count; i++ ){
        TRCP_PARA *pinfo = info->para_list[i];
        Gprintf( "      i-%d\n", i );
        Gprintf( "        rcpparanm = %s\n", pinfo->rcpparnm );
        data_to_string( pinfo->par_fmt, pinfo->par_size, (BYTE*)pinfo->rcpparval, buff );
        Gprintf( "        rcpparval = %s\n", buff );
    }
}
/*-----------------------------------------------------------*/
// disp_prj_info()
/*-----------------------------------------------------------*/
void    disp_prj_info( TPRJ_INFO *info )
{
        int         i, j, n;
        char        buff[128];
        TCAR_INFO   *car_info;
        TSLOT_INFO  *slot_info;
        TRCP_INFO   rcp_info;
        TRCP_PARA   *rcp_para;
//------------1234567890123456789012345678901234567890123456789012345678901234
    Gprintf( "----- PRJ Information ------------------------------------------\n" );
    Gprintf( "    prjid    = %s\n", info->prjobid );
    Gprintf( "    mf       = %d\n", info->mf );
    Gprintf( "    carcount = %d\n", info->car_count );
    for ( i = 0; i < info->car_count; i++ ){
        car_info = info->car_list[i];
        Gprintf( "     i-%d\n", i );
        Gprintf( "      car_id    = %s\n", car_info->carid );
        Gprintf( "      slot_count= %d\n", car_info->slot_count );
        for ( j = 0; j < car_info->slot_count; j++ ){
            slot_info = car_info->slot_list[j];
            Gprintf( "       %d - slotid = %d\n", j ,  slot_info->slotid);
        }
        //---- RCP INFO ----
        Gprintf( "    prrcpmethod = %d\n", info->prrecipemethod );
        if (info->rcp_info != (TRCP_INFO*)NULL){
            rcp_info = *info->rcp_info;
            Gprintf( "    rcpspec    = %s\n",rcp_info.rcpspec);
            Gprintf( "    rcpbody    = %s\n",rcp_info.rcpbody );
            Gprintf( "    para count = %d\n", rcp_info.para_count );
            for ( j=0; j < rcp_info.para_count; j++ ){
                rcp_para = rcp_info.para_list[j];
                Gprintf( "     j-%d\n", j );
                if (rcp_para->rcpparnm != NULL ){
                    Gprintf( "       rcpparnm  = %s\n", rcp_para->rcpparnm);
                }
                if (rcp_para->rcpparval != NULL ){
                    data_to_string( rcp_para->par_fmt, rcp_para->par_size, (BYTE*)rcp_para->rcpparval, buff );
                    Gprintf( "       rcpparval = %s\n", buff );
                }
            }
        }
        Gprintf( "    prprocessstart = %d\n", info->prprocessstart );
        n = info->ceid_count;
        Gprintf( "    ceid_count = %d\n", info->ceid_count );
        for ( i=0; i < info->ceid_count; i++ ){
            Gprintf( "    pauseceid      = %d\n", info->pause_ceid_list[i] );
        }
    }
}

/*-----------------------------------------------------------*/
// disp_cj_info()
/*-----------------------------------------------------------*/
void    disp_cj_info( TOBJ_INFO *info )
{
        int     i, j, k, n;
        char    buff[256];
        TOBJ_ATTR_INFO *p;
        int         *sptr;
//------------1234567890123456789012345678901234567890123456789012345678901234
    Gprintf( "----- Object Information ---------------------------------------\n" );
    Gprintf( "    objspec = %s\n", info->objspec );
    Gprintf( "    objtype = %s\n", info->objtype );
    Gprintf( "    objid   = %s\n", info->objid   );
    //--------------------------------------------------------------
    n = info->attr_count;                    // attr 
    Gprintf( "    attr_count= %d\n", info->attr_count );
    if ( n > 0 ){
        for ( i=0; i < n; i++ ){
            p = (TOBJ_ATTR_INFO*) info->attr_list[i];
            Gprintf( "    i-%d\n", i );
            switch (p->attrid_index){
            //--------------------------------------------------------------
            case EN_ObjID:
                Gprintf ("      ObjID");
                Gprintf( "       objid    = %s\n", (char*)p->attrdata);
                break;
            //--------------------------------------------------------------
            case EN_CarrierInputSpec:
                Gprintf ("      CarrierInputSpec");
                if ( p->attrdata != NULL ){
                    TCJ_TEXT_INFO *ptext = (TCJ_TEXT_INFO*)p->attrdata;
                    for ( j=0; j < ptext->text_count; j++ ){
                        Gprintf( "        j-%d\n", i );
                        Gprintf( "          car in spec = %s\n", ptext->text_list[j] );
                    }
                }
                break;
              //--------------------------------------------------------------
            case EN_CurrentPRJob:
                Gprintf ("      Curretn PRJob");
                if ( p->attrdata != NULL ){
                    TCJ_TEXT_INFO *ptext = (TCJ_TEXT_INFO*)p->attrdata;
                    for ( j=0; j < ptext->text_count; j++ ){
                        Gprintf( "        j-%d\n", i );
                        Gprintf( "          current pr job = %s\n", ptext->text_list[j] );
                    }
                }
                break;
              //--------------------------------------------------------------
            case EN_DataCollectionPlan:
                Gprintf ("      DataCollectionPlan");
                Gprintf( "       data collect plan  = %s\n", (char*)p->attrdata);
                break;
              //--------------------------------------------------------------
            case EN_MtrlOutByStatus:
                Gprintf ("      MtrlOutByStatus");
                if ( p->attrdata != NULL ){
                    TVOID_LIST *pvoid;
                    pvoid = (TVOID_LIST*)p->attrdata;
                    Gprintf( "       count =%d\n", pvoid->count );
                    for ( j=0; j < pvoid->count; j++ ){
                        TMTRL_OUT_STAT *mostat;
                        mostat = (TMTRL_OUT_STAT*)pvoid->void_list[j];
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          mtrl_status = %d\n", mostat->mtrl_status );
                        Gprintf( "          carid       = %s\n", mostat->carid );
                        Gprintf( "          slot count  = %d\n", mostat->slot_count );
                        sptr = mostat->slotid_list;
                        for ( k=0; k < mostat->slot_count; k++ ){
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           slotid = %d\n", sptr[k]);
                        }
                    }
                }
                break;
              //--------------------------------------------------------------
            case EN_MtrlOutSpec:
                Gprintf ("      MtrlOutSpec");
                if ( p->attrdata != NULL ){
                    TVOID_LIST *pvoid;
                    pvoid = (TVOID_LIST*)p->attrdata;
                    Gprintf( "       count = %d\n", pvoid->count );
                    for ( j=0; j < pvoid->count; j++ ){
                        TMTRL_OUT_SPEC *mospec;
                        mospec = (TMTRL_OUT_SPEC*)pvoid->void_list[j];
                        Gprintf( "        j-%d\n", j );
                        //----- src
                        Gprintf( "          src carid     = %s\n", mospec->src_carid );
                        sptr = mospec->src_slotid_list;
                        Gprintf( "          src_slot_count = %d\n", mospec->src_slot_count );
                        for ( k=0; k < mospec->src_slot_count; k++ ){
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           src slotid = %d\n", sptr[k]);
                        }
                        //----- dst
                        Gprintf( "          dst carid     = %s\n", mospec->dst_carid );
                        sptr = mospec->dst_slotid_list;
                        Gprintf( "          dst_slot_count = %d\n", mospec->dst_slot_count );
                        for ( k=0; k < mospec->dst_slot_count; k++ ){
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           dst slotid = %d\n", sptr[k]);
                        }
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_PauseEvent:
                Gprintf ("      PauseEvent");
                if ( p->attrdata != NULL ){
                    int *ce_ptr; 
                    TPAUSE_EVENT *pause;
                    pause = (TPAUSE_EVENT*)p->attrdata;
                    Gprintf( "        ce_count = %d\n", pause->ce_count );
                    ce_ptr = pause->ceid_list;
                    for ( j=0; j < pause->ce_count; j++ ){
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          ceid   = %d\n", pause->ceid_list[j] );
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_ProcessingCtrlSpec:
                Gprintf ("      ProcessingCtrlSpec");
                if ( p->attrdata != NULL ){
                    TVOID_LIST *pvoid;
                    pvoid = (TVOID_LIST*)p->attrdata;
                    Gprintf( "       count = %d\n", pvoid->count );
                    for ( j=0; j < pvoid->count; j++ ){
                        TCTRL_SPEC *cspec;
                        cspec = (TCTRL_SPEC*)pvoid->void_list[j];
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          prjobid       = %s\n", cspec->prjobid );
                        Gprintf( "          ctrl rue count= %d\n", cspec->ctrl_rule_count );
                        for ( k=0; k < cspec->ctrl_rule_count; k++ ){
                            TCTRL_RULE *crule;
                            crule = (TCTRL_RULE*)cspec->ctrl_rule_list[k];
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           name   = %s\n", crule->name );
                            data_to_string( crule->fmt, crule->asize, (BYTE*)crule->value, buff );
                            Gprintf( "           value  = %s\n", buff );
                        }
                        Gprintf( "          out rule count= %d\n", cspec->out_rule_count );
                        for ( k=0; k <cspec->out_rule_count; k++ ){
                            {
                            TOUT_RULE *orule;
                            orule = (TOUT_RULE*)cspec->out_rule_list[k];
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           status = %d\n", orule->status );
                            data_to_string( orule->fmt, orule->asize, (BYTE*)orule->value, buff );
                            Gprintf( "           value  = %s\n", buff );
                            }
                        }
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_ProcessingOrderMgmt:
                Gprintf("      ProcessingOrderMgmt");
                Gprintf( "        order management = %d\n", (int)p->attrdata );
                break;
              //--------------------------------------------------------------
            case EN_PRJobStatusList:
                Gprintf ("      PRJobStatesList");
                if ( p->attrdata != NULL ){
                    TPRJ_STATE_LIST *pstat;
                    pstat = (TPRJ_STATE_LIST*)p->attrdata;
                    Gprintf( "       count = %d\n", pstat->prj_count );
                    for ( j=0; j < pstat->prj_count; j++ ){
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          prj name        = %s\n", pstat->prj_list[j] );
                        Gprintf( "          state           = %d\n", pstat->state_list[j] );
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_StartMethod:
                {
                int     method; 
                Gprintf ("      StartMethod");
                method = (int)p->attrdata;
                if ( method != 0 )
                    Gprintf ("        start method = True" );
                else
                    Gprintf ("        start method = False" );
                }
                break;
            //--------------------------------------------------------------
            case EN_State:
                {
                int dstate;
                Gprintf ("      State");
                dstate = (int)p->attrdata;
                Gprintf( "        state  = %d\n", dstate );
                }
                break;
            //--------------------------------------------------------------
            default:
                break;
            }
        }
    }
}




