/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                              */
/*                                                              */
/*              file name : g_dt_str.c                          */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/
#include    "all.h"
/*------------------------------------------------------------*/
// data_to_string()
/*------------------------------------------------------------*/
char    *data_to_string( int fmt, int asize, BYTE* ss, char *buff )
{
        int     usize;
        char    *fstr;
    buff[0] = 0;
    if ( ss == NULL ) return buff;
    usize = D_GetItemCodeSize( fmt );
    fstr = dsh_get_item_name( fmt );
    switch( fmt ){
        case ICODE_A:
        case ICODE_J:
            sprintf( buff, ("%s[%d] = \"%s\""), fstr, asize, ss );
            break;
        case ICODE_L:
            sprintf( buff, ("%s[%d]"), fstr, asize );
            break;
        case ICODE_B:
            sprintf( buff, ("%s[%d] = 0x%02x"), fstr, asize, *ss );
            break;
        case ICODE_BOOLEAN:
        case ICODE_U1:
            sprintf( buff, ("%s[%d] = %u"), fstr, asize, *ss );
            break;
        case ICODE_I1:
            sprintf( buff, ("%s[%d] = %d"), fstr, asize, *ss );
            break;
        case ICODE_I2:
            sprintf( buff, ("%s[%d] = %d"), fstr, asize, *(short*)ss );
            break;
        case ICODE_U2:
            sprintf( buff, ("%s[%d] = %u"), fstr, asize, *(USHORT*)ss );
            break;
        case ICODE_I4:
            sprintf( buff, ("%s[%d] = %d"), fstr, asize, *(int*)ss );
            break;
        case ICODE_U4:
            sprintf( buff, ("%s[%d] = %u"), fstr, asize, *(UINT*)ss );
            break;
        case ICODE_I8:
            sprintf( buff, ("%s[%d] = %I64d"), fstr, asize, *(INT64*)ss );
            break;
        case ICODE_U8:
            sprintf( buff, ("%s[%d] = %I64u"), fstr, asize, *(UINT64*)ss );
            break;
        case ICODE_F4:
            sprintf( buff, ("%s[%d] = %f"), fstr, asize, *(float*)ss );
            break;
        case ICODE_F8:
            sprintf( buff, ("%s[%d] = %f"), fstr, asize, *(double*)ss );
            break;
        default:
            strcpy(buff, "??? format" );
            break;
    }
    return buff;
}
/*------------------------------------------------------------*/
// set_data_value()
/*------------------------------------------------------------*/
void set_data_val( int fmt, char *strd, BYTE *ddd )
{
    memset( ddd, 0, 8 );
    switch( fmt ){
        case ICODE_A:
        case ICODE_J:
            ddd[0] = 0;
            if ( strlen(strd) > 0 ) strcpy( ddd, strd );
            break;
        case ICODE_L:
        case ICODE_B:
        case ICODE_BOOLEAN:
        case ICODE_I1:
        case ICODE_U1:
            *ddd = (BYTE)atoi( strd ) & 0xff;
            break;
        case ICODE_I2:
        case ICODE_U2:
            *(short*)ddd = (short)(atoi( strd ) & 0xffff);
            break;
        case ICODE_I4:
        case ICODE_U4:
            *(int*)ddd = atoi( strd ) & 0xffff;
            break;
        case ICODE_I8:
        case ICODE_U8:
            *(INT64*)ddd =atoll( strd );
            break;
        case ICODE_F4:
            *(float*)ddd = (float)atof( strd );
            break;
        case ICODE_F8:
            *(double*)ddd = (double)atof( strd );
            break;
        default:
            break;
    }
}
