/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_dvope.c                           */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     dv_list( void );
int     dv_ginfo( void );
int     dv_gval( void );
int     dv_dval( void );
/*-----------------------------------------------------------*/
static  char    cbuf[KEY_BUFF_SIZE];
/*-----------------------------------------------------------*/
static  char    *dv_menu[] = {                          // menu
        "  q       : quit",
        "  h       : help",
        "  list    : get list",
        "  ginfo   : get infomation",
        "  gval    : get value",
        "  dval    : set value",
        NULL
        };
/*-----------------------------------------------------------*/
static  TEST_CMD_TAB    dv_cmd_tab[] = {                // cmd name & function
        { "Q",        0 },
        { "H",        0 },
        { "LIST",     dv_list },
        { "GINFO",    dv_ginfo },
        { "GVAL",     dv_gval },
        { "DVAL",     dv_dval },
        { NULL,       0 }
        };
/*-----------------------------------------------------------*/
// p_dv() - Data Variable
/*-----------------------------------------------------------*/
int     p_DV( void )
{
        int     i;
    Gprintf( "*----- DV operation --------*\n" );
    test_menu( dv_menu );
    while( 1 ){
        input_line( "DV> : ", cbuf );
        if ( strlen(cbuf) == 0 ) continue;
        i = test_cmd_go( cbuf, dv_cmd_tab );
        if ( i == 0 ) break;                    // Quit
        if ( i == 1 ){                          // Help
            Gprintf( "*----- DV operation --------*" );
            test_menu( dv_menu );
            continue;
        }
    }
    return 1000;
}

/*-----------------------------------------------------------*/
// dv_list() - display all DV id and name list
/*-----------------------------------------------------------*/
int     dv_list( void )
{
        int     ei;
        int     i;
        TBIN_DLIST  *lptr;
    ei = EngGetDvList( &lptr );                      // *lptr̓e TBIN_DLIS
    if ( ei == 0 ){
        Gprintf( "  # of id = %d\n", lptr->count );
        if ( lptr->count > 0 ){
            Gprintf( "----- DV id and name list -----------\n" );
            for ( i=0; i < lptr->count; i++ ){
                Gprintf( " %3d. id:%6d  name: %s\n", i+1, lptr->id_list[i], lptr->name_list[i] );
            }
        }
        DshFreeTBIN_DLIST( lptr );                          // release TBIN_DLIST memory
    }else{
        Gprintf( " !! EngGetDvlist() error\n ");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// dv_ginfo() - get all infoand display
/*-----------------------------------------------------------*/
int     dv_ginfo( void )
{
        TDVID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
        char    str[1024];
        int     n;
    while( 1 ){
        input_line( "DV> DVID (0=end) : ", cbuf );                                 // input DVID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   DVID = %d\n", id );
        ei = EngGetDvFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! DVID %d inval;id\n" );
            continue;
        }
        ei = EngGetDvArraySize( id, &asize );        // get array size
        ei = EngGetDvName( id, (char*)ss, &n );      // get name
        Gprintf("        name    = %s\n", ss );
        Gprintf("        fmt     = %s (0x%x)\n", dsh_get_item_name(fmt), fmt );
        Gprintf("        asize   = %d\n", asize );
        ei = EngGetDvVal( id, ss, &asize );           // value
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        value   = %s\n", str );

        ei = EngGetDvNominal( id, ss, &asize );      // nominal
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        nominal = %s\n", str );

        ei = EngGetDvMin( id, ss, &asize );          // min
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        min     = %s\n", str );

        ei = EngGetDvMax( id, ss, &asize );          // max
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        max     = %s\n", str );

        ei = EngGetDvUnits( id, (char*)ss, &asize ); // units
        Gprintf("        units   = %s", ss );
        Gprintf("\n");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// dv_gval() - get DV value and display
/*-----------------------------------------------------------*/
int     dv_gval( void )
{
        TDVID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
        char    str[1024];
    while( 1 ){
        input_line( "DV> GVAL DVID (0=end) : ", cbuf );    // input DVID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   DVID = %d\n", id );
        ei = EngGetDvFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! DVID %d inval;id\n" );
            continue;
        }
        ei = EngGetDvArraySize( id, &asize );        // get array size
        ei = EngGetDvName( id, (char*)ss, &asize );  // get value
        ei = EngGetDvVal( id, ss, &asize );
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        value   = %s\n", str );
        Gprintf("\n");
    }
    return 0;
}

/*-----------------------------------------------------------*/
// dv_dval() - set DV value
/*-----------------------------------------------------------*/
int     dv_dval( void )
{
        TDVID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
    while( 1 ){
        input_line( "DV> DVAL DVID (0=end) : ", cbuf );                                 // input DVID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   DVID = %d\n", id );
        ei = EngGetDvFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! DVID %d inval;id\n" );
            continue;
        }
        ei = EngGetDvArraySize( id, &asize );        // get array size
        Gprintf( "        fmt     = %s (0x%x)\n", dsh_get_item_name(fmt), fmt );
        input_line( "DV> value = ", cbuf );
        memset( ss, 0, sizeof(ss) );
        set_data_val( fmt, cbuf, ss );
        ei = EngSetDvVal( id, (void*)ss, asize );    // set value
        Gprintf( "     result = %d\n", ei );
        Gprintf("\n");
    }
    return 0;
}

/*----- End Of File -----------------------------------------*/
