/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_ecope.c                           */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     ec_list( void );
int     ec_ginfo( void );
int     ec_gval( void );
int     ec_sval( void );
/*-----------------------------------------------------------*/
static  char    cbuf[KEY_BUFF_SIZE];
/*-----------------------------------------------------------*/
static  char    *ec_menu[] = {                          // menu
        "  q       : quit",
        "  h       : help",
        "  list    : get list",
        "  ginfo   : get infomation",
        "  gval    : get value",
        "  sval    : set value",
        NULL
        };
/*-----------------------------------------------------------*/
static  TEST_CMD_TAB    ec_cmd_tab[] = {                // cmd name & function
        { "Q",        0 },
        { "H",        0 },
        { "LIST",     ec_list },
        { "GINFO",    ec_ginfo },
        { "GVAL",     ec_gval },
        { "SVAL",     ec_sval },
        { NULL,       0 }
        };
/*-----------------------------------------------------------*/
// p_EC() - Equipment Constant
/*-----------------------------------------------------------*/
int     p_EC( void )
{
        int     i;
    Gprintf( "*----- EC operation --------*\n" );
    test_menu( ec_menu );
    while( 1 ){
        input_line( "EC> : ", cbuf );
        if ( strlen(cbuf) == 0 ) continue;
        i = test_cmd_go( cbuf, ec_cmd_tab );
        if ( i == 0 ) break;                    // Quit
        if ( i == 1 ){                          // Help
            Gprintf( "*----- EC operation --------*" );
            test_menu( ec_menu );
            continue;
        }
    }
    return 1000;
}

/*-----------------------------------------------------------*/
// ec_list() - display all EC id and name list
/*-----------------------------------------------------------*/
int     ec_list( void )
{
        int     ei;
        int     i;
        TBIN_DLIST  *lptr;
    ei = EngGetEcList( &lptr );                      // *lptr̓e TBIN_DLIS
    if ( ei == 0 ){
        Gprintf( "  # of id = %d\n", lptr->count );
        if ( lptr->count > 0 ){
            Gprintf( "----- EC id and name list -----------\n" );
            for ( i=0; i < lptr->count; i++ ){
                Gprintf( " %3d. id:%6d  name: %s\n", i+1, lptr->id_list[i], lptr->name_list[i] );
            }
        }
        DshFreeTBIN_DLIST( lptr );                          // release TBIN_DLIST memory
    }else{
        Gprintf( " !! EngGetEclist() error\n ");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// ec_ginfo() - get all infoand display
/*-----------------------------------------------------------*/
int     ec_ginfo( void )
{
        TECID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
        char    str[1024];
        int     n;
    while( 1 ){
        input_line( "EC> ECID (0=end) : ", cbuf );           // input ECID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   ECID = %d\n", id );
        ei = EngGetEcFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! ECID %d inval;id\n" );
            continue;
        }
        ei = EngGetEcArraySize( id, &asize );        // get array size
        ei = EngGetEcName( id, (char*)ss, &n );      // get name
        Gprintf("        name    = %s\n", ss );
        Gprintf("        fmt     = %s (0x%x)\n", dsh_get_item_name(fmt), fmt );
        Gprintf("        asize   = %d\n", asize );
        ei = EngGetEcVal( id, ss, &asize );          // value
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        value   = %s\n", str );

        ei = EngGetEcNominal( id, ss, &asize );      // nominal
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        nominal = %s\n", str );

        ei = EngGetEcMin( id, ss, &asize );          // min
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        min     = %s\n", str );

        ei = EngGetEcMax( id, ss, &asize );          // max
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        max     = %s\n", str );

        ei = EngGetEcUnits( id, (char*)ss, &asize ); // units
        Gprintf("        units   = %s", ss );
        Gprintf("\n");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// ec_gval() - get EC value and display
/*-----------------------------------------------------------*/
int     ec_gval( void )
{
        TECID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
        char    str[1024];
    while( 1 ){
        input_line( "EC> GVAL ECID (0=end) : ", cbuf );                                 // input ECID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   ECID = %d\n", id );
        ei = EngGetEcFormat( id, &fmt );            // get format
        if ( ei < 0 ){
            Gprintf( " !! ECID %d inval;id\n" );
            continue;
        }
        ei = EngGetEcArraySize( id, &asize );       // get array size
        ei = EngGetEcName( id, (char*)ss, &asize ); // get value
        ei = EngGetEcVal( id, ss, &asize );
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        value   = %s\n", str );
        Gprintf("\n");
    }
    return 0;
}

/*-----------------------------------------------------------*/
// ec_sval() - set EC value
/*-----------------------------------------------------------*/
int     ec_sval( void )
{
        TECID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
    while( 1 ){
        input_line( "EC> SVAL ECID (0=end) : ", cbuf );                                 // input ECID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   ECID = %d\n", id );
        ei = EngGetEcFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! ECID %d inval;id\n" );
            continue;
        }
        ei = EngGetEcArraySize( id, &asize );        // get array size
        Gprintf( "        fmt     = %s (0x%x)\n", dsh_get_item_name(fmt), fmt );
        input_line( "EC> value = ", cbuf );
        memset( ss, 0, sizeof(ss) );
        set_data_val( fmt, cbuf, ss );
        ei = EngSetEcVal( id, (void*)ss, asize );    // set value
        Gprintf( "     result = %d\n", ei );
        Gprintf("\n");
    }
    return 0;
}

/*----- End Of File -----------------------------------------*/
