/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_main.c - Main Program             */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/
#include    "all.h"

#define WAIT_TIMEOUT  (-1)
static  int     limit_event;
static  ULONG   limit_thid;
/*-----------------------------------------------------------*/
// s_setup_limit_thread()
/*-----------------------------------------------------------*/
void    s_setup_limit_thread( void )
{
    limit_event = CREATE_EVENT( NULL, FALSE, FALSE, NULL );

#if ENG_OS == OS_WINDOWS
    DshCreateThread( (LPTHREAD_START_ROUTINE)limit_event_rcv_thread, NULL,  &limit_thid );
#else
    dsh_create_thread( (LPTHREAD_START_ROUTINE)limit_event_rcv_thread, NULL,
                            NULL, NULL, (pthread_t*)&limit_thid );
#endif
    EngSetupVLimitEventList( limit_event );
}
/*-----------------------------------------------------------*/
// s_stop_limit_thread()
/*-----------------------------------------------------------*/
void    s_stop_limit_thread( void )
{
    limit_thid = 0;
    if ( limit_event != 0 ){
        SET_EVENT( limit_event );
    }
}
/*-----------------------------------------------------------*/
// limit_event_rcv_thread()
/*-----------------------------------------------------------*/
void    limit_event_rcv_thread( void )
{
        int     ei;
        TVLIMIT_EVENT_INFO limit_info;
    while( limit_thid != 0 ){
        if ( limit_event != 0 ){                            // eventwH
            ei = WAIT_EVENT( limit_event, 5000 );           // yes, wait for event
            if ( ei != WAIT_TIMEOUT ){
                RESET_EVENT( limit_event );
            }else{                                          // timeout
                continue;
            }
        }else{
            Sleep( 10 );                                    // polling
        }
        if ( EngGetVLimitEventList( &limit_info ) > 0 ){    // any limit event information on queue ?
            Gprintf("!!**!! limit_event_thread()   Limit Event Occurred( Value Range Changed )\n" );
            Gprintf("    vid     = %d ( 0x%x )\n", limit_info.vid, limit_info.vid );
            Gprintf("    value   = %s\n", limit_info.value );
            Gprintf("    Limitid = %d\n", limit_info.limitid );
            Gprintf("    dir     = %d\n", limit_info.dir );

            // ŁA~bg͂AKvȏǉB

            DshFreeTVLIMIT_EVENT_INFO( &limit_info );       // limit_infoŎgpĂ؂J
        }
     }
    Gprintf( "    end of limit_event_rcv_thread()\n" );
    END_THREAD(0);
}

