/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_main.c - Main Program             */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"
#define     SOLARIS     0

/*----------------------------------------------------------*/
static  int     s_data_fmt = 32 ;                           // CEID, RPID, VID, ALID format( 16=U2, 32=U4 )
static  int     s_rcp_msg  = rcp_msg_mode_RCP;              // use S15F13
static  int     s_prj_msg  = 0;                             // use S16F11

/*-----------------------------------------------------------*/
#define COMMON_LOG  "common.log"                            // equipment common log file name
/*-----------------------------------------------------------*/
/* File Name -  Configuration File, Data Inforamtion Define  */
/*              Log file                                     */
/*-----------------------------------------------------------*/
#if ENG_OS == OS_WINDOWS                                            // defined at all.h file
I
//----- WINDOWS
char    *test_log_file = { "c:\\dsheng4\\c_eq\\demo.log" };         // Log File Name for test program
char    *comm_def_file = { "c:\\dsheng4\\cnf\\comm.def" };
char    *eq_conf_file  = { "c:\\dsheng4\\cnf\\equip.cnf" };         // equipment configuration file
char    *job_sche_file = { "c:\\dsheng4\\cnf\\jobsche.txt" };       // Wafer Processiing Job Schedule File for simulation


#else

#if SOLARIS == 1
//----- Solaris-----------------------------------------
char    *test_log_file = { "../demo.log" };                         // test program log file
char    *comm_def_file = { "/export/home/dsheng4/cnf/comm.def" };   // comm.def file for dshdr2
char    *eq_conf_file  = { "/export/home/dsheng4/cnf/equip.cnf" };  // eq configuration file
char    *job_sche_file = { "/export/home/dsheng4/cnf/jobsche.txt" }; // Job Schedule File

#else
char    *test_log_file = { "../demo.log" };                         // test program log file
char    *comm_def_file = { "/export/home/dsheng4/cnf/comm.def" };   // comm.def file for dshdr2
char    *eq_conf_file  = { "/export/home/dsheng4/cnf/equip.cnf" };  // eq configuration file
char    *job_sche_file = { "/export/home/dsheng4/cnf/jobsche.txt" }; // Job Schedule File

#endif

#endif                  // WINDOWS / LINUX, UNIX selection end
int     mem_leak_check_flag = 1;                                    // DSHEng4 memory check flag;
/*-----------------------------------------------------------*/
static  int     poll_thid;                                          // ThreadID for Polling
        void    s_set_data_format( void );
        void    s_disp_data_format( void );

//static  char    buff[KEY_BUFF_SIZE];
void    DH_init_linux_tab( void );
/*************************************************************/
// main()
/*************************************************************/
int     main( void )
{
        int     ei;
        char    err_str[256];
        int     step = 0;
        int     x=0;

//----- start -------------------------------------------------
    g_mem_ck_flag( mem_leak_check_flag );
    DshGetSerialNo( err_str );                              // get  serial number
    Gprintf( "%s\n", err_str );

    s_restore_fmt_msg();                                    // CEID fmt, rcp, prj msg

    init_Gpirntf( test_log_file );                          // test log file name setting "demo.log"

    set_print_flag( 1 );                                    // Echo log on the console

    Bprintf( "***** DSHENG4 Communication Engine DEMO Start *****\n\n" );

    DshSetMemLeakCkFlag( mem_leak_check_flag );             // memory check flag

    while( 1 ){

/*-----------------------------------------------------------*/
        //* comm.def file for DSHDR2 HSMS driver

    ei = EngStart( comm_def_file, eq_conf_file, 0, err_str );   // DSHEng4 Engine Start
        if ( ei == 0 ){
            Gprintf( "    EngStart() - OK\n" );
        }else{
            Gprintf( "    EngStart() - error ei=%d\n", ei );
        }
        if ( ei != 0 ) break;
/*-----------------------------------------------------------*/
        ei = set_reserved_variable();                       // Reserved CEID, ECID, SVID, Setting

/*-----------------------------------------------------------*/
        if ( ei < 0 ){
            printf( "!!! Reserved Information setup error x = %d\n", x );
            break;                                          // exit
        }
/*-----------------------------------------------------------*/
        //* Host Message SxFy Registartion, passed from DSHENG4
        //*      capacity = 100 SxFy message
        ei = EngRegisterDefaultSxFy( 100, 0 );
        Gprintf( "    EngRegisterDefaultSxFy() - ei=%d\n", ei );

        //* Polling and Processing Thread - Primary Message sent by host
#if ENG_OS == OS_WINDOWS
        DshCreateThread( (LPTHREAD_START_ROUTINE)s_poll_thread, NULL,  &poll_thid );

#else
        dsh_create_thread( (LPTHREAD_START_ROUTINE)s_poll_thread, NULL,
                                        NULL, NULL, (pthread_t*)&poll_thid );
#endif

        Gprintf( "    poll thread() creation end\n" );
        step = 2;

        s_setup_limit_thread( );                            // start limit monitoring thread

        Gprintf( "    s_setup_limit_thread() end\n" );
        s_disp_format_msg();                                // display CEID, VID format and rcp, prj msg

        test_cmd_proc( );                                   // got to test ans ask a operator command
        break;                                              // end of test

    }
/*----- End Of Test -----------------------------------------*/

    if ( step == 2 ){
        s_stop_limit_thread( );                            // stop limit monitoring thread
        Gprintf( "        -> EngStop() start\n" );
        EngStop( );
        Gprintf( "        -> EngStop() end\n" );
    }
    if ( step < 2 ){
        Gprintf( "        -> EngStop() start\n" );
        EngStop( );
        Gprintf( "        -> EngStop() end\n" );
    }
    term_Gpirntf( );                                        // Close Internal Log File
    g_PrintMalloc();                                        // memory leak report
    printf( "***** DSHENG4 Communication Engine Test End *******\n\n" );

    return ei;
}

/*-----------------------------------------------------------*/
// s_set_data_format()
/*-----------------------------------------------------------*/
void    s_set_data_format( void )
{
    if ( s_data_fmt == 16 ){
        EngSetDataFormat( X_FMT_ALID, ICODE_U2 );
        EngSetDataFormat( X_FMT_VID, ICODE_U2 );
        EngSetDataFormat( X_FMT_ECID, ICODE_U2 );
        EngSetDataFormat( X_FMT_SVID, ICODE_U2 );
        EngSetDataFormat( X_FMT_DVID, ICODE_U2 );
        EngSetDataFormat( X_FMT_RPID, ICODE_U2 );
        EngSetDataFormat( X_FMT_CEID, ICODE_U2 );
        EngSetDataFormat( X_FMT_DATAID, ICODE_U2 );
    }else{
        EngSetDataFormat( X_FMT_ALID, ICODE_U4 );
        EngSetDataFormat( X_FMT_VID, ICODE_U4 );
        EngSetDataFormat( X_FMT_ECID, ICODE_U4 );
        EngSetDataFormat( X_FMT_SVID, ICODE_U4 );
        EngSetDataFormat( X_FMT_DVID, ICODE_U4 );
        EngSetDataFormat( X_FMT_RPID, ICODE_U4 );
        EngSetDataFormat( X_FMT_CEID, ICODE_U4 );
        EngSetDataFormat( X_FMT_DATAID, ICODE_U4 );
    }
    Gprintf( "***** new      data format list *****\n" );
    s_disp_data_format( );
}
/*-----------------------------------------------------------*/
// s_get_data_format()
/*-----------------------------------------------------------*/
int     s_get_data_format( void ){ return s_data_fmt; }

/*-----------------------------------------------------------*/
// s_disp_data_format()
/*-----------------------------------------------------------*/
void    s_disp_data_format( void )
{
        int     fmt;
    fmt = EngGetDataFormat( X_FMT_ALID );
    Gprintf( "    FMT_ALID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_VID );
    Gprintf( "    FMT_VID        = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_ECID );
    Gprintf( "    FMT_ECID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_SVID );
    Gprintf( "    FMT_SVID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_DVID );
    Gprintf( "    FMT_DVID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_LIMITID );
    Gprintf( "    FMT_LIMITID    = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_TRID );
    Gprintf( "    FMT_TRID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_SMPLN );
    Gprintf( "    FMT_SMPLN      = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_RPID );
    Gprintf( "    FMT_RPID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_CEID );
    Gprintf( "    FMT_CEID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_DATAID );
    Gprintf( "    FMT_DATAID     = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_PPID );
    Gprintf( "    FMT_PPID       = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_PPBODY );
    Gprintf( "    FMT_PPBODY     = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_LENGTH );
    Gprintf( "    FMT_LENGTH     = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_PTN );
    Gprintf( "    FMT_PTN        = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );

    fmt = EngGetDataFormat( X_FMT_DATALENGTH );
    Gprintf( "    FMT_DATALENGTH = %s (0x%02X)  \n", dsh_get_item_name(fmt), fmt );
}


/*-----------------------------------------------------------*/
// s_set_rcp_msg( )
/*-----------------------------------------------------------*/
void    s_set_rcp_msg( int msg_mode ){ s_rcp_msg = msg_mode; }
int     s_get_rcp_msg( void ){ return s_rcp_msg; }

/*-----------------------------------------------------------*/
// s_set_prj_msg( )
/*-----------------------------------------------------------*/
void    s_set_prj_msg( int msg_mode ){ s_prj_msg = msg_mode; }
int     s_get_prj_msg( void ){ return s_prj_msg; }


#define GEM_HIS_FILE    "gem_fmt.his"
/*-----------------------------------------------------------*/
// s_save_fmt_msg( )
/*-----------------------------------------------------------*/
void    s_save_fmt_msg( void )
{
        FILE    *fp;
    if ( ( fp=fopen( GEM_HIS_FILE, "w" )) == NULL ) return;
    fprintf( fp, "%d\n", s_data_fmt );
    fprintf( fp, "%d\n", s_rcp_msg );
    fprintf( fp, "%d\n", s_prj_msg );
    fclose( fp );
}
/*-----------------------------------------------------------*/
// s_restore_fmt_msg( )
/*-----------------------------------------------------------*/
void    s_restore_fmt_msg( void )
{
    FILE    *fp;
    char    buff[16];
    if ( (fp=fopen( GEM_HIS_FILE, "r")) == NULL ) return;
    while( 1 ){
        if ( fgets( buff, 16, fp ) == NULL ) break;
        s_data_fmt = atoi(buff);
        if ( fgets( buff, 16, fp ) == NULL ) break;
        s_rcp_msg = atoi(buff);
        if ( fgets( buff, 16, fp ) == NULL ) break;
        s_prj_msg =atoi(buff);
        break;
    }
    fclose( fp );
}
/*-----------------------------------------------------------*/
// s_get_data_format()
/*-----------------------------------------------------------*/
int     set_reserved_variable( void )
{
        int     ei, x;
    while( 1 ){
        Gprintf( "Reserved Variable set start\n" );
        //----- Recserved CEID ---Index and CEID ----------------------
        ei = EngSetReservedCeid( CEX_RSV_COMMUNICATING, CE_Communicating);

        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedCeid( CEX_RSV_SPOOL_END, CE_SpoolDeactivated);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedCeid( CEX_RSV_LIMIT, CE_LimitChange);

        if ( ei < 0 ) break;
        //----- ECID, SVID --- Index and VID --------------------------

        ei = EngSetReservedEcid( ECX_RSV_MDLN, EC_Mdln);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedEcid( ECX_RSV_SOFTREV, EC_SoftRev);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedEcid( ECX_RSV_SPOOL_MAX, EC_MaxSpoolTransmit);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedEcid( ECX_RSV_SPOOL_OVERWRITE, EC_OverWriteSpool);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedEcid( ECX_RSV_INIT_COMMSTATE, EC_InitCommState);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedEcid( ECX_RSV_SPOOL_ENABLE, EC_SpoolEnable);

        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_CLOCK, SV_Clock);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_COMMUNICATING, SV_CommunicationState);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_SPOOL_STATE, SV_SpoolState);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_SPOOL_TOTAL, SV_SpoolCountTotal);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_SPOOL_ACTUAL, SV_SpoolCountActual);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_SPOOL_STIME, SV_SpoolStartTime);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_SPOOL_FTIME, SV_SpoolFullTime);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_LIMIT_VID, SV_LimitVid);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_LIMIT_DIR, SV_LimitDir);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_LIMIT_DVVAL, SV_LimitDVVal);
        if ( ei < 0 ) break;
        x++;
        ei = EngSetReservedSvid( SVX_RSV_LIMIT_ID, SV_LimitLimitid);
        Gprintf( "Reserved Variable set start end\n" );
        if ( ei < 0 ) break;
        x++;
        break;
    }
    Gprintf( "    EngSetReservedXXX() - ei=%d\n", ei );
    if ( ei < 0 ) Gprintf("      x = %d\n", x );
    return ei;
}

/*----- End Of File ------------------------------------------*/
