/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_pmsgpr.c                          */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/
#include    "all.h"

//  Wafer Processing Simulation ŎgpȂ messagȅŏ܂B

/*--------------------------------------------------------------------------*/
/* S1F15 - Offline                                                          */
/*--------------------------------------------------------------------------*/
void    s1f15_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg)
{
        int     oflack;
        int     ei;
    Gprintf( "**-->S1F15 Offline\n" );
    oflack = get_ack_value( X_S1F15 );                      // get oflack
    sim_ope_mode( 0 );                                // set ofline
    ei = DshResponseS1F16( qmsg->trid, oflack );
    if ( ei < 0 ){
        Gprintf( "!!! S1F16 response send error\n" );
    }
}
/*--------------------------------------------------------------------------*/
/* S1F17 - Online                                                           */
/*--------------------------------------------------------------------------*/
void    s1f17_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     onlack;
        int     ei;
    Gprintf( "**-->S1F17 Online\n" );
    onlack = get_ack_value( X_S1F17 );
    sim_ope_mode( 1 );                                // set online
    ei = DshResponseS1F18( qmsg->trid, onlack );
    if ( ei < 0 ){
        Gprintf( "!!! S1F18 response send error\n" );
    }
}
/*--------------------------------------------------------------------------*/
// S2F23 - Trace Initialize Send
/*--------------------------------------------------------------------------*/
void    s2f23_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     tiaack;
        int     index;
        TTRACE_INFO tinfo;
    Gprintf( "**-->S2F23 Trace Initialize Send\n");
    tiaack = get_ack_value( X_S2F23 );
    ei = DshDecodeS2F23( smsg, &tinfo );                    // decode S2F23==>tinfo
    if ( ei == 0 ){
        ei = EngAllocTrInfo( tinfo.trid, &index );    // alloc
        ei = EngSetTrInfoX( index, &tinfo );          // set
        disp_trace_info( &tinfo );                          // display trace information
        ei = EngEnableTrace( tinfo.trid );           // enable message trace
        Gprintf( " EngEnableTrace( ) ei = %d\n", ei );
    }else{
        tiaack = 1;                                         // negative ack
    }
    ei = DshResponseS2F24( qmsg->trid, &tinfo, tiaack );  // S2F24
    if ( ei < 0 ){
        Gprintf( "!!! S2F24 response send error\n" );
    }
}
//----- disp_trace_info( ) -------------------------------------
void    disp_trace_info( TTRACE_INFO *tinfo )
{
        int     i;
    Gprintf( "  traceid = %s\n", tinfo->trid );
    Gprintf( "  dsper   = %s\n", tinfo->dsper );
    Gprintf( "  totsmp  = %d\n", tinfo->totsmp );
    Gprintf( "  repgsz  = %d\n", tinfo->repgsz );
    Gprintf( "  # of SV = %d\n", tinfo->svid_count );
    for ( i=0; i < tinfo->svid_count; i++ ){
        Gprintf( "    svid = %d\n", tinfo->svid_list[i] );
    }
}
/*--------------------------------------------------------------------------*/
// S2F41 - Host Command Send
/*--------------------------------------------------------------------------*/
void    s2f41_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        TRCMD_INFO      rinfo;
        TRCMD_ERR_INFO  erinfo;
        int     hcack;
        int     ei;
        int     err_count = 0;
    Gprintf( "**-->S2F41 : Remote Host Command Received\n" );
    ei = DshDecodeS2F41( smsg, &rinfo );
    if ( ei == 0 ){
        disp_rc_info( &rinfo );
        hcack = get_ack_value( X_S2F41 );

    }else{
        hcack = 1;
    }
    if ( hcack != 0 ) err_count = 1;
    DshInitTRCMD_ERR_INFO( &rinfo, &erinfo, hcack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTRCMD_ERR_PARA( &rinfo, &erinfo, 0, 15 ); // order=0, cpack=15
        Gprintf( "  DshPutTRCMD_ERR_PARA ( )-1 ei=%d\n\n", ei );
        ei = DshPutTRCMD_ERR_PARA( &rinfo, &erinfo, 1, 16 ); // order=1, cpack=16
        Gprintf( "  DshPutTRCMD_ERR_PARA ( )-2 ei=%d\n\n", ei );
        ei = DshPutTRCMD_ERR_PARA( &rinfo, &erinfo, 2, 17 ); // order=2, cpack=17 ==> ei=( -1 )Ԃ
        Gprintf( "  DshPutTRCMD_ERR_PARA ( )-3 ei=%d\n\n", ei );
    }
    ei = DshResponseS2F42( qmsg->trid, &rinfo, &erinfo );
                     //  - rinfoerinfoallocꂽ؂DshResponseS2F42( )JĂB
                     //      DshResponseS2F42( )ŊJĂقȂꍇAu_s2f41.c ύXĂB
    if ( ei < 0 ){
        Gprintf( "!!! S2F42 response send error\n" );
    }
}
//----- disp_rc_info( ) ----------------------------------------
void    disp_rc_info( TRCMD_INFO  *rinfo )
{
        char    buff[256];
        int     i;
    Gprintf( "  rcmd    = %s\n", rinfo->rcmd );
    Gprintf( "  cp_count= %d\n", rinfo->cp_count );
    for ( i=0; i < rinfo->cp_count; i++ ){
        Gprintf( "    cpname   = %s\n", rinfo->cp_list[i]->cpname );
        if ( rinfo->cp_list[i]->cpval_fmt == ICODE_L ){
            disp_rc_para( rinfo->cp_list[i], 0 );
        }else{
            data_to_string( rinfo->cp_list[i]->cpval_fmt, rinfo->cp_list[i]->cpval_size,
                                 (BYTE*)rinfo->cp_list[i]->cpval, buff );
            Gprintf( "    para val = %s\n", buff );
        }
    }
}
//----- disp_rc_para( ) ----------------------------------------
void    disp_rc_para( TRCMD_PARA* pinfo, int lvl )
{
        int     i;
        char    buff[256];
        TRCMD_PARA **list;
        TRCMD_PARA *info;
    Gprintf( " ----- rcmd para list lvl=%d n=%d----", lvl, pinfo->cpval_size );
    if ( pinfo->cpval_size == 0 ) return;
    list = ( TRCMD_PARA ** )pinfo->cpval;
    for ( i=0; i < pinfo->cpval_size; i++ ){
        info = list[i];
        if ( info->cpval_fmt == ICODE_L ){
            disp_rc_para( info, lvl+1 );
        }else{
            data_to_string( info->cpval_fmt, info->cpval_size, (BYTE*)info->cpval, buff );
            Gprintf( "    para val = %s\n", buff );
        }
    }
}
/*--------------------------------------------------------------------------*/
// S2F43 - Reset Spooling Stream and Function
/*--------------------------------------------------------------------------*/
void    s2f43_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     rsack = 0;
        int     ei;
        int     i, j;
        int     err_count = 0;
        TSPOOL_INFO     tinfo;
        TSPOOL_ERR_INFO errinfo;
        TSTRE_ERR_INFO *serr_info;
        int     strack   = 1;
        int     stream   = 2;
        int     f_count  = 2;
        int     function = 3;
        int     func_err = 4;
    memset( &errinfo, 0, sizeof( TSPOOL_ERR_INFO ) );
    Gprintf( "**-->S2F43 Reset Spooling Stream and Function\n" );
    ei = DshDecodeS2F43( smsg, &tinfo );
    Gprintf( "DshDecodeS2F43( ) ei=%d\n", ei );
    if ( ei == 0 ){
        ei = EngSetAllSpoolInfo( &tinfo );
        disp_spool_info( &tinfo );
        rsack = get_ack_value( X_S2F43 );
    }else{
        rsack = 1;
    }
    if ( rsack != 0 ){                                      // error ack  ?
        err_count = 1;
    }
    DshInitTSPOOL_ERR_INFO( &errinfo, rsack, err_count );   // reset err info
    if ( err_count > 0 ){
        for ( i=0; i < err_count; i++ ){
            DshInitTSTRE_ERR_INFO( &serr_info, strack, stream , 2 );
            for ( j=0; j < f_count; j++ ){
                ei = DshPutTSTRE_ERR_INFO( serr_info, function, func_err );
                function += 2;
            }
            ei = DshPutTSPOOL_ERR_INFO( &errinfo, serr_info );
            stream++;
        }
    }
    disp_spool_err_info( &errinfo );                        // err info\
    ei = DshResponseS2F44( qmsg->trid, &tinfo, &errinfo );
    if ( ei < 0 ){
        Gprintf( "!!! S2F44 response send error\n" );
    }
}
//----- disp_spool_info( ) -------------------------------------
void    disp_spool_info( TSPOOL_INFO *tinfo )
{
        int     i, j;
        TSTRE_INFO *sinfo;
    Gprintf( "----- Spool Information -----" );
    if ( tinfo->s_count == 0 ){                             // reset all
        Gprintf( "    Reset all spool info" );
    }else{
        for ( i=0; i < tinfo->s_count; i++ ){
            sinfo = tinfo->stre_list[i];
            Gprintf( "    i=%d Stream = %d  f_count = %d\n", i+1, sinfo->stream, sinfo->f_count );
            if ( sinfo->f_count == 0 ){
                Gprintf( "      No function" );
            }else{
                for ( j=0; j < sinfo->f_count; j++ ){
                    Gprintf( "      j=%d Function = %d\n", j+1, sinfo->func_list[j] );
                }
            }
        }
    }
}
//----- disp_spool_err_info( ) ---------------------------------
void    disp_spool_err_info( TSPOOL_ERR_INFO *info )
{
        int     i, j;
        TSTRE_ERR_INFO  *sinfo;
    Gprintf( "----- TSPOOL_ERR_INFO ---------" );
    Gprintf( "   rsack     = %d\n", info->rsack );
    Gprintf( "   err_count = %d\n", info->err_count );
    for ( i=0; i < info->err_count; i++ ){
        sinfo = info->stre_list[i];
        Gprintf( "     i=%d  strack  = %d\n", i+1, sinfo->strack );
        Gprintf( "          stream  = %d f_count=%d\n", sinfo->stream, sinfo->f_count );
        for ( j=0; j < sinfo->f_count; j++ ){
            Gprintf( "         j=%d function = %d\n", j+1, sinfo->func_list[j] );
            Gprintf( "             func_err = %d\n", sinfo->func_err[j] );
        }
    }
}
/*--------------------------------------------------------------------------*/
// S2F45 - Define Variable Limit Attribute
/*--------------------------------------------------------------------------*/
void    s2f45_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     err_count = 0;
        int     lvack;
        int     lmt_count;
        int     limit_id;
        int     limitack;
        TLIMIT_LIST tinfo;
        TLIMIT_ERR_LIST errinfo;
        TLIMIT_ERR_INFO *iinfo;
    Gprintf( "**-->S2F45 Define Variable Limit Attribute\n" );
    memset( &errinfo, 0, sizeof( TLIMIT_ERR_LIST ) );
    ei = DshDecodeS2F45( smsg, &tinfo );
    if ( ei == 0 ){
        disp_s2f45( &tinfo );
        ei = EngSetMultiVLimit( &tinfo );             // Limito^
        if ( ei != 0 ) ei = 1;
        else ei = get_ack_value( X_S2F45 );
        // ɕKvȏǉB
    }else{
        ei = 1;
    }
    if ( ei != 0 ){                                         // error ack  ?
        err_count = 2;
    }
    DshInitTLIMIT_ERR_LIST( &errinfo, ei, err_count );
    if ( err_count > 0 && tinfo.vid_count >= 0 ){
        lvack = 3;                                          // l͑SýėpłB
        lmt_count = 1;                                      // VID-1 1
        DshInitTLIMIT_ERR_INFO( &iinfo, tinfo.limit_list[0]->vid, lvack, lmt_count );
        limit_id = 5;
        limitack = 6;

        ei = DshPutTLIMIT_ERR_ID( iinfo, limit_id, limitack );
        DshPutTLIMIT_ERR_LIST( &errinfo, iinfo );           // ERRLISTput
        lvack = 13;                                         // l͑SýėpłB
        lmt_count = 2;                                      // VID-2 2

        DshInitTLIMIT_ERR_INFO( &iinfo, tinfo.limit_list[1]->vid, lvack, lmt_count );
        limit_id = 15;
        limitack = 16;
        ei = DshPutTLIMIT_ERR_ID( iinfo, limit_id, limitack );
        limit_id = 27;
        limitack = 28;
        ei = DshPutTLIMIT_ERR_ID( iinfo, limit_id, limitack );
        DshPutTLIMIT_ERR_LIST( &errinfo, iinfo );           // ERRLISTput
    }
    ei = DshResponseS2F46( qmsg->trid, &tinfo, &errinfo );
    if ( ei < 0 ){
        Gprintf( "!!! S2F46 response send error\n" );
    }
}
//----- disp_s2f45( ) -------------------------------------------
void    disp_s2f45( TLIMIT_LIST *info )
{
        int     i, j;
        char    buff[256];
        TLIMIT_INFO *vinfo;
    Gprintf( "  ----- Variable Limit Information -----" );
    Gprintf( "    vid_count = %d\n", info->vid_count );
    if ( info->vid_count == 0 ){
        return;
    }
    for ( i=0; i < info->vid_count; i++ ){
        vinfo = info->limit_list[i];
        Gprintf( "   list[%d] ----- \n", i );
        Gprintf( "     vid         = %d\n", vinfo->vid );
        Gprintf( "     limit count = %d\n", vinfo->limit_count );
        for ( j = 0; j < vinfo->limit_count; j++ ){
            TLIMIT_ID_INFO *dinfo; dinfo = vinfo->limitid_list[j];
            Gprintf( "     id_list[%d] -----\n", j );
            Gprintf( "       limit_id  = %d\n", dinfo->limit_id );
            data_to_string( vinfo->format, 1, (BYTE*)dinfo->upperdb, buff );
            Gprintf( "       upperdb   = %s\n", buff );
            data_to_string( vinfo->format, 1, (BYTE*)dinfo->lowerdb, buff );
            Gprintf( "       lowerdb   = %s\n", buff );
        }
    }
}
/*--------------------------------------------------------------------------*/
// S2F49 - Enhanced Remote Control
/*--------------------------------------------------------------------------*/
void    s2f49_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        TERCMD_INFO     rinfo;
        TERCMD_ERR_INFO erinfo;
        int     hcack = 0;
        int     ei;
        int     err_count = 0;
    Gprintf( "**-->S2F49 : Enhanced Remote Host Command Received\n" );
    ei = DshDecodeS2F49( smsg, &rinfo );
    if ( ei == 0 ){
        disp_erc_info( &rinfo );
        hcack = get_ack_value( X_S2F49 );                   // ́Aýėpack
    }else{
        hcack = 1;
    }
    if ( hcack != 0 ){
        err_count = 2;                                       // <==== err count = 2( testp )
    }
    DshInitTERCMD_ERR_INFO( &rinfo, &erinfo, hcack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTERCMD_ERR_PARA( &rinfo, &erinfo, 0, 15 ); // order=0, cpack=15
        Gprintf( "  DshPutTERCMD_ERR_PARA ( )-1 ei=%d\n\n", ei );

        ei = DshPutTERCMD_ERR_PARA( &rinfo, &erinfo, 1, 16 ); // order=1, cpack=16
        Gprintf( "  DshPutTERCMD_ERR_PARA ( )-2 ei=%d\n\n", ei );

        ei = DshPutTERCMD_ERR_PARA( &rinfo, &erinfo, 2, 17 ); // order=2, cpack=17 ==> ei=( -1 )Ԃ
        Gprintf( "  DshPutTERCMD_ERR_PARA ( )-3 ei=%d\n\n", ei );

    }
    ei = DshResponseS2F50( qmsg->trid, &rinfo, &erinfo );
                     //  - rinfoerinfoallocꂽ؂DshResponseS2F50( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S2F50 response send error\n" );
    }
}
//----- disp_erc_info( ) ----------------------------------------
void    disp_erc_info( TERCMD_INFO  *rinfo )
{
        int     i, j, k, n;
        char    buff[256];
        TERCMD_PARA *pinfo, *ninfo;
    Gprintf( "    objspec = %s\n", rinfo->objspec );
    Gprintf( "    rcmd    = %s\n", rinfo->rcmd );
    Gprintf( "    cp_count= %d\n", rinfo->cp_count );
    for ( i=0; i < rinfo->cp_count; i++ ){
        pinfo = rinfo->cp_list[i];
        Gprintf( "      cpname   = %s\n", pinfo->cpname );
        n = pinfo->cpx_count;
        if ( n > 0 ){
            if ( pinfo->cpx_list != NULL ){
                for ( j=0; j < n; j++ ){
                    ninfo = pinfo->cpx_list[j];
                    Gprintf( "      cpname( nest )= %s\n", ninfo->cpname );
                    for ( k=0; k < ninfo->cpx_count; k++ ){
                        data_to_string( ninfo->cpval_fmt[k], ninfo->cpval_size[k],
                                                            (BYTE*)ninfo->cpval[k], buff );
                        Gprintf( "      para val = %s\n", buff );
                    }
                }
            }else{
                for ( j=0; j < n; j++ ){
                    data_to_string( pinfo->cpval_fmt[j], pinfo->cpval_size[j],
                                         (BYTE*)pinfo->cpval[j], buff );
                    Gprintf( "      para val = %s\n", buff );
                }
            }
        }
    }
}
/*-----------------------------------------------------------*/
// s3f17_proc( ) - Carrier Action Control
/*-----------------------------------------------------------*/
void    s3f17_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        TCACT_INFO tinfo;
        int     ei;
        int     ack = 0;
    Gprintf( "**-->S3F17 : Carrier Control Received\n" );
    ei = DshDecodeS3F17( smsg, &tinfo );
    if ( ei == 0 ){                                     // decode = OK
        disp_s3f17( &tinfo );
        DshFreeTCACT_INFO( &tinfo );
    }else{
        ack = 1;
    }
    s3f17_response( qmsg, ack );         // send response
}
/*-----------------------------------------------------------*/
// s3f17_response( ) - send s3f18
/*-----------------------------------------------------------*/
void    s3f17_response( TMSG_QUEUE_INFO *qmsg, int ack )
{
        TCACT_ERR_INFO  erinfo;
        int             ei;
        int             err_count = 0;
    memset( &erinfo, 0, sizeof( TCACT_ERR_INFO ) );
    //----- S3F18̏ -----------------------------
    if ( ack == 0 ){
        ack = get_ack_value( X_S3F17 );                         // error ack  ?
    }
    if ( ack != 0 ){
        err_count = 2;
    }
    DshInitTCACT_ERR_INFO( &erinfo, ack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 17, "ERR01" ); // err code,errtext
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 1 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 18, "ERR02" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 2 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 19, "ERR03" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 3 ei = %d\n", ei );
    }
    ei = DshResponseS3F18( qmsg->trid, NULL, &erinfo );   // u_s3f17.c
    if ( ei < 0 ){
        Gprintf( "!!! S3F18 response send error\n" );
    }
}

//----- S3F17_ProceedWithCarrier( ) ---sim_state = 1 -------------
void    S3F17_ProceedWithCarrier( TCACT_INFO *info )
{
        int     ei = 0;
        int     slot_count;
        int     i;
        char    id[81];
        char    *sim_carid;
        char    substid [81];
        TTSIM_OPERATION *sim_p;
    if ( get_sim_operation_busy( ) == 0 ){             // Simulation Active ?
        return;
    }
    sim_p = get_sim_operation_info( );
    sim_carid = sim_p->carid;
    if ( strcmp( info->carspec, sim_carid ) != 0 ){
        Gprintf( "!!! carid not for sim - %s -  %s\n", info->carspec, sim_carid );
        return;
    }
//    if ( check_sim_wait_msg( 3, 17, 0 )== 0 ){        // waitong for s3f17 ?
        ei = DoS3F17Proc( info );
        slot_count = 0;
        ei = EngGetCarSlotCount( sim_carid, &slot_count );
        for ( i = 0; i < slot_count; i++ ){                 // set substid for each slot

            ei = EngGetCarSubstid( sim_carid, i, substid );
            if ( ei == 0 && strlen( substid ) > 0 ){
                int ope_index = 0;
                ei = EngAllocSubstInfo( substid, &ope_index );
                if ( ei == 0 ){
                    char lotid[80];
                    ei = EngGetCarLotid( sim_carid, i, lotid );
                    if ( ei == 0 ){
                        ei = EngSetSubstLotIdX( ope_index, lotid );
                    }
                }
            }
//        }
        ei = EngGetCarLotid( sim_carid, 0, id );
        ei = EngSetSvVal( SV_LotId, id, strlen( id ) );   // lotid
        ei = EngGetCarSubstid( sim_carid, 0, id );
        ei = EngSetSvVal( SV_SubstID, id, strlen( id ) ); // substid
        ei = EngGetCarUsage( sim_carid, id );
        ei = EngSetSvVal( SV_CarUsage, id, strlen( id ) );// usage

        ei = EngGetCarLocation( sim_carid, id );
        ei = EngSetSvVal( SV_CarLocation, id, strlen( id ) ); // location
    }
}
//----- DoS3F17Proc( ) ------------------------------------------
int     DoS3F17Proc( TCACT_INFO *info )
{
        int     ei = 0;
        int     i;
        TCACT_PARA  *tinfo;
    if ( info->cp_count > 0 ){
        for ( i=0; ei == 0 && i < info->cp_count; i++ ){
            tinfo = info->cp_list[i];
            switch ( info->action_index ){
            case CA_Bind:
            case CA_CancelBind:
            case CA_CancelCarrier:
            case CA_CancelCarrierAtPort:
            case CA_CancelCarrierNotification:
            case CA_CancelCarrierOut:
            case CA_CarrierIn:
            case CA_CarrierNotification:
            case CA_CarrierOut:
            case CA_CarrierReCreate:
            case CA_CarrierRelease:
                break;
            case CA_ProceedWithCarrier:
                ei = DoProceedWithCarrier( info, tinfo );
                break;
            default:
                break;
            }
        }
    }
    return ei;
}
//----- DoProceedWithCarrier( ) ---------------------------------
int     DoProceedWithCarrier( TCACT_INFO *info, TCACT_PARA *pinfo )
{
        int     ei = 0;
        int     *iptr;
        int     i;
        TCACT_CONTENT   *content;
        TCACT_SLOT_INFO *sinfo;
        TTSIM_OPERATION *sim_p;
        char    *sim_carid;
    if ( get_sim_operation_busy( ) == 0 ){            // Simulation Active ?
        return 0;
    }
    sim_p = get_sim_operation_info( );
    sim_carid = sim_p->carid;
    switch ( pinfo->attr_index ){
    case CA_ObjId:
    case CA_Capacity:
          break;
    case CA_CarrierAccessingStatus:
          ei = EngSetCarAccessStatus( sim_carid, ( int )( pinfo->cattrdata ) );
          break;
    case CA_CarrierIDStatus:
          ei = EngSetCarIdStatus( sim_carid, ( int )( pinfo->cattrdata ) );
          break;
    case CA_ContentMap:
          content = ( TCACT_CONTENT* )pinfo->cattrdata;
          ei = EngSetCarContent( sim_carid, content );
          break;
    case CA_LocationID:
         if ( pinfo->cattrdata == NULL ) break;
         ei = EngSetCarLocation( sim_carid, ( char* )pinfo->cattrdata );
         break;
    case CA_SlotMap:
         sinfo = ( TCACT_SLOT_INFO* )pinfo->cattrdata;
         if ( sinfo->count > 0 ){
            iptr = sinfo->slot_list;
            for( i = 0; i < sinfo->count; i++, iptr++ ){
                ei = EngSetCarSlotmap( sim_carid, i, *iptr );
                if ( ei < 0 ){
                    break;
                }
            }
         }
         break;
    case CA_SlotMapStatus:
        ei = EngSetCarMapStatus( sim_carid, ( int )pinfo->cattrdata );
        break;
    case CA_SubStrateCount:
        break;
    case CA_Usage:
         if ( pinfo->cattrdata == NULL ) break;
        ei = EngSetCarUsage( sim_carid, ( char* )pinfo->cattrdata );
        break;
    default:
        break;
    }
    return ei;
}
//----- disp_s3f17 ---------------------------------------------
void    disp_s3f17( TCACT_INFO *info )
{
        int     i, j;
        TCACT_CONTENT *content;
    Gprintf( "    caction = %s\n", info->caction );
    if ( info->carspec != NULL ){
        Gprintf( "    carspec = %s\n", info->carspec );
    }
    Gprintf( "    ptn     = %d\n", info->ptn );
    Gprintf( "    cp_count= %d\n", info->cp_count );
    if ( info->cp_count > 0 ){
        for ( i=0; i < info->cp_count; i++ ){
            Gprintf( "      i-%d\n", i );
            Gprintf( "        cattrid   = %s\n", info->cp_list[i]->cattrid );
            switch( info->cp_list[i]->attr_index ){
            case CA_ObjId:
            case CA_Capacity:
            case CA_CarrierAccessingStatus:
            case CA_CarrierIDStatus:
                //( no operation )
                break;
            //--------------------------------------------------------------
            case CA_ContentMap:
                content = ( TCACT_CONTENT* )info->cp_list[i]->cattrdata;
                if ( content->count > 0 ){
                    for ( j=0; j < content->count; j++ ){
                    // lotid
                        Gprintf( "          lotid   = %s\n", content->lotid[j] );
                    // substid
                        Gprintf( "          lsubstid= %s\n", content->substid[j] );
                    }
                }
                break;
            case CA_LocationID:
                Gprintf( "        location  = %s\n", ( char* )info->cp_list[i]->cattrdata );
                break;
            case CA_SlotMap:
                break;
            case CA_SlotMapStatus:
                break;
            case CA_SubStrateCount:
                break;
            case CA_Usage:
                Gprintf( "        usage     = %s\n", ( char* )info->cp_list[i]->cattrdata );
                break;
            default:
                break;
            }
        }
    }
}
/*--------------------------------------------------------------------------*/
// S3F23 Port Group Action
/*--------------------------------------------------------------------------*/
void    s3f23_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        TPORTG_INFO     tinfo;
        TCACT_ERR_INFO  erinfo;
        int     ei;
        int     ack = 0;
        int     err_count = 0;
    memset( &erinfo, 0, sizeof( TCACT_ERR_INFO ) );
    Gprintf( "**-->S3F23 : Carrier Control Received\n" );
    ei = DshDecodeS3F23( smsg, &tinfo );
    if ( ei == 0 ){
        disp_s3f23( &tinfo );
    }else{
        ack = 1;
    }
    if ( ack == 0 ){                                        // error ack  ?
        ack = get_ack_value( X_S3F23 );
    }
    if ( ack != 0 ){
        err_count = 2;
    }
    DshInitTCACT_ERR_INFO( &erinfo, ack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 17, "ERR01" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 1 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 18, "ERR02" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 2 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 19, "ERR03" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 3 ei = %d\n", ei );
    }
    ei = DshResponseS3F24( qmsg->trid, &tinfo, &erinfo );
                     //  - tinfoerinfoallocꂽ؂DshResponseS3F24( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S3F24 response send error\n" );
    }
}
//----- disp_s3f23( ) ------------------------------------------
void   disp_s3f23( TPORTG_INFO *info )
{
        char    buff[256];
        int     i;
    Gprintf( "    action    = %s\n", info->portgrpaction );
    Gprintf( "    grpupname = %s\n", info->portgrpname );
    Gprintf( "    pn_count  = %d\n", info->pn_count );
    if ( info->pn_count > 0 ){
        for ( i=0; i < info->pn_count; i++ ){
            Gprintf( "      i-%d\n", i );
            Gprintf( "       paramname = %s\n", info->pn_list[i]->paramname );
            data_to_string( info->pn_list[i]->pval_fmt, info->pn_list[i]->pval_size,
                                 (BYTE*)info->pn_list[i]->paramval, buff );
            Gprintf( "       param val = %s\n", buff );
        }
    }
}
/*--------------------------------------------------------------------------*/
// S3F25 - Port  Action
/*--------------------------------------------------------------------------*/
void    s3f25_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ack = 0;
        int     err_count = 0;
        TPORT_INFO      tinfo;
        TCACT_ERR_INFO  erinfo;
        int     ei;
    Gprintf( "**-->S3F25 : Port Action  Received\n" );
    ei = DshDecodeS3F25( smsg, &tinfo );
    if ( ei == 0 ){
        disp_s3f25( &tinfo );
    }else{
        ack = 1;
    }
    err_count = 0;
    if ( ack == 0 ){                                        // error ack  ?
        ack = get_ack_value( X_S3F25 );
    }
    if ( ack != 0 ){
        err_count = 2;
    }
    DshInitTCACT_ERR_INFO( &erinfo, ack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 17, "ERR01" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 1 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 18, "ERR02" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 2 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 19, "ERR03" );
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 3 ei = %d\n", ei );
    }
    ei = DshResponseS3F26( qmsg->trid, &tinfo, &erinfo );
                     //  - tinfoerinfoallocꂽ؂DshResponseS3F26( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S3F26 response send error\n" );
    }
}
//----- disp_s3f25 ---------------------------------------------
void    disp_s3f25( TPORT_INFO *info )
{
        int     i;
        char    buff[256];
    Gprintf( "    action    = %s\n", info->portaction );
    Gprintf( "    pn_count  = %d\n", info->pn_count );
    if ( info->pn_count > 0 ){
        for ( i=0; i < info->pn_count; i++ ){
            Gprintf( "    i-%d\n", i );
            Gprintf( "        paramname = %s\n", info->pn_list[i]->paramname );
            data_to_string( info->pn_list[i]->pval_fmt, info->pn_list[i]->pval_size,
                                            (BYTE*)info->pn_list[i]->paramval, buff );
            Gprintf( "        param val = %s\n", buff );
        }
    }
}

/*--------------------------------------------------------------------------*/
// S3F27 Change Access
/*--------------------------------------------------------------------------*/
void    s3f27_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ack = 0;
        int     ei;
        int     err_count = 0;
        TACCESS_INFO tinfo;
        TACCESS_ERR_INFO  erinfo;
    Gprintf( "**-->S3F27 : Chanfe Access Received \n" );
    ei = DshDecodeS3F27( smsg, &tinfo );
    if ( ei == 0 ){

            // port no. checkȗ
        sim_access_mode( tinfo.accessmode );          // set access mode

        disp_s3f27( &tinfo );
    }else{
        ack = 1;
    }
    err_count = 0;
    if ( ack == 0 ){                                        // error ack  ?
        ack = get_ack_value( X_S3F27 );
    }
    if ( ack != 0 ){
        err_count = 2;
    }
    DshInitTACCESS_ERR_INFO( &erinfo, &tinfo, ack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTACCESS_ERR_INFO( &erinfo, &tinfo, 0, 17, "ERR01" );
        Gprintf( "   DshPutTACCESS_ERR_INFO( ) 1 ei = %d\n", ei );

        ei = DshPutTACCESS_ERR_INFO( &erinfo, &tinfo, 1, 18, "ERR02" );
        Gprintf( "   DshPutTACCESS_ERR_INFO( ) 2 ei = %d\n", ei );

        ei = DshPutTACCESS_ERR_INFO( &erinfo, &tinfo, 2, 19, "ERR03" ); // 2̂ƂA3Bei=(-1)ɂȂ͂B
        Gprintf( "   DshPutTACCESS_ERR_INFO( ) 3 ei = %d\n", ei );
    }
    ei = DshResponseS3F28( qmsg->trid, &tinfo, &erinfo );
                     //  - tinfoerinfoallocꂽ؂DshResponseS3F28( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S3F28 response send error\n" );
    }
}
//----- disp_s3f27 ---------------------------------------------
void    disp_s3f27( TACCESS_INFO *info )
{
        int     i;
    Gprintf( "    access mode = %d\n", info->accessmode );
    Gprintf( "    port_count  = %d\n", info->port_count );
    if ( info->port_count > 0 ){
        for ( i=0; i < info->port_count; i++ ){
            Gprintf( "      i-%d\n", i );
            Gprintf( "        port no. = %d\n", info->port_list[i] );
        }
    }
}
/*--------------------------------------------------------------------------*/
// S7F1 Process Program Inquire
/*--------------------------------------------------------------------------*/
void    s7f1_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ppgnt = 0;
        int     ei;
        TPPINQ_INFO tinfo;
    Gprintf( "**-->S7F1 : Process Program Inquire\n" );
    ei = DshDecodeS7F1( smsg, &tinfo );
    if ( ei == 0 ){
        disp_s7f1( &tinfo );
              // ɏǉB
    }else{
        ppgnt = 1;
    }
    if ( ppgnt == 0 ){                                      // error ack  ?
        ppgnt = get_ack_value( X_S7F1 );
    }
    ei = DshResponseS7F2( qmsg->trid, &tinfo, ppgnt );
    if ( ei < 0 ){
        Gprintf( "!!! S7F2 response send error\n" );
    }
}
//----- disp_s7f1 ---------------------------------------------
void    disp_s7f1( TPPINQ_INFO *info )
{
    Gprintf( "    ppid   = %s\n", info->ppid );
    Gprintf( "    length = %d\n", info->length );
}
/*--------------------------------------------------------------------------*/
// S7F23 Formatted Process Program
/*--------------------------------------------------------------------------*/
void    s7f23_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ackc7 = 0;
        int     ei;
        int     index;
        TFPP_INFO   tinfo;
    Gprintf( "**-->S7F23 : Formatted Process Program Send \n" );
    ei = DshDecodeS7F23( smsg, &tinfo );
    if ( ei == 0 ){
        if ( get_sim_operation_busy( ) ==0 ){          // simulation = active ?
            disp_S7f23( &tinfo );                           // no, display Fpp
        }
        index = 0;
        ei = EngAllocFppInfo( tinfo.ppid, &index );   // IDo^ ===> Eng3
        if ( ei >= 0 ){
            ei = EngSetFppInfoX( index, &tinfo );     // ݒ ===> Eng3
        }
    }else{
        ackc7 = 1;
    }
    if ( ackc7 == 0 ){                                      // error ack  ?
        ackc7 = get_ack_value( X_S7F23 );
    }
    ei = DshResponseS7F24( qmsg->trid, NULL, ackc7 ); // S7F24 !! tinfoJȂB
    if ( ei < 0 ){
        Gprintf( "!!! S7F24 response send error\n" );
    }
    if ( ackc7 == 0 ){
        ;
    }
    DshFreeTFPP_INFO( &tinfo );
}
//----- disp_S7f23 ---------------------------------------------
void    disp_S7f23( TFPP_INFO *info )
{
        int     i, j;
        char    buff[256];
        TFPP_CCODE  **p;
        TFPP_CCODE  *info_ccode;
        TFPP_PARA   *info_para;
    Gprintf( "  ------ FPP Information -----\n" );
    Gprintf( "        ppid    = %s\n", info->ppid );
    Gprintf( "        mdln    = %s\n", info->mdln );
    Gprintf( "        softrev = %s\n", info->softrev );
    Gprintf( "        ccode_count= %d\n", info->ccode_count );
    if ( info->ccode_count > 0 ){
        p = info->ccode_list;
        for ( i=0; i < info->ccode_count; i++ ){
            info_ccode = ( TFPP_CCODE* )info->ccode_list[i];
            Gprintf( "        i-%d\n", i );
            Gprintf( "         ccode   = %s\n",( char* )info_ccode->ccode );
            Gprintf( "         ppara_count = %d\n", info_ccode->ppara_count );
            if ( info_ccode->ppara_count > 0 ){
                for ( j=0; j < info_ccode->ppara_count; j++ ){
                    info_para = info_ccode->ppara_list[j];
                    Gprintf( "          j-%d\n", j );
                    data_to_string( info_para->ppara_fmt, info_para->ppara_size,
                                    (BYTE*)info_para->ppara, buff );
                    Gprintf( "            ppara   = %s\n", buff );
                }
            }
        }
    }
}
/*--------------------------------------------------------------------------*/
// S7F3 Process Program Send
/*--------------------------------------------------------------------------*/
void    s7f3_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ackc7 = 0;
        int     ei;
        TPP_INFO tinfo;
        int     index;
        char    ppid[81];
    Gprintf( "**-->S7F3 : Process Program Send \n" );
    ei = DshDecodeS7F3( smsg, &tinfo );
    if ( ei == 0 ){
        strcpy( ppid, tinfo.ppid );                         // save ppid
        if ( get_sim_operation_busy( ) == 0 ){
            disp_S7f3( &tinfo );
        }
        index = 0;
        ei = EngAllocPpInfo( ( char* )tinfo.ppid, &index );// IDo^
        if ( ei >= 0 ){
            ei = EngSetPpInfoX( index, &tinfo );      // ݒ
            // ɏǉB
        }
    }else{
        ackc7 = 1;
    }
    if ( ackc7 == 0 ){                                      // error ack  ?
        ackc7 = get_ack_value( X_S7F3 );
    }
    ei = DshResponseS7F4( qmsg->trid, &tinfo, ackc7 );
    if ( ei < 0 ){
        Gprintf( "!!! S7F4 response send error\n" );
    }
    if ( ackc7 == 0 ){
        ;
    }
}
//----- disp_S7f3 ---------------------------------------------
void    disp_S7f3( TPP_INFO  *info )
{
        char    buff[8192];
    Gprintf( "----- PP Information -----\n" );
    Gprintf( "        ppid    = %s\n", info->ppid );
    data_to_string( info->ppbody_fmt, info->ppbody_size, (BYTE*)info->ppbody, buff );
    Gprintf( "        ppbody  = %s\n", buff );
}
/*--------------------------------------------------------------------------*/
// S10F3 Terminal Msg
/*--------------------------------------------------------------------------*/
void    s10f3_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     tid = 0;
        int     ackc10 = 0;
        char    text[256];
        int     ei;
    Gprintf( "**-->S10F3 : Terminal Text\n" );
    ei = DshDecodeS10F3( smsg, &tid, text );                    // terminal id÷Ămsg擾
    if ( ei == 0 ){                                             //  ?
        Gprintf( "   tid  = %d\n", tid );
        Gprintf( "   text = %s\n", text );
    }else{
        ackc10 = 1;
    }
    if ( ackc10 == 0 ){                                         // error ack  ?
        ackc10 = get_ack_value( X_S10F3 );
    }
    ei = DshResponseS10F4( qmsg->trid, NULL, ackc10 );    // S10F4
    if ( ei < 0 ){
        Gprintf( "    !!! S10F4 response send error\n" );
    }
}
/*--------------------------------------------------------------------------*/
/* S10F5 Terminal Text Multi-block                                          */
/*--------------------------------------------------------------------------*/
void    s10f5_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ackc10 = 0;
        int     ei;
        TTERMTEXT_INFO tinfo;
    Gprintf( "**-->S10F5 : Terminal Text Multi-Block\n" );
    ei = DshDecodeS10F5( smsg, &tinfo );
    if ( ei == 0 ){
        disp_s10f5( &tinfo );
    }else{
        ackc10 = 1;
    }
    if ( ackc10 == 0 ){                                     // error ack  ?
        ackc10 = get_ack_value( X_S10F5 );
    }
    ei = DshResponseS10F6( qmsg->trid, &tinfo, ackc10 );
    if ( ei < 0 ){
        Gprintf( "    !!! S10F6 response send error\n" );
    }
}
//----- disp_s10f5 ---------------------------------------------
void    disp_s10f5( TTERMTEXT_INFO *info )
{
        int     i;
    Gprintf( "   tid        = %d\n", info->tid );
    Gprintf( "   text_count = %d\n", info->text_count );
    if ( info->text_count > 0 ){
        for ( i=0; i < info->text_count; i++ ){
            Gprintf( "    text      = %s\n", info->text_list[i] );
        }
    }
}
/*--------------------------------------------------------------------------*/
// S14F9 Create Object - Control Job
/*--------------------------------------------------------------------------*/
void    s14f9_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     index = 0;
        int     objack = 0;
        int     err_count = 0;
        TOBJ_INFO     tinfo;
        TOBJ_ERR_INFO errinfo;
    Gprintf ( "**-->S14F9 : Create Object Request( Cj )\n" );
    ei = DshDecodeS14F9( smsg, &tinfo );                    // S14F9decodeA擾
    if ( ei == 0 ){                                         // decode OK?
        if ( get_sim_operation_busy( ) == 0 ){         // Simulation ?
          disp_s14f9( &tinfo );
        }
        ei = EngAllocCjInfo( tinfo.objid, &index );  // CjIDo^
        if ( ei >= 0 ){
            ei = EngSetCjInfoX( index, &tinfo );      // CJݒ
            // ɕKvȏǉB
        }else{
            objack = 1;
        }
    }else{
        objack = 1;
    }
    err_count = 0;
    if ( objack == 0 ){                                     // error ack  ?
        objack = get_ack_value( X_S14F9 );
    }
    if ( objack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &errinfo, objack, err_count );    // <=== error count( test )
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( &errinfo, 0x12, "ERR01" );// errcode -1 && errtext
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 1 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( &errinfo, 0x13, "ERR02" );// errcode - 2 && errtext
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 2 ei = %d\n", ei );
        ei = DshPutTOBJ_ERR_INFO( &errinfo, 0x13, "ERR02" );// errcode - 3 ei( -1 )ɂȂ͂
        Gprintf( "   DshPutTOBJ_ERR_INFO( ) 3 ei = %d\n", ei );
    }
    ei = DshResponseS14F10( qmsg->trid, &tinfo, &errinfo );
                     //  - tinfoerinfoallocꂽ؂DshResponseS14F10( )JĂB
    if ( ei < 0 ){
        Gprintf( "    !!! S14F10 response send error\n" );
    }
    S14F9_CJID( &tinfo );
    DshFreeTOBJ_INFO( &tinfo );                             // DecodeŎgmemoryJ
}
//----- S14F9_CJID( ) -------------------------------------------
void    S14F9_CJID( TOBJ_INFO *info )
{
        int     ei;
    ei = EngSetSvVal( SV_CJID, (BYTE*)info->objid,  strlen( info->objid ) ); // ԕϐXV
    if ( ei == 0 ){
        ;
    }else{
        Gprintf( "    !!! SV_CJID set error\n" );
    }
}
//----- disp_s14f9( ) -------------------------------------------
void    disp_s14f9( TOBJ_INFO *info )
{
        int             i, j, k, n;
        int             *sptr;
        int             *ce_ptr;
        int             method;
        int             dstate;
        char            buff[256];
        TOBJ_ATTR_INFO  *p;
        TCJ_TEXT_INFO   *ptext;
        TVOID_LIST      *pvoid;
        TMTRL_OUT_STAT  *mostat;
        TMTRL_OUT_SPEC  *mospec;
        TPAUSE_EVENT    *pause;
        TCTRL_SPEC      *cspec;
        TOUT_RULE       *orule;
        TCTRL_RULE      *crule;
        TPRJ_STATE_LIST *pstat;

    Gprintf( "  ----- Object Information -----\n" );
    Gprintf( "    objspec = %s\n", info->objspec );
    Gprintf( "    objtype = %s\n", info->objtype );
    Gprintf( "    objid   = %s\n", info->objid  );
    //--------------------------------------------------------------
    n = info->attr_count;                               // attr 
    Gprintf( "    attr_count= %d\n", info->attr_count );
    if ( n > 0 ){
        for ( i=0; i < n; i++ ){
            p = ( TOBJ_ATTR_INFO* )info->attr_list[i];
            Gprintf( "    i-%d\n", i );
            switch ( p->attrid_index ){
            //--------------------------------------------------------------
            case EN_ObjID:
                Gprintf ( "      ObjID\n" );
                Gprintf( "       objid    = %s\n", ( char* )p->attrdata );
                break;
            //--------------------------------------------------------------
            case EN_CarrierInputSpec:
                Gprintf ( "      CarrierInputSpec\n" );
                if ( p->attrdata != NULL ){
                    ptext = ( TCJ_TEXT_INFO* )p->attrdata;
                    for ( j=0; j < ptext->text_count; j++ ){
                        Gprintf( "        j-%d\n", i );
                        Gprintf( "          car in spec = %s\n", ptext->text_list[j] );
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_CurrentPRJob:
                Gprintf ( "      Curretn PRJob\n" );
                if ( p->attrdata != NULL ){
                    ptext = ( TCJ_TEXT_INFO* )p->attrdata;
                    for ( j=0; j < ptext->text_count; j++ ){
                        Gprintf( "        j-%d\n", i );
                        Gprintf( "          current pr job = %s\n", ptext->text_list[j] );
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_DataCollectionPlan:
                Gprintf ( "      DataCollectionPlan\n" );
                Gprintf( "       data collect plan  = %s\n", ( char* )p->attrdata );
                break;
            //--------------------------------------------------------------
            case EN_MtrlOutByStatus:
                Gprintf ( "      MtrlOutByStatus\n" );
                if ( p->attrdata != NULL ){
                    pvoid = ( TVOID_LIST* )p->attrdata;
                    Gprintf( "       count =%d\n", pvoid->count );
                    for ( j=0; j < pvoid->count; j++ ){
                        mostat = ( TMTRL_OUT_STAT* )pvoid->void_list[j];
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          mtrl_status = %d\n", mostat->mtrl_status );
                        Gprintf( "          carid       = %s\n", mostat->carid );
                        Gprintf( "          slot count  = %d\n", mostat->slot_count );
                        sptr = mostat->slotid_list;
                        for ( k=0; k < mostat->slot_count; k++ ){
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           slotid = %d\n", sptr[k] );
                         }
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_MtrlOutSpec:
                Gprintf ( "      MtrlOutSpec\n" );
                if ( p->attrdata != NULL ){
                    pvoid = ( TVOID_LIST* )p->attrdata;
                    Gprintf( "       count = %d\n", pvoid->count );
                    for ( j=0; j < pvoid->count; j++ ){
                        mospec = ( TMTRL_OUT_SPEC* )pvoid->void_list[j];
                        Gprintf( "        j-%d\n", j );
                        //----- src
                        Gprintf( "          src carid     = %s\n", mospec->src_carid );
                        sptr = mospec->src_slotid_list;
                        Gprintf( "          src_slot_count = %d\n", mospec->src_slot_count );
                        for ( k=0; k < mospec->src_slot_count; k++ ){
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           src slotid = %d\n", sptr[k] );
                        }
                        //----- dst
                        Gprintf( "          dst carid     = %s\n", mospec->dst_carid );
                        sptr = mospec->dst_slotid_list;
                        Gprintf( "          dst_slot_count = %d\n", mospec->dst_slot_count );
                        for ( k=0; k < mospec->dst_slot_count; k++ ){
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           dst slotid = %d\n", sptr[k] );
                        }
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_PauseEvent:
                Gprintf ( "      PauseEvent\n" );
                if ( p->attrdata != NULL ){
                    pause = ( TPAUSE_EVENT* )p->attrdata;
                    Gprintf( "        ce_count = %d\n", pause->ce_count );
                    ce_ptr = pause->ceid_list;
                    for ( j=0; j < pause->ce_count; j++ ){
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          ceid   = %d\n", pause->ceid_list[j] );
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_ProcessingCtrlSpec:
                Gprintf ( "      ProcessingCtrlSpec\n" );
                if ( p->attrdata != NULL ){
                    pvoid = ( TVOID_LIST* )p->attrdata;
                    Gprintf( "       count = %d\n", pvoid->count );
                    for ( j=0; j < pvoid->count; j++ ){
                        cspec = ( TCTRL_SPEC* )pvoid->void_list[j];
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          prjobid       = %s\n", cspec->prjobid );
                        Gprintf( "          ctrl rue count= %d\n", cspec->ctrl_rule_count );
                        for ( k=0; k < cspec->ctrl_rule_count; k++ ){
                            crule = ( TCTRL_RULE* )cspec->ctrl_rule_list[k];
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           name   = %s\n", crule->name );
                            data_to_string( crule->fmt, crule->asize, (BYTE*)crule->value, buff );
                            Gprintf( "           value  = %s\n", buff );
                        }
                        Gprintf( "          out rule count= %d\n", cspec->out_rule_count );
                        for ( k=0; k <cspec->out_rule_count; k++ ){
                            orule = ( TOUT_RULE* )cspec->out_rule_list[k];
                            Gprintf( "         k-%d\n", k );
                            Gprintf( "           status = %d\n", orule->status );
                            data_to_string( orule->fmt, orule->asize, (BYTE*)orule->value, buff );
                            Gprintf( "           value  = %s\n", buff );
                        }
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_ProcessingOrderMgmt:
                Gprintf( "      ProcessingOrderMgmt\n" );
                Gprintf( "        order management = %d\n", ( int )p->attrdata );
                break;
            //--------------------------------------------------------------
            case EN_PRJobStatusList:
                Gprintf ( "      PRJobStatesList\n" );
                if ( p->attrdata != NULL ){
                    pstat = ( TPRJ_STATE_LIST* )p->attrdata;
                    Gprintf( "       count = %d\n", pstat->prj_count );
                    for ( j=0; j < pstat->prj_count; j++ ){
                        Gprintf( "        j-%d\n", j );
                        Gprintf( "          prj name        = %s\n", pstat->prj_list[j] );
                        Gprintf( "          state           = %d\n", pstat->state_list[j] );
                    }
                }
                break;
            //--------------------------------------------------------------
            case EN_StartMethod:
                Gprintf ( "      StartMethod\n" );
                method = ( int )p->attrdata;
                if ( method != 0 )
                    Gprintf ( "        start method = True" );
                else
                    Gprintf ( "        start method = False" );
                break;
            //--------------------------------------------------------------
            case EN_State:
                Gprintf ( "      State\n" );
                dstate = ( int )p->attrdata;
                Gprintf( "        state  = %d\n", dstate );
                break;
            //--------------------------------------------------------------
            default:
                break;
            }
        }
    }
}
//=============================================================================
/*--------------------------------------------------------------------------*/
// S14F11 Delete Object
/*--------------------------------------------------------------------------*/
void    s14f11_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int             ei;
        int             objack = 0;
        int             err_count = 0;
        TOBJ_INFO       tinfo;
        TOBJ_ERR_INFO   erinfo;
    Gprintf( "**-->S14F11 : Delete Object\n" );
    ei = DshDecodeS14F11( smsg, &tinfo );
    if ( ei == 0 ){
        if ( get_sim_operation_busy( ) == 0 ){
            disp_s14f9( &tinfo );                           // s14f9Ɠ
            ei = EngDelCjInfo( tinfo.objid );        // CjID폜
        }
        if ( ei >= 0 ){
          // ɕKvȏǉB
        }else{
          objack = 1;
        }
    }else{
        objack = 1;
    }
    if ( objack == 0 ){                                     // error ack  ?
        objack = get_ack_value( X_S14F11 );
    }
    if ( objack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &erinfo, objack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( &erinfo, 11, "Not Deleted" ); // errcode -1
    }
    ei = DshResponseS14F12( qmsg->trid,  &tinfo , &erinfo );
                     //  - erinfoallocꂽ؂DshResponseS14F12( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S14F12 response send error\n" );
    }
    DshFreeTOBJ_INFO( &tinfo );
}

//=============================================================================
/*--------------------------------------------------------------------------*/
// S15F3 Recipe name Space Action
/*--------------------------------------------------------------------------*/
void    s15f3_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int             ei;
        int             rmack = 0;
        int             err_count = 0;
        TRCP_ERR_INFO   erinfo;
        TRCP_ACT_INFO   tinfo;
    Gprintf( "**-->S15F3 : Recipe Name Space Action\n" );
    ei = DshDecodeS15F3( smsg, &tinfo );                    // decode s15f3
    if ( ei == 0 ){
        if ( get_sim_operation_busy( ) == 0 ){
            disp_s15f3( &tinfo );
            s_do_recipe_ope( &tinfo, &erinfo );
        }
    }else{
        rmack = 1;
    }if ( ei == 0 ){
            //S15F3_CJID( info );
    }
    if ( rmack == 0 ){                                      // error ack  ?
        rmack = get_ack_value( X_S15F3 );
    }
    if ( rmack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &erinfo, rmack, err_count );      // <=== error
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 3, "Space Action Negative" );         // errtext
    }
    ei = DshResponseS15F4( qmsg->trid, &tinfo, &erinfo );
                     //  - tinfoerinfoallocꂽ؂DshResponseS15F4( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S15F4 response send error\n" );
    }
}
//----- disp_s15f3( ) -------------------------------------------
void    disp_s15f3( TRCP_ACT_INFO *info )
{
    Gprintf( "    rcpid   = %s\n", info->rmnsspec );
    Gprintf( "    cmd     = %d\n", info->rmnscmd );
}
//----- s_do_recipe_ope( ) ----------------------------------------
void    s_do_recipe_ope( TRCP_ACT_INFO *info, TRCP_ERR_INFO *erinfo )
{
        int index = 0;
        int ei = 0;
    switch( info->rmnscmd ){
    case 1:                                                     // Create
        ei = EngAllocRcpInfo( info->rmnsspec, &index );  // RcpIDo^
        Gprintf ( "        EngAllocRcpInfo( ) ei = %d\n", ei );
        if ( ei >= 0 ){
            // ɕKvȏǉB
        }else{
            erinfo->rmack = 1;
        }
        break;
    case 5:
        ei = EngGetRcpIdIndex( info->rmnsspec, &index );
        if ( ei < 0 ){
            erinfo->rmack = 3;
        }else{
            ei = EngDelRcpInfoX( index );
            Gprintf ( "        EngDelRcpInfo( ) ei = %d\n", ei );
        }
        break;
    default:
        erinfo->rmack = 4;
        break;
    }
}
//=============================================================================
/*--------------------------------------------------------------------------*/
// S15F5 Recipe Rename
/*--------------------------------------------------------------------------*/
void    s15f5_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int                 rmack = 0;
        int                 ei;
        int                 err_count = 0;
        TRCP_RENAME_INFO    info;
        TRCP_ERR_INFO       erinfo;
    Gprintf ( "**-->S15F5 : Recipe Rename Request" );
    ei = DshDecodeS15F5( smsg, &info );
    if ( ei == 0 ){
        if ( get_sim_operation_busy( ) == 0 ){
            disp_s15f5( &info );
            rmack = do_rename_rcp( &info, &erinfo );
        }
    }else{
        rmack = 1;
    }
    if ( ei == 0 ){
        ;
    }
    if ( rmack == 0 ){                                      // error ack  ?
        rmack = get_ack_value( X_S15F5 );
    }
    if ( rmack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &erinfo, rmack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 3, "Rename error" );
    }
    ei = DshResponseS15F6( qmsg->trid, &info, &erinfo );
                     //  - tinfoerinfoallocꂽ؂DshResponseS15F6( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S15F6 response send error\n" );
    }
}
//----- disp_s15f5( ) -------------------------------------------
void    disp_s15f5( TRCP_RENAME_INFO *info )
{
    Gprintf( "    rcpid       = %s\n", info->rmnsspec );
    Gprintf( "    rcpid(new)  = %s\n", info->rmnewns );
}
//----- do_rename_rcp( ) ----------------------------------------
int     do_rename_rcp( TRCP_RENAME_INFO *info, TRCP_ERR_INFO *erinfo )
{
        int     ei;
    ei = EngRenameRcpId( info->rmnsspec, info->rmnewns );
    Gprintf( " EngRenameRcpId( ) ei = %d\n", ei );
    if ( ei == 0 ) return 0;
    else           return 1;
}
//============================================================================
/*--------------------------------------------------------------------------*/
/* S15F13 Create / Update Recipe Request                                    */
/*--------------------------------------------------------------------------*/
void    s15f13_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int             rmack = 0;
        int             ei;
        int             err_count = 0;
        int             updt_flag = 0;
        TRCP_INFO       tinfo;
        TRCP_ERR_INFO   erinfo;
        char            rcpid[81];
    Gprintf ( "**-->S15F13 : Create / Update Recipe Request" );
    updt_flag = 0;
    ei = DshDecodeS15F13( smsg, &tinfo, &updt_flag );
    if ( ei == 0 ){
        strcpy( rcpid, tinfo.rcpspec );                     // save rcpid
        if ( get_sim_operation_busy( ) == 0 ){         // simulation active ?
            disp_s15f13( &tinfo, updt_flag );
            do_recipe_reg( &tinfo, &erinfo );         // recipeo^
        }
    }else{
        rmack = 1;
    }
    if ( ei == 0 ){
        ;
    }
    if ( rmack == 0 ){                                      // error ack  ?
        rmack = get_ack_value( X_S15F13 );
    }
    if ( rmack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &erinfo, rmack, err_count );      // errcount = 2
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 3, "Update error" );
    }
    ei = DshResponseS15F14( qmsg->trid, &tinfo, &erinfo );
                     //  - tinfoerinfoallocꂽ؂DshResponseS15F14( )JĂB
                     // JȂꍇ u_s15f13.c CĂB
    if ( ei < 0 ){
        Gprintf( "    !!! S15F14 response send error\n" );
    }

    if ( rmack == 0 ){
        ei = EngSetSvVal( SV_PPID, rcpid, strlen( rcpid) );  // SV
        if ( ei == 0 ){
            ;
        }else{
            Gprintf( "    !!! S15F13 : EngSetSvVal() error - rcpspec = %s\n", rcpid );
        }
    }
}
//----- disp_s15f13( ) -------------------------------------------
void    disp_s15f13( TRCP_INFO *info, int updt_flag )
{
        int     i;
        char    buff[256];
    Gprintf( "----- RCP Information -----\n" );
    Gprintf( "    rcpid      = %s\n", info->rcpspec );
    if ( updt_flag == 0 ){
        Gprintf( "    ( Create )" );
    }else{
        Gprintf( "    ( Update )" );
    }
    Gprintf( "    rcpbody    = %s\n", info->rcpbody );
    Gprintf( "    para count = %d\n", info->para_count );
    for ( i=0; i < info->para_count; i++ ){
        TRCP_PARA *pinfo = info->para_list[i];
        Gprintf( "      i-%d\n", i );
        Gprintf( "        rcpparanm = %s\n", pinfo->rcpparnm );

        data_to_string( pinfo->par_fmt, pinfo->par_size, (BYTE*)pinfo->rcpparval, buff );
        Gprintf( "        rcpparval = %s\n", buff );
    }
}
//----- do_recipe_reg( ) ----------------------------------------
void    do_recipe_reg( TRCP_INFO *info, TRCP_ERR_INFO *erinfo )
{
        int     index;
        int     ei;
    ei = EngAllocRcpInfo( info->rcpspec, &index );   // RcpIDo^
    Gprintf ( "    EngAllocRcpInfo( ) ei = %d\n", ei );
    if ( ei >= 0 ){
        ei = EngSetRcpInfoX( index, info );
        Gprintf ( "    EngSetRcpInfoX( ) ei = %d\n", ei );
        if ( ei == 0 ) erinfo->rmack = 0;
        else           erinfo->rmack = 1;
    }
    else erinfo->rmack = 1;
}
//=============================================================================
/*--------------------------------------------------------------------------*/
// S16F5 PRJob Command Request
/*--------------------------------------------------------------------------*/
void    s16f5_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     acka =1;
        int     ei;
        int     err_count = 0;
        TPRJ_CMD_ERR_INFO   erinfo;
        TPRJ_CMD_INFO       info;
    Gprintf ( "**-->S16F5 PRJob Command Request\n" );
    ei = DshDecodeS16F5( smsg, &info );
    if ( ei == 0 ){
        disp_s16f5( &info );
        acka = 1;             // True
        // ɕKvȏǉB
    }else{
        acka = 0;             // False
    }
    if ( acka == 1 ){                                       // error ack  ?
        acka = get_ack_value( X_S16F5 );
    }
    if ( acka == 0 ){                                       // falseerror
        err_count =1;
    }
    DshInitTPRJ_CMD_ERR_INFO( &erinfo, info.prjobid, acka, err_count );
    if ( err_count > 0 ){
        DshPutTERR_INFO_LIST( erinfo.err_list, erinfo.err_count, 23, "ERR23" );
    }
    ei = DshResponseS16F6( qmsg->trid, &info, &erinfo );  //  S16F6
                     //  - infoerinfoallocꂽ؂DshResponseS16F6( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S16F16 response send error\n" );
    }
}
//------ disp_s16f5( ) ------------------------------------------
void    disp_s16f5( TPRJ_CMD_INFO *info )
{
        int     i;
        char    buff[256];
        TCMD_PARA *pinfo;
    Gprintf ( "    prjobid  = %s\n", info->prjobid );
    Gprintf ( "    cmd      = %s\n", info->cmd );
    Gprintf ( "    cmd index= %d\n", info->cmd_index );
    Gprintf ( "    cp_count = %d\n", info->cp_count );
    for ( i = 0; i < info->cp_count; i++ ){
        pinfo = info->cp_list[i];
        Gprintf ( "     i-%d\n", i );
        Gprintf ( "      cpname   = %s\n", pinfo->cpname );
        data_to_string( pinfo->cpval_fmt, pinfo->cpval_size, (BYTE*)pinfo->cpval, buff );
        Gprintf ( "      cpval    = %s\n", buff );
    }
}
//=============================================================================
/*--------------------------------------------------------------------------*/
// S16F11 PRJob Create Enh
/*--------------------------------------------------------------------------*/
void    s16f11_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     index = 0;
        int     acka = 1;
        int     err_count = 0;
        int     result_flag = 0;
        TPRJ_INFO       info;
        TPRJ_ERR_INFO   errinfo;
    Gprintf ( "**-->S16F11 PRJob Create\n" );
    ei = DshDecodeS16F11( smsg, &info );                    // S16F11-->TPRJ_INFO޺
    if ( ei == 0 ){
        if ( get_sim_operation_busy( ) == 0 ){
            disp_s16f11( &info );
        }
        ei = EngAllocPrjInfo( info.prjobid, &index );// PrjIdo^
        Gprintf( "        EngApi.EngAllocPrjInfo( ) ei = %d\n", ei );
        if ( ei >= 0 ){
            ei = EngSetPrjInfoX( index, &info );      // Prjݒ
            Gprintf( "        EngSetPrjInfoX( ) ei = %d\n", ei );
                // ɕKvȏǉB
        }
        if ( result_flag == 0 ){
            acka = 1;         // True
        }else{
            acka = 0;         // False
        }
    }else{
        acka = 0;            // False
    }
//----- S16F12  -------------------------------------------
    if ( acka == 1 ){                                       // error ack  ?
        acka = get_ack_value( X_S16F11 );
    }
    if ( acka == 0 ){                                       // falseerror
        err_count =1;
    }
    DshInitTPRJ_ERR_INFO( &errinfo, 1, acka, err_count );
    ei = DshPutTPRJ_ERR_PRJID( &errinfo, info.prjobid );
    if ( err_count > 0 ){
        ei = DshPutTPRJ_ERR_INFO( &errinfo, 0x12, "ERR01" );    // errtext
        Gprintf( "        DshPutTPRJ_ERR_INFO( ) 1 ei = %d\n", ei );
    }
    ei = DshResponseS16F12( qmsg->trid, NULL, &errinfo ); //  S16F16
                     //  - erinfoallocꂽ؂DshResponseS16F12( )JĂB
    if ( ei < 0 ){
        Gprintf( "    !!! S16F12 response send error\n" );
    }
    if ( acka == 1 ){
        ;
    }
    DshFreeTPRJ_INFO( &info );
}
//----- disp_s16f11( ) - Process Job Information -----------------
void    disp_s16f11( TPRJ_INFO *info )
{
        int     i, j, n;
        char    buff[128];
        TCAR_INFO   *car_info;
        TSLOT_INFO  *slot_info;
        TRCP_INFO   *rcp_info;
        TRCP_PARA   *rcp_para;
    Gprintf( "    prjid    = %s\n", info->prjobid );
    Gprintf( "    mf       = %d\n", info->mf );
    Gprintf( "    carcount = %d\n", info->car_count );
    for ( i = 0; i < info->car_count; i++ ){
        car_info = info->car_list[i];
        Gprintf( "     i-%d\n", i );
        Gprintf( "      car_id    = %s\n", car_info->carid );
        Gprintf( "      slot_count= %d\n", car_info->slot_count );
        for ( j = 0; j < car_info->slot_count; j++ ){
            slot_info = car_info->slot_list[j];
            Gprintf( "       %d - slotid = %d\n", j ,  slot_info->slotid );
        }
        //---- RCP INFO ----
        Gprintf( "    prrcpmethod = %d\n", info->prrecipemethod );
        if ( info->rcp_info != ( TRCP_INFO* )NULL ){
            rcp_info = info->rcp_info;
            Gprintf( "    rcpspec    = %s\n", rcp_info->rcpspec );
            Gprintf( "    rcpbody    = %s\n", rcp_info->rcpbody );
            Gprintf( "    para count = %d\n", rcp_info->para_count );
            for ( j=0; j < rcp_info->para_count; j++ ){
                rcp_para = rcp_info->para_list[j];
                Gprintf( "     j-%d\n", j );
                if ( rcp_para->rcpparnm != NULL ){
                    Gprintf( "       rcpparnm  = %s\n", rcp_para->rcpparnm );
                }
                if ( rcp_para->rcpparval != NULL ){
                    data_to_string( rcp_para->par_fmt, rcp_para->par_size,
                                (BYTE*)rcp_para->rcpparval, buff );
                    Gprintf( "       rcpparval = %s\n", buff );
                }
            }
        }
        Gprintf( "    prprocessstart = %d\n", info->prprocessstart );
        n = info->ceid_count;
        Gprintf( "    ceid_count = %d\n", info->ceid_count );
        for ( i=0; i < info->ceid_count; i++ ){
          Gprintf( "    pauseceid      = %d\n", info->pause_ceid_list[i] );
        }
    }
}
//=============================================================================
/*--------------------------------------------------------------------------*/
// S16F15 PRJob Multi Create
/*--------------------------------------------------------------------------*/
void    s16f15_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     i;
        int     index = 0;
        int     acka = 1;
        int     result_flag = 0;
        int     err_count = 0;
        TPRJ_ERR_INFO   errinfo;
        TPRJ_LIST       linfo;
        TPRJ_INFO       **q;
        TPRJ_INFO       *info;
    Gprintf ( "**-->S16F15 PRJob Multi Create\n" );
    ei = DshDecodeS16F15( smsg, &linfo );                   // S16F15-->TPRJ_LIST޺
    if ( ei == 0 ){
        q = linfo.prj_list;
        for ( i = 0; i < linfo.prj_count; i++ ){            // ܂܂鐔PRJ̏
            info = linfo.prj_list[i];                       // TPRJ_INFO
            if ( get_sim_operation_busy( ) == 0 ){
                disp_s16f15( info );
            }
            ei = EngAllocPrjInfo( info->prjobid, &index ); // PrjIdo^
            if ( ei >= 0 ){
                ei = EngSetPrjInfoX( index, info );   // Prjݒ
                // ɕKvȏǉB
            }
            if ( ei < 0 ){
                result_flag = 1;                            // error
                break;
            }
        }
        if ( result_flag == 0 ){
            acka = 1;         // True
        }else{
            acka = 0;         // False
        }
    }else{
        acka = 0;            // False
    }
//----- S16F16  -------------------------------------------
    if ( acka == 1 ){                                       // error ack  ?
        acka = get_ack_value( X_S16F15 );
    }
    if ( acka == 0 ){                                       // falseerror
        err_count =1;
    }
    DshInitTPRJ_ERR_INFO( &errinfo, linfo.prj_count, acka, err_count );
    for ( i=0; i < linfo.prj_count; i++ ){
        ei = DshPutTPRJ_ERR_PRJID( &errinfo, linfo.prj_list[i]->prjobid );
    }
    if ( err_count > 0 ){
        ei = DshPutTPRJ_ERR_INFO( &errinfo, 0x12, "ERR01" );// errtext
        Gprintf( "   DshPutTPRJ_ERR_INFO( ) 1 ei = %d\n", ei );
    }
    ei = DshResponseS16F16( qmsg->trid, NULL, &errinfo );  //  S16F16
                     //  - erinfoallocꂽ؂DshResponseS16F16( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S16F16 response send error\n" );
    }
    if ( acka == 1 ){
        ;
    }
    DshFreeTPRJ_LIST( &linfo );
}

//----- disp_s16f15( ) - Process Job Information -----------------
void    disp_s16f15( TPRJ_INFO *info )
{
        int     i, j;
        char buff[128];
        TCAR_INFO   *car_info;
        TSLOT_INFO  *slot_info;
        TRCP_INFO   *rcp_info;
        TRCP_PARA   *rcp_para;
    Gprintf( "    prjid    = %s\n", info->prjobid );
    Gprintf( "    mf       = %d\n", info->mf );
    Gprintf( "    carcount = %d\n", info->car_count );
    for ( i = 0; i < info->car_count; i++ ){
        car_info = info->car_list[i];
        Gprintf( "     i-%d\n", i );
        Gprintf( "      car_id    = %s\n", car_info->carid );
        Gprintf( "      slot_count= %d\n", car_info->slot_count );

        for ( j = 0; j < car_info->slot_count; j++ ){
            slot_info = car_info->slot_list[j];
            Gprintf( "       %d - slotid = %d\n", j ,  slot_info->slotid );
        }
        //---- RCP INFO ----
        Gprintf( "    prrcpmethod = %d\n", info->prrecipemethod );
        if ( info->rcp_info != ( TRCP_INFO* )NULL ){
            rcp_info = info->rcp_info;
            Gprintf( "    rcpspec    = %s\n", rcp_info->rcpspec );
            Gprintf( "    rcpbody    = %s\n", rcp_info->rcpbody );
            Gprintf( "    para count = %d\n", rcp_info->para_count );
            for ( j=0; j < rcp_info->para_count; j++ ){
                rcp_para = rcp_info->para_list[j];
                Gprintf( "     j-%d\n", j );
                if ( rcp_para->rcpparnm != NULL ){
                    Gprintf( "       rcpparnm  = %s\n", rcp_para->rcpparnm );
                }
                if ( rcp_para->rcpparval != NULL ){
                    data_to_string( rcp_para->par_fmt, rcp_para->par_size,
                                            (BYTE*)rcp_para->rcpparval, buff );
                    Gprintf( "       rcpparval = %s\n", buff );
                }
            }
        }
        Gprintf( "    prprocessstart = %d\n", info->prprocessstart );
        Gprintf( "    ceid_count = %d\n", info->ceid_count );
        for ( i=0; i < info->ceid_count; i++ ){
            Gprintf( "    pauseceid      = %d\n", info->pause_ceid_list[i] );
        }
    }
}
//=============================================================================
/*--------------------------------------------------------------------------*/
// S16F17 PRJob Deque
/*--------------------------------------------------------------------------*/
void    s16f17_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     index;
        int     acka = 1;
        int     result_flag;
        int     i;
        int     err_count = 0;
        TPRJ_DEQ_INFO       linfo;
        TPRJ_DEQ_ERR_INFO   erinfo;
    Gprintf ( "**-->S16F17 PRJob Dequeue\n" );
    ei = DshDecodeS16F17( smsg, &linfo );
    if ( ei == 0 ){
        Gprintf( "  prj count = %d\n", linfo.prj_count );
        if ( linfo.prj_count > 0 ){
            for ( i = 0; i < linfo.prj_count; i++ ){
                Gprintf( "   i-%d\n", i );
                index = 0;
                Gprintf( "      prjid = %s\n", linfo.prj_list[i] );
                ei = EngGetPrjIdIndex( linfo.prj_list[i], &index );
                Gprintf( "     EngApi.EngGetPrjIdIndex( ) ei = %d\n", ei );
                if ( ei == 0 ){
                    ei = EngDelPrjInfo( linfo.prj_list[i] ); //PRJ1폜
                    Gprintf( "     EngApi.EngDelPrjInfo( ) ei = %d\n", ei );
                    // ɕKvȏǉB
                    if ( ei < 0 ){
                        result_flag = 1;
                    }
                }else{
                    Gprintf( "      ( prjid not exist )\n" );
                }
            }
            if ( result_flag == 0 ){
                acka = 1;         // True
            }else{
                acka = 0;         // False
            }
        }else{                                              // all prjid
            Gprintf( "    !! Dequeue All Prj \n" );
            for ( i = 0; i < 256; i++ ){
                char    prjid[80];
                ei = EngGetPrjId( i, prjid );
                if ( ei >= 0 ){
                    Gprintf( "    index  = %d\n", i );
                    Gprintf( "    prjid = %s\n", prjid );
                    ei = EngDelPrjInfoX( i );         // i=index PRJ폜
                    Gprintf( "    EngApi.EngDelPrjInfo( ) ei = %d\n", ei );
                }
            }
            Gprintf( "    All Prj Dequeue end\n" );
            acka = 1;           // True
        }
    }else{
        acka = 0;               // False
    }
    if ( acka == 1 ){                                       // error ack  ?
        acka = get_ack_value( X_S16F17 );
    }
    if ( acka == 0 ){                                       // falseerror
        err_count =1;
    }
    DshInitTPRJ_DEQ_ERR_INFO( &erinfo, &linfo, acka, err_count );
    if ( err_count > 0 ){
        DshPutTERR_INFO_LIST( erinfo.err_list, erinfo.err_count, 17, "ERR17" );
    }
    ei = DshResponseS16F18( qmsg->trid, &linfo, &erinfo );  //  S16F18
                     //  - linfoerinfoallocꂽ؂DshResponseS16F18( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S16F18 response send error\n" );
    }
}
//=============================================================================
/*--------------------------------------------------------------------------*/
// S16F27 Control Command Request
/*--------------------------------------------------------------------------*/
void    s16f27_proc( DSHMSG *smsg, TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     acka = 1;                   // True
        int     index;
        int     err_flag;
        TCJ_CMD_ERR_INFO    erinfo;
        TCJ_CMD_INFO        info;
    Gprintf ( "**-->S16F27 Control Command Request\n" );
    ei = DshDecodeS16F27( smsg, &info );
    if ( ei == 0 ){
        disp_s16f27( &info );
        ei = EngGetCjIdIndex( info.ctljobid, &index );
        Gprintf ( "    EngGetCjIdIndex( ) ei = %d\n", ei );
        if ( ei == 0 ){
            acka = 1;           // True
            // ɕKvȏǉB
        }else{
            acka = 0;           // False
        }
    }else{
        acka = 0;               // False
    }
    if ( acka == 1 ){                                       // error ack  ?
        acka = get_ack_value( X_S16F5 );
    }
    err_flag = ( acka ? 0 : 1 );                            // err TERR_INFO L 0=ȂA1=
    if ( err_flag != 0 ){
        DshInitTCJ_CMD_ERR_INFO( &erinfo, acka, err_flag, 27, "CJID not Found" );
    }else{
        DshInitTCJ_CMD_ERR_INFO( &erinfo, acka, err_flag, 0, NULL );
    }
    ei = DshResponseS16F28( qmsg->trid, &info, &erinfo );  //  S16F28
                     //  - infoerinfoallocꂽ؂DshResponseS16F28( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S16F28 response send error\n" );
    }
}

//----- s16f27 text display -------------------------------------
void    disp_s16f27( TCJ_CMD_INFO *info )
{
        char    buff[256];
        TCMD_PARA *para_info;
    Gprintf( "    cjid     = %s\n", info->ctljobid );
    Gprintf( "    cjcmd    = %s\n", info->cmd );
    Gprintf( "    cmd index= %d\n", info->cmd_index );
    if ( info->cp_info != NULL ){
        para_info = info->cp_info;
        Gprintf( "    cpname   = %s\n", para_info->cpname );
        data_to_string( para_info->cpval_fmt, para_info->cpval_size, (BYTE*)para_info->cpval, buff );
        Gprintf( "    cpval    = %s\n", buff );
    }else{
        Gprintf( "    no parameter" );
    }
}
