/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_poll.c                            */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/
#include    "all.h"

static  int     stop_flag;                        // poll stop flag

/*--------------------------------------------------------------------------*/
// s_poll_thread() - Polling Thread
/*--------------------------------------------------------------------------*/
void    s_poll_thread( void )
{
    stop_flag = 0;
    Gprintf( "        <=== poll_thread start\n" );
    while( stop_flag == 0 ){                  // do until stop request
        s_check_rcv_message( );                // check queue and process
        Sleep( 10 );
    }
    Gprintf( "        <=== poll_thread end\n" );
    stop_flag = 0;
    END_THREAD(0);
}
/*--------------------------------------------------------------------------*/
/* s_stop_poll_thread() - Stop s_poll_thread()                              */
/*--------------------------------------------------------------------------*/
void    s_stop_poll_thread( void )
{
    stop_flag = 1;
    while( stop_flag == 1 ){ Sleep(10); }
}
/*------------------------------------------------------------*/
// s_check_rcv_message() - Check if any message from DSHENG4
//                        If available, process it
/*------------------------------------------------------------*/
int     s_check_rcv_message( void )
{
        int     ei;
        TMSG_QUEUE_INFO qmsg, *pass_qmsg;
        DSHMSG          *minfo;
        int             s, f;
    ei = EngGetSecsMsgReq( &qmsg );                     // any message from host ?
    if ( ei <= 0 ) return 0;
    pass_qmsg = g_malloc( sizeof(TMSG_QUEUE_INFO), 1001 );
    *pass_qmsg = qmsg;
    minfo = pass_qmsg->smsg;                            // qmsgsmsgDSHSMG
#if 0
    Gprintf( "        Poll true S%dF%d received\n", minfo->stream, minfo->function );
#endif
    s = minfo->stream; f = minfo->function;
    if ( p_get_sim_busy( ) != 0 ){                      // Awafer processing (simulation)Ȃ΁A
        if ( ( s==3 && f==17 ) ||                       // msg simulation programɓnB
                ( s==7 && f==3 ) || ( s==7 && f==23 ) ||
                ( s==15 && f==13 ) ||
                ( s==14 && f==9 ) || ( s==14 && f==11 ) ||
                ( s==16 && f==11 ) || (s==16 && f==15 ) ){
            s_put_msg_list( pass_qmsg );
            return 0;
        }
    }
    ei = s_proc_rcv_msg( pass_qmsg );                 // ̑
    DshFreeMsg( minfo );                                    // Free smsg
    g_free( pass_qmsg );          // & free pass_qmsg
    return ei;
}
/*------------------------------------------------------------*/
// s_proc_rcv_message() - process message from DSHENG4
/*------------------------------------------------------------*/
int     s_proc_rcv_msg( TMSG_QUEUE_INFO *qmsg )
{
        DSHMSG *minfo = qmsg->smsg;

    switch (minfo->stream){                                 // Stream ŕ
    case 1:     // S1Fx
        switch (minfo->function){
        case 15:                                    // S1F15 Offline Request
            s1f15_proc( minfo, qmsg );
            break;
        case 17:                                    // S1F17 Online Request
            s1f17_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;
//-------------------------------------------------------------
    case 2:     // S2Fx
        switch (minfo->function){
        case 23:                                    // S2F23 Trace Condition
            s2f23_proc( minfo, qmsg );
            break;
        case 41:                                    // S2F41 Host Command
            s2f41_proc( minfo, qmsg );
            break;
        case 43:                                    // S2F43 Reset Spool Stream & Function
            s2f43_proc( minfo, qmsg );
            break;
        case 45:                                    // S2F45 Varable Limit
            s2f45_proc( minfo, qmsg );
            break;
        case 49:                                    // S2F49 Enhanced Host Command
            s2f49_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;
//-------------------------------------------------------------
    case 3:     // S3Fx
        switch (minfo->function){
        case 17:                                    // S3F17 Carrier Action Request
            s3f17_proc( minfo, qmsg );
            break;
        case 23:                                    // S3F23 Port Group Action
            s3f23_proc( minfo, qmsg );
            break;
        case 25:                                    // S3F25 Port Action
            s3f25_proc( minfo, qmsg );
            break;
        case 27:                                    // S3F27 Change Access
            s3f27_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;

//-------------------------------------------------------------
    case 7:     // S7Fx
        switch (minfo->function){
        case 1:                                     // S7F1  Process Program Load Inq
            s7f1_proc( minfo, qmsg );
            break;
        case 3:                                     // S7F3 Process Program Send
            s7f3_proc( minfo, qmsg );
            break;
        case 23:                                    // S7F23 Formatted Process Program Send
            s7f23_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;

//-------------------------------------------------------------
    case 10:        // S10Fx
        switch (minfo->function){
        case 3:                                     // S10F3 Terminal Request( Single )
            s10f3_proc( minfo, qmsg );
            break;
        case 5:                                     // S10F5 Terminal Request( Multi-block )
            s10f5_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;
//-------------------------------------------------------------
    case 14:        // S14Fx
        switch (minfo->function){
        case 9:                                     // S14F9 Create Object Request
            s14f9_proc( minfo, qmsg );
            break;
        case 11:                                    // S14F11 Delete Object Request
            s14f11_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;
//-------------------------------------------------------------
    case 15:        // S15Fx
        switch (minfo->function){
        case 3:                                     // S15F3 Recipe Name Action Request
            s15f3_proc( minfo, qmsg );
            break;
        case 5:                                     // S15F5 Recipe Name Space Rename Request
            s15f5_proc( minfo, qmsg );
            break;
        case 13:                                    // S15F13 Recipe Create Request
            s15f13_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;
//-------------------------------------------------------------
    case 16:        // S16Fx
        switch (minfo->function){
        case 5:                                     // S16F5 Process Job Cmd Request
            s16f5_proc( minfo, qmsg );
            break;
        case 11:                                    // S16F11 PrJob Create Enh
            s16f11_proc( minfo, qmsg );
            break;
        case 15:                                    // S16F15 PrJob Multi Create
            s16f15_proc( minfo, qmsg );
            break;
        case 17:                                    // S16F17 PrJob Deque
            s16f17_proc( minfo, qmsg );
            break;
        case 27:                                    // S16F27 Control Job Command Request
            s16f27_proc( minfo, qmsg );
            break;
        default:
            break;
        }
        break;
//-------------------------------------------------------------
    default:
        break;
    }
 //   DshFreeMsg( minfo );                            // Free smsg
    return 1;
}
/*------------------------------------------------------------*/
int     ack_tab[] = {
        0,              // S1F15
        0,              // S1F17
        0,              // S2F23
        0,              // S2F41
        0,              // S2F43
        0,              // S2F45
        0,              // S2F49
        0,              // S3F17
        0,              // S3F23
        0,              // S3F25
        0,              // S3F27
        0,              // S7F1
        0,              // S7F3
        0,              // S7F23
        0,              // S10F3
        0,              // S10F5
        0,              // S14F9
        0,              // S14F11
        0,              // S15F3
        0,              // S15F5
        0,              // S15F13
        1,              // S16F5
        1,              // S16F11
        1,              // S16F15
        1,              // S16F17
        1,              // S16F27
        0,
        0,
        0
        };

/*------------------------------------------------------------*/
// get_ack_value()
/*------------------------------------------------------------*/
int     get_ack_value( int ack_index )
{
    return ack_tab[ack_index];
}

