/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_print.c                           */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/
#include "all.h"

static  pthread_mutex_t log_mutex;          // mutex id

static  FILE    *fp_common = NULL;          // FILE
static  int     print_flag = 1;             // printf() enable(1) or disable(0)
/*---------------------------------------------------------------------*/
/* init_Gpirntf()                                                      */
/*---------------------------------------------------------------------*/
void init_Gpirntf( char *fname )
{
    fp_common = fopen( fname, "w" );
    mutex_init( &log_mutex, USYNC_PROCESS_ROBUST, NULL );
}
/*---------------------------------------------------------------------*/
/* term_Gpirntf()                                                      */
/*---------------------------------------------------------------------*/
void term_Gpirntf( void )
{
    if ( fp_common != NULL ){
        fclose( fp_common );
        fp_common = NULL;

        mutex_destroy( &log_mutex );
    }
}
/*---------------------------------------------------------------------*/
/* Gprintf() :               Log                                       */
/*---------------------------------------------------------------------*/
    void   Gprintf( const char * pfmt, ... )
{
        char        *buffer;
        va_list     marker;
        int         pos;
    mutex_lock( &log_mutex );
    buffer = malloc( 0x20000 );
    DshFormatDateTime( buffer, "YYYY-MM-DD HH:NN:SS.CC " );
    pos = strlen( buffer );
    va_start( marker, pfmt );
    vsprintf( buffer+strlen(buffer), pfmt, marker );
    va_end( marker );
    if ( print_flag != 0 ){
        printf( "%s", buffer+pos );
    }
    if ( fp_common != NULL ){
        fputs( buffer, fp_common );
        fflush( fp_common );
    }
    free( buffer );
    mutex_unlock( &log_mutex );
}
/*---------------------------------------------------------------------*/
/* set_print_flag() - flag=1 means printf() also performed             */
/*---------------------------------------------------------------------*/
void    set_print_flag( int flag )
{
    print_flag = flag;
}
/*---------------------------------------------------------------------*/
/* Bprintf() :               Log    File & Display                     */
/*---------------------------------------------------------------------*/
    void   Bprintf( const char * pfmt, ... )
{
        char        *buffer;
        va_list     marker;
        int         pos;
    mutex_lock( &log_mutex );
    buffer = malloc( 0x20000 );
    DshFormatDateTime( buffer, "YYYY-MM-DD HH:NN:SS.CC " );
    pos = strlen( buffer );
    va_start( marker, pfmt );
    vsprintf( buffer+strlen(buffer), pfmt, marker );
    va_end( marker );
    printf( "%s", buffer+pos );
    if ( fp_common != NULL ){
        fputs( buffer, fp_common );
        fflush( fp_common );
    }
    free( buffer );
    mutex_unlock( &log_mutex );
}
/*---------------------------------------------------------------------*/
/* Nprintf() :               Log - File (only)                         */
/*---------------------------------------------------------------------*/
    void   Nprintf( const char * pfmt, ... )
{
        char        *buffer;
        va_list     marker;
        int         pos;
    mutex_lock( &log_mutex );
    buffer = malloc( 0x20000 );
    DshFormatDateTime( buffer, "YYYY-MM-DD HH:NN:SS.CC " );
    pos = strlen( buffer );
    va_start( marker, pfmt );
    vsprintf( buffer+strlen(buffer), pfmt, marker );
    va_end( marker );
    if ( fp_common != NULL ){
        fputs( buffer, fp_common );
        fflush( fp_common );
    }
    free( buffer );
    mutex_unlock( &log_mutex );
}

