/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEngLib - GEM, GEM300 Library Program Package                         */
/*                                                                          */
/*    d_r14f11.c  - Delete Control Job        for simulation                */
/*                                                                          */
/*  Copyright (c)2007 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#include    "all.h"
/*--------------------------------------------------------------------------*/
// sim_S14F11 Delete Control Job
/*--------------------------------------------------------------------------*/
int     sim_s14f11_proc( TMSG_QUEUE_INFO *qmsg )
{
        int             ei;
        int             objack = 0;
        int             err_count = 0;
        TOBJ_INFO       tinfo;
        TOBJ_ERR_INFO   erinfo;
    Gprintf( "        S14F11 : Delete Object\n" );
    ei = DshDecodeS14F11( qmsg->smsg, &tinfo );
    if ( ei == 0 ){
        if ( ei >= 0 ){
            ;
        }else{
            objack = 1;
        }
    }else{
        objack = 1;
    }
    if ( objack == 0 ){                                     // error ack  ?
        objack = get_ack_value( X_S14F11 );
    }
    if ( objack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &erinfo, objack, err_count );
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( &erinfo, 11, "Not Deleted" ); // errcode -1
    }
    ei = DshResponseS14F12( qmsg->trid,  &tinfo , &erinfo );
    if ( ei < 0 ){
        Gprintf( "!!! S14F12 response send error\n" );
    }
    DshFreeTOBJ_INFO( &tinfo );
    return ei;
}
