/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEngLib - GEM, GEM300 Library Program Package                         */
/*                                                                          */
/*    d_r14f9.c  - Create Control Job        for simulation                 */
/*                                                                          */
/*  Copyright (c)2007 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#include    "all.h"
/*--------------------------------------------------------------------------*/
// sim_S14F9 Create Control Job
/*--------------------------------------------------------------------------*/
int     sim_s14f9_proc( TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     index = 0;
        int     objack = 0;
        int     err_count = 0;
        TOBJ_INFO     tinfo;
        TOBJ_ERR_INFO errinfo;
    Gprintf ( "        S14F9 : Create Object Request( Cj )\n" );
    ei = DshDecodeS14F9( qmsg->smsg, &tinfo );                  // S14F9decodeA擾
    if ( ei == 0 ){                                             // decode OK?
        ei = EngAllocCjInfo( tinfo.objid, &index );      // CjIDo^
        if ( ei >= 0 ){
            ei = EngSetCjInfoX( index, &tinfo );          // CJݒ
            // ɕKvȏǉB
        }else{
            objack = 1;
        }
    }else{
        objack = 1;
    }
    err_count = 0;
    if ( objack == 0 ){                                         // error ack  ?
        objack = get_ack_value( X_S14F9 );
    }
    if ( objack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &errinfo, objack, err_count );        // <=== error count( test )
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( &errinfo, 0x12, "ERR01" );    // errcode  -1 && errtext
        ei = DshPutTOBJ_ERR_INFO( &errinfo, 0x13, "ERR02" );    // errcode - 2 && errtext
        ei = DshPutTOBJ_ERR_INFO( &errinfo, 0x13, "ERR02" );    // errcode - 3 ei( -1 )ɂȂ͂
    }
    ei = DshResponseS14F10( qmsg->trid, &tinfo, &errinfo );
    if ( ei < 0 ){
        Gprintf( "    !!! S14F10 response send error\n" );
    }else{
        sim_S14F9_CJID( &tinfo );
    }
    DshFreeTOBJ_INFO( &tinfo );                                 // DecodeŎgmemoryJ

    return ei;
}

/*--------------------------------------------------------------------------*/
// sim_S14F9_CJID( )
/*--------------------------------------------------------------------------*/
void    sim_S14F9_CJID( TOBJ_INFO *info )
{
        int     ei;
    if ( get_sim_operation_busy( ) == 0 ){            // Simulation Active ?
        return;
    }
    sim_set_cjid( info->objid );                       // yes, CJIDݒ
    ei = EngSetSvVal( SV_CJID, (BYTE*)info->objid,  strlen( info->objid ) ); // ԕϐXV
    if ( ei == 0 ){
        ;
    }else{
        Gprintf( "    !!! SV_CJID set error\n" );
    }
}
