/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEngLib - GEM, GEM300 Library Program Package                         */
/*                                                                          */
/*    d_r15f13.c - Recipe                    for simulation                 */
/*                                                                          */
/*  Copyright (c)2007 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#include    "all.h"

/*--------------------------------------------------------------------------*/
// sim_S15F13 Create / Update Recipe Request
/*--------------------------------------------------------------------------*/
int     sim_s15f13_proc( TMSG_QUEUE_INFO *qmsg )
{
        int             rmack = 0;
        int             ei;
        int             err_count = 0;
        int             updt_flag = 0;
        TRCP_INFO       tinfo;
        TRCP_ERR_INFO   erinfo;
        char            rcpid[81];
    Gprintf ( "        S15F13 : Create / Update Recipe Request" );
    updt_flag = 0;
    ei = DshDecodeS15F13( qmsg->smsg, &tinfo, &updt_flag );
    if ( ei == 0 ){
        strcpy( rcpid, tinfo.rcpspec );                     // save rcpid
        sim_do_recipe_reg( &tinfo, &erinfo );         // recipeo^
    }else{
        rmack = 1;
    }
    if ( ei == 0 ){
        ;
    }
    if ( rmack == 0 ){                                      // error ack  ?
        rmack = get_ack_value( X_S15F13 );
    }
    if ( rmack != 0 ){
        err_count =1;
    }
    DshInitTOBJ_ERR_INFO( &erinfo, rmack, err_count );      // errcount = 2
    if ( err_count > 0 ){
        ei = DshPutTOBJ_ERR_INFO( ( TOBJ_ERR_INFO* )&erinfo, 3, "Update error" );
    }
    ei = DshResponseS15F14( qmsg->trid, &tinfo, &erinfo );
                     //  - erinfoallocꂽ؂DshResponseS15F14( )JĂB
                     // JȂꍇ u_s15f13.c CĂB

    if ( ei < 0 ){
        Gprintf( "    !!! S15F14 response send error\n" );
    }

    if ( rmack == 0 ){
        sim_set_ppid( rcpid );
        ei = EngSetSvVal( SV_PPID, rcpid, strlen( rcpid) );  // SV
        if ( ei == 0 ){
            ;
        }else{
            Gprintf( "    !!! S15F13 : EngSetSvVal() error - rcpspec = %s\n", rcpid );
        }
    }
    DshFreeTRCP_INFO( &tinfo );
    return ei;
}
/*--------------------------------------------------------------------------*/
// sim_do_recipe_reg( ) 
/*--------------------------------------------------------------------------*/
void    sim_do_recipe_reg( TRCP_INFO *info, TRCP_ERR_INFO *erinfo )
{
        int     index;
        int     ei;
    ei = EngAllocRcpInfo( info->rcpspec, &index );   // RcpIDo^
    Gprintf ( "    EngAllocRcpInfo( ) ei = %d\n", ei );
    if ( ei >= 0 ){
        ei = EngSetRcpInfoX( index, info );
        Gprintf ( "    EngSetRcpInfoX( ) ei = %d\n", ei );
        if ( ei == 0 ) erinfo->rmack = 0;
        else           erinfo->rmack = 1;
    }
    else erinfo->rmack = 1;
}

