/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEngLib - GEM, GEM300 Library Program Package                         */
/*                                                                          */
/*    d_r16f11.c - Process Job Creation      for simulation                 */
/*                                                                          */
/*  Copyright (c)2007 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#include    "all.h"
/*--------------------------------------------------------------------------*/
// sim_S16F11 Create Process Job Enh
/*--------------------------------------------------------------------------*/
int     sim_s16f11_proc( TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     index = 0;
        int     acka = 1;
        int     err_count = 0;
        int     result_flag = 0;
        TPRJ_INFO       info;
        TPRJ_ERR_INFO   errinfo;
    Gprintf ( "        S16F11 PRJob Create\n" );
    ei = DshDecodeS16F11( qmsg->smsg, &info );                    // S16F11-->TPRJ_INFO޺
    if ( ei == 0 ){
        ei = EngAllocPrjInfo( info.prjobid, &index );// PrjIdo^
        Gprintf( "        EngApi.EngAllocPrjInfo( ) ei = %d\n", ei );
        if ( ei >= 0 ){
            ei = EngSetPrjInfoX( index, &info );      // Prjݒ
            Gprintf( "        EngSetPrjInfoX( ) ei = %d\n", ei );
                // ɕKvȏǉB
        }
        if ( result_flag == 0 ){
            acka = 1;         // True
        }else{
            acka = 0;         // False
        }
    }else{
        acka = 0;            // False
    }
//----- S16F12  -------------------------------------------
    if ( acka == 1 ){                                       // error ack  ?
        acka = get_ack_value( X_S16F11 );
    }
    if ( acka == 0 ){                                       // falseerror
        err_count =1;
    }
    DshInitTPRJ_ERR_INFO( &errinfo, 1, acka, err_count );
    ei = DshPutTPRJ_ERR_PRJID( &errinfo, info.prjobid );
    if ( err_count > 0 ){
        ei = DshPutTPRJ_ERR_INFO( &errinfo, 0x12, "ERR01" );    // errtext
        Gprintf( "        DshPutTPRJ_ERR_INFO( ) 1 ei = %d\n", ei );
    }
    ei = DshResponseS16F12( qmsg->trid, NULL, &errinfo ); //  S16F16
                     //  - erinfoallocꂽ؂DshResponseS16F12( )JĂB
    if ( ei < 0 ){
        Gprintf( "    !!! S16F12 response send error\n" );
    }
    if ( acka == 1 ){
        ei = EngSetPrjInfo( &info );                  // prj info setting
        if ( ei == 0 ){
            sim_set_prjid( info.prjobid );
            ei = EngSetSvVal( SV_PrjID, info.prjobid, strlen( info.prjobid ) );
            if ( ei == 0 ){
                ;
            }else{
                Gprintf( "  @@!!! S16F11 EngSetSvVal() error prjobid=%s\n", info.prjobid );
            }
        }
    }
    DshFreeTPRJ_ERR_INFO( &errinfo );
    DshFreeTPRJ_INFO( &info );
    return ei;
}
