/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEngLib - GEM, GEM300 Library Program Package                         */
/*                                                                          */
/*    d_r16f15.c - Process Job Creation      for simulation                 */
/*                                                                          */
/*  Copyright (c)2007 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#include    "all.h"
/*--------------------------------------------------------------------------*/
// sim_S16F15 Create Process Job (Multiple)
/*--------------------------------------------------------------------------*/
int     sim_s16f15_proc( TMSG_QUEUE_INFO *qmsg )
{
        int     ei;
        int     i;
        int     index = 0;
        int     acka = 1;
        int     result_flag = 0;
        int     err_count = 0;
        TPRJ_ERR_INFO   errinfo;
        TPRJ_LIST       linfo;
        TPRJ_INFO       **q;
        TPRJ_INFO       *info;
    Gprintf ( "        S16F15 PRJob Multi Create\n" );
    ei = DshDecodeS16F15( qmsg->smsg, &linfo );                 // S16F15-->TPRJ_LIST޺
    if ( ei == 0 ){
        q = linfo.prj_list;
        for ( i = 0; i < linfo.prj_count; i++ ){                // ܂܂鐔PRJ̏
            info = linfo.prj_list[i];                           // TPRJ_INFO
            ei = EngAllocPrjInfo( info->prjobid, &index ); // PrjIdo^
            if ( ei >= 0 ){
                ei = EngSetPrjInfoX( index, info );       // Prjݒ
                // ɕKvȏǉB
            }
            if ( ei < 0 ){
                result_flag = 1;                                // error
                break;
            }
        }
        if ( result_flag == 0 ){
            ;       //            S16F15_PRJID( info );
            acka = 1;         // True
        }else{
            acka = 0;         // False
        }
    }else{
        acka = 0;            // False
    }
//----- S16F16  -------------------------------------------
    if ( acka == 1 ){                                           // error ack  ?
        acka = get_ack_value( X_S16F15 );
    }
    if ( acka == 0 ){                                           // falseerror
        err_count =1;
    }
    DshInitTPRJ_ERR_INFO( &errinfo, linfo.prj_count, acka, err_count );
    for ( i=0; i < linfo.prj_count; i++ ){
        ei = DshPutTPRJ_ERR_PRJID( &errinfo, linfo.prj_list[i]->prjobid );
    }
    if ( err_count > 0 ){
        ei = DshPutTPRJ_ERR_INFO( &errinfo, 0x12, "ERR01" );// errtext
        Gprintf( "   DshPutTPRJ_ERR_INFO( ) 1 ei = %d\n", ei );
    }
    ei = DshResponseS16F16( qmsg->trid, NULL, &errinfo );  //  S16F16
                     //  - erinfoallocꂽ؂DshResponseS16F16( )JĂB
    if ( ei < 0 ){
        Gprintf( "!!! S16F16 response send error\n" );
    }
    if ( acka == 1 ){
        sim_S16F15_PRJID( linfo.prj_list[0] );            // 擪܂B
    }
    DshFreeTPRJ_LIST( &linfo );
    return ei;
}

/*--------------------------------------------------------------------------*/
// S16F15_PRJID( )
/*--------------------------------------------------------------------------*/
void    sim_S16F15_PRJID( TPRJ_INFO *info )
{
        int     ei;
    ei = EngSetPrjInfo( info );                       // prj info setting
    if ( ei == 0 ){
        sim_set_prjid( info->prjobid );
        ei = EngSetSvVal( SV_PrjID, info->prjobid, strlen( info->prjobid ) );
        if ( ei == 0 ){
            ;
        }else{
            Gprintf( "  !!! S16F15 EngSetSvVal() error prjobid=%s\n", info->prjobid );
        }
    }
}
