/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DshEngLib - GEM, GEM300 Library Program Package                         */
/*                                                                          */
/*    d_r7f23.c  - Formatted Process Program for simulation                 */
/*                                                                          */
/*  Copyright (c)2007 by Data Map Corp.                                     */
/*                                                                          */
/*--------------------------------------------------------------------------*/
#include    "all.h"

/*--------------------------------------------------------------------------*/
// sim_S7F23 Formatted Process Program
/*--------------------------------------------------------------------------*/
int     sim_s7f23_proc( TMSG_QUEUE_INFO *qmsg )
{
        int     ackc7 = 0;
        int     ei;
        int     index;
        TFPP_INFO   tinfo;
    Gprintf( "        S7F23 : Formatted Process Program Send \n" );
    ei = DshDecodeS7F23( qmsg->smsg, &tinfo );
    if ( ei == 0 ){
        index = 0;
        ei = EngAllocFppInfo( tinfo.ppid, &index );   // IDo^ ===> Eng3
        if ( ei >= 0 ){
            ei = EngSetFppInfoX( index, &tinfo );     // ݒ ===> Eng3
        }
    }else{
        ackc7 = 1;
    }
    if ( ackc7 == 0 ){                                      // error ack  ?
        ackc7 = get_ack_value( X_S7F23 );
    }
    ei = DshResponseS7F24( qmsg->trid, NULL, ackc7 ); // S7F24 !! tinfoJȂB
    if ( ei < 0 ){
        Gprintf( "!!! S7F24 response send error\n" );
    }
    if ( ackc7 == 0 ){
        sim_set_ppid( tinfo.ppid );
        ei = EngSetSvVal( SV_PPID, tinfo.ppid, strlen( tinfo.ppid ) );  // SV
        if ( ei == 0 ){
            ;
        }else{
            Gprintf( "  !!! S7F23 : EngSetSvVal() error - ppid = %s\n", tinfo.ppid );
        }
    }
    DshFreeTFPP_INFO( &tinfo );
    return ei;
}


