/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                              */
/*                                                              */
/*              file name : g_rpope.c                           */
/*                                                              */
/*  Produced by Data Map Covoration in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Covoration.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     rp_list( void );
int     rp_ginfo( void );

/*-----------------------------------------------------------*/
static  char    cbuf[KEY_BUFF_SIZE];

/*-----------------------------------------------------------*/
static  char    *rp_menu[] = {                          // menu
        "  q       : quit",
        "  h       : help",
        "  list    : get list",
        "  ginfo   : get infomation",
        NULL
        };
/*-----------------------------------------------------------*/
static  TEST_CMD_TAB    rp_cmd_tab[] = {                // cmd name & function
        { "Q",        0 },
        { "H",        0 },
        { "LIST",     rp_list },
        { "GINFO",    rp_ginfo },
        { NULL,       0 }
        };
/*-----------------------------------------------------------*/
// p_RP() - Report
/*-----------------------------------------------------------*/
int     p_RP( void )
{
        int     i;
    Gprintf( "*----- RP operation --------*\n" );
    test_menu( rp_menu );
    while( 1 ){
        input_line( "RP> : ", cbuf );
        if ( strlen(cbuf) == 0 ) continue;
        i = test_cmd_go( cbuf, rp_cmd_tab );
        if ( i == 0 ) break;                    // Quit
        if ( i == 1 ){                          // Help
            Gprintf( "*----- RP operation --------*" );
            test_menu( rp_menu );
            continue;
        }
    }
    return 1000;
}

/*-----------------------------------------------------------*/
// rp_list() - display all RP id and name list
/*-----------------------------------------------------------*/
int     rp_list( void )
{
        int     ei;
        int     i;
        TBIN_DLIST  *lptr;
    ei = EngGetRpList( &lptr );                      // *lptr̓e TBIN_DLIS
    if ( ei == 0 ){
        Gprintf( "  # of id = %d\n", lptr->count );
        if ( lptr->count > 0 ){
            Gprintf( "----- RP id and name list -----------\n" );
            for ( i=0; i < lptr->count; i++ ){
                Gprintf( " %3d. id:%6d  name: %s\n", i+1, lptr->id_list[i], lptr->name_list[i] );
            }
        }
        DshFreeTBIN_DLIST( lptr );                          // release TBIN_DLIST memory
    }else{
        Gprintf( " !! EngGetRplist() error\n ");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// rp_ginfo() - get all info and display
/*-----------------------------------------------------------*/
int     rp_ginfo( void )
{
        TRPID   id;
        int     ei;
        int     i;
        TRP_INFO info;
    while( 1 ){
        input_line( "RP> GINFO RPID (0=end) : ", cbuf );                                 // input RPID
        id = atoi( cbuf );
        Gprintf( "   RPID = %d\n", id );
        if ( id == 0 ) break;
        ei = EngGetRpInfo( id, &info );               // get information
        if ( ei < 0 ){
            Gprintf( " !! RPID %d inval;id\n" );
            continue;
        }
        Gprintf("        name    = %s\n", info.name );
        Gprintf("        # of vid = %d\n", info.v_count );
        for ( i=0; i < info.v_count; i++ ){
            Gprintf("          %2d. vid=%6d  %s\n", i+1, info.vid[i], info.vname[i] );
        }
        Gprintf("\n");
    }
    return 0;
}

/*----- End Of File -----------------------------------------*/
