/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_selmsg.c                          */
/*                                                              */
/*  Produced by Data Map Covoration in 2009.                    */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Covoration.                                        */
/*                                                              */
/****************************************************************/

#include    "all.h"

static  char    cbuf[KEY_BUFF_SIZE];

static  char *rcp_menu_list[] = {
        "----- recipe message selection ----",
        "  0       : S7F3",
        "  1       : S7F23",
        "  2       : S15F13",
        "  Q       : Quit",
        NULL
        };
static  char *rcp_msg_name[] = {
        "S7F3", "S7F23", "S15F13"
        };

/*-----------------------------------------------------------*/
// p_rcpmsg() - select recipe message S7F3/S7F23/S15F13
/*-----------------------------------------------------------*/
int     p_rcpmsg( void )
{
    Gprintf( "    current message selected = %s\n", rcp_msg_name[s_get_rcp_msg()] );

    test_menu( rcp_menu_list );
    while( 1 ){
        input_line( "RCP MSG> : ", cbuf );
        dsh_trim( cbuf );
        if ( strlen(cbuf) == 0 ) continue;

        if ( cbuf[0] == 'Q' || cbuf[0] == 'q' ) break;
        if ( cbuf[0] == '0' ){ s_set_rcp_msg( 0 ); break; }    // S7F3
        if ( cbuf[0] == '1' ){ s_set_rcp_msg( 1 ); break; }    // S7F23
        if ( cbuf[0] == '2' ){ s_set_rcp_msg( 2 ); break; }    // S15F13
    }
    Gprintf( "    new message selected = %s\n", rcp_msg_name[s_get_rcp_msg()] );
    s_save_fmt_msg();                                           // save fmt_msg hist file
    return 0;
}

static  char *prj_menu_list[] = {
        "----- process job message selection -----",
        "  0       : S16F11 (single)",
        "  1       : S16F15 (multiple)",
        "  Q       : Quit",
        NULL
        };

static  char *prj_msg_name[] = {
        "S16F11", "S16F15"
        };

/*-----------------------------------------------------------*/
// p_prjmsg() - select prj message S16F11/S16F15
/*-----------------------------------------------------------*/
int     p_prjmsg( void )
{
    Gprintf( "    current message selected = %s\n", prj_msg_name[s_get_prj_msg()] );

    test_menu( prj_menu_list );
    while( 1 ){
        input_line( "PRJ MSG> : ", cbuf );
        dsh_trim( cbuf );
        if ( strlen(cbuf) == 0 ) continue;

        if ( cbuf[0] == 'Q' || cbuf[0] == 'q' ) break;
        if ( cbuf[0] == '0' ){ s_set_prj_msg( 0 ); break; }    // S16F11
        if ( cbuf[0] == '1' ){ s_set_prj_msg( 1 ); break; }    // S16F15
    }
    Gprintf( "    new message selected = %s\n", prj_msg_name[s_get_prj_msg()] );
    s_save_fmt_msg();                                           // save fmt_msg hist file
    return 0;
}

/*-----------------------------------------------------------*/
// s_disp_format_msg()
/*-----------------------------------------------------------*/
void    s_disp_format_msg( void )
{
        int     mx;
    Gprintf( "\n" );
    Gprintf( "**===========================================================**\n" );
    if ( s_get_data_format() == 16 ){
        Gprintf( "**    CEID, RPTID, VID format = U2\n" );
    }else{
        Gprintf( "**    CEID, RPTID, VID format = U4\n" );
    }
    mx = s_get_rcp_msg();
    if ( mx == 0 ){
        Gprintf( "**    Recipe, PP message      = S7F3\n" );
    }else if ( mx == 1 ){
        Gprintf( "**    Recipe, PP message      = S7F23\n" );
    }else{
        Gprintf( "**    Recipe, PP message      = S15F13\n" );
    }
    mx = s_get_prj_msg();
    if ( mx == 0 ){
        Gprintf( "**    Process Job message     = S16F11\n" );
    }else{
        Gprintf( "**    Process Job message     = S16F15\n" );
    }
    Gprintf( "**===========================================================**\n" );
}
