/****************************************************************/
/*                                                              */
/*    << DSHENG4 Test Program >>                                */
/*                                                              */
/*              file name : g_svope.c                           */
/*                                                              */
/*  Produced by Data Map Corporation in 2009.                   */
/*  All rights reserved. No part of this program may be copied  */
/*  in anyway, or by any means, without permission from         */
/*  Data Map Corporation.                                       */
/*                                                              */
/****************************************************************/

#include    "all.h"

int     sv_list( void );
int     sv_ginfo( void );
int     sv_gval( void );
int     sv_sval( void );
/*-----------------------------------------------------------*/
static  char    cbuf[KEY_BUFF_SIZE];
/*-----------------------------------------------------------*/
static  char    *sv_menu[] = {                          // menu
        "  q       : quit",
        "  h       : help",
        "  list    : get list",
        "  ginfo   : get infomation",
        "  gval    : get value",
        "  sval    : set value",
        NULL
        };
/*-----------------------------------------------------------*/
static  TEST_CMD_TAB    sv_cmd_tab[] = {                // cmd name & function
        { "Q",        0 },
        { "H",        0 },
        { "LIST",     sv_list },
        { "GINFO",    sv_ginfo },
        { "GVAL",     sv_gval },
        { "SVAL",     sv_sval },
        { NULL,       0 }
        };
/*-----------------------------------------------------------*/
// p_sv() - Status Variable
/*-----------------------------------------------------------*/
int     p_SV( void )
{
        int     i;
    Gprintf( "*----- SV operation --------*\n" );
    test_menu( sv_menu );
    while( 1 ){
        input_line( "SV> : ", cbuf );
        if ( strlen(cbuf) == 0 ) continue;
        i = test_cmd_go( cbuf, sv_cmd_tab );
        if ( i == 0 ) break;                    // Quit
        if ( i == 1 ){                          // Help
            Gprintf( "*----- SV operation --------*" );
            test_menu( sv_menu );
            continue;
        }
    }
    return 1000;
}

/*-----------------------------------------------------------*/
// sv_list() - display all SV id and name list
/*-----------------------------------------------------------*/
int     sv_list( void )
{
        int     ei;
        int     i;
        TBIN_DLIST  *lptr;
    ei = EngGetSvList( &lptr );                      // *lptr̓e TBIN_DLIS
    if ( ei == 0 ){
        Gprintf( "  # of id = %d\n", lptr->count );
        if ( lptr->count > 0 ){
            Gprintf( "----- SV id and name list -----------\n" );
            for ( i=0; i < lptr->count; i++ ){
                Gprintf( " %3d. id:%6d  name: %s\n", i+1, lptr->id_list[i], lptr->name_list[i] );
            }
        }
        DshFreeTBIN_DLIST( lptr );                          // release TBIN_DLIST memory
    }else{
        Gprintf( " !! EngGetSvlist() error\n ");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// sv_ginfo() - get all infoand display
/*-----------------------------------------------------------*/
int     sv_ginfo( void )
{
        TSVID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
        char    str[1024];
        int     n;
    while( 1 ){
        input_line( "SV> SVID (0=end) : ", cbuf );                                 // input SVID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   SVID = %d\n", id );
        ei = EngGetSvFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! SVID %d inval;id\n" );
            continue;
        }
        ei = EngGetSvArraySize( id, &asize );        // get array size
        ei = EngGetSvName( id, (char*)ss, &n );      // get name
        Gprintf("        name    = %s\n", ss );
        Gprintf("        fmt     = %s (0x%x)\n", dsh_get_item_name(fmt), fmt );
        Gprintf("        asize   = %d\n", asize );
        ei = EngGetSvVal( id, ss, &asize );           // value
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        value   = %s\n", str );

        ei = EngGetSvNominal( id, ss, &asize );      // nominal
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        nominal = %s\n", str );

        ei = EngGetSvMin( id, ss, &asize );          // min
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        min     = %s\n", str );

        ei = EngGetSvMax( id, ss, &asize );          // max
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        max     = %s\n", str );

        ei = EngGetSvUnits( id, (char*)ss, &asize ); // units
        Gprintf("        units   = %s", ss );
        Gprintf("\n");
    }
    return 0;
}
/*-----------------------------------------------------------*/
// sv_gval() - get SV value and display
/*-----------------------------------------------------------*/
int     sv_gval( void )
{
        TSVID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
        char    str[1024];
    while( 1 ){
        input_line( "SV> GVAL SVID (0=end) : ", cbuf );                                 // input SVID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   SVID = %d\n", id );
        ei = EngGetSvFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! SVID %d inval;id\n" );
            continue;
        }
        ei = EngGetSvArraySize( id, &asize );        // get array size
        ei = EngGetSvName( id, (char*)ss, &asize );  // get value
        ei = EngGetSvVal( id, ss, &asize );
        dsh_sprint_vdval( str, fmt, ss );
        Gprintf("        value   = %s\n", str );
        Gprintf("\n");
    }
    return 0;
}

/*-----------------------------------------------------------*/
// sv_sval() - set SV value
/*-----------------------------------------------------------*/
int     sv_sval( void )
{
        TSVID   id;
        int     ei, fmt, asize;
        BYTE    ss[1024];
    while( 1 ){
        input_line( "SV> SVAL SVID (0=end) : ", cbuf );                                 // input SVID
        id = atoi( cbuf );
        if ( id == 0 ) break;
        Gprintf( "   SVID = %d\n", id );
        ei = EngGetSvFormat( id, &fmt );              // get format
        if ( ei < 0 ){
            Gprintf( " !! SVID %d inval;id\n" );
            continue;
        }
        ei = EngGetSvArraySize( id, &asize );        // get array size
        Gprintf( "        fmt     = %s (0x%x)\n", dsh_get_item_name(fmt), fmt );
        input_line( "SV> value = ",cbuf );
        memset( ss, 0, sizeof(ss) );
        set_data_val( fmt, cbuf, ss );
        ei = EngSetSvVal( id, (void*)ss, asize );    // set value
        Gprintf( "     result = %d\n", ei );
        Gprintf("\n");
    }
    return 0;
}

/*----- End Of File -----------------------------------------*/
